function [rmse,rms] = nanrms(dife,varargin)
%NANRMS	Root mean square.
%
% For vectors, NANRMS(x) returns the root mean square.
% For matrices, NANRMS(X) is a row vector containing the
% root mean square of each column. All NaN valuez
% are neglected.
%
% NANRMS(X,DIM) takes the rms along the dimension DIM of X. 
%Dwonloaded from Matlab, modified by Julius Jara
%See also: RMS, nanMEAN, nanMAX, nanMIN, STD

% $Id$
% $Date$
% $Author$
% $Revision$
% $HeadURL$
% $Keywords$

if isempty(dife) 
%if isempty(x) 
	%y = NaN;
    rmse = NaN;
	return
end

%    rmse = sqrt(nanmean(dife.^2,varargin{:}))/numel(dife);
%   rmse=sqrt(sum(dife).^2)/numel(dife);
    rms= sqrt (nanmean (dife .^2) );
    rmse=rms/numel(dife);