function varargout = TerraceM_LEM(varargin)
% TERRACEM_LEM MATLAB code for TerraceM_LEM.fig
%      TERRACEM_LEM, by itself, creates a new TERRACEM_LEM or raises the existing
%      singleton*.
%
%      H = TERRACEM_LEM returns the handle to a new TERRACEM_LEM or the handle to
%      the existing singleton*.
%
%      TERRACEM_LEM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TERRACEM_LEM.M with the given input arguments.
%
%      TERRACEM_LEM('Property','Value',...) creates a new TERRACEM_LEM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TerraceM_LEM_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TerraceM_LEM_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TerraceM_LEM

% Last Modified by GUIDE v2.5 11-Jun-2019 17:15:25

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TerraceM_LEM_OpeningFcn, ...
                   'gui_OutputFcn',  @TerraceM_LEM_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before TerraceM_LEM is made visible.
function TerraceM_LEM_OpeningFcn(hObject, eventdata, handles, varargin)%,global global_struct3 global_struct2 global_struct global_struct4
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TerraceM_LEM (see VARARGIN)

% Choose default command line output for TerraceM_LEM
handles.output = hObject;

%default values for handles
handles.snap=20;
handles.smuth=40;
handles.sill=150;
handles.edit32=150;
handles.dt=100;
handles.dt2=100;
handles.trunca=0;
handles.mint=0;
handles.mint2=0;
handles.maxt=500;
handles.maxt2=500;
handles.dx=5;
handles.dx2=5;
handles.slope=10;
handles.slp2=10;
handles.wave=5;
handles.wave2=5;
handles.Ur=1.4;
handles.Er=0.3;
handles.savepdf=0;
handles.age=123;
handles.age2=123;
handles.up=9;
handles.up2=9;
handles.down=4;
handles.down2=4;
handles.diff=0.02;
handles.diff2=0;
handles.vx=0;
handles.checkbox9=0;
handles.checkbox11=0;
handles.dispshore=0;
handles.disptime=0;
handles.ratio=100; 
handles.cycle=15000;
handles.type=1;
handles.Er2=0.05;
handles.sill2=150;
handles.iterations=100;
handles.chains=3;
handles.element=1; 
handles.trunca2=0;
handles.savef=0;
handles.levsel2=1;
handles.ovr1=0;
handles.minimize=1; 
handles.plotite=0;

%set sea level poup ups
cd ('sealevel')
name_sl = dir(sprintf('%s/*.mat',pwd));
nsl=numel(name_sl);
slt=nsl;
k=1;

% sea level names
for slt=1:nsl 
    sl_arch{k}=name_sl(slt,1).name;
    k=k+1;
end  

handles.curves=pwd;
set(handles.text100,'String','Info:   Welcome to TerraceM LEM, for quick modelling select a sea-level curve and press "Run LEM", if you want to save your results or model a mapped marine terrace profile set the Inputs files and Output directories in the upper left corner'); 
set(handles.popupmenu1,'String',sl_arch); 
set(handles.popupmenu5,'String',sl_arch); 
set(handles.uipanel9,'Visible','Off')
set(handles.uipanel10,'Visible','On')
set(handles.slpp2,'Visible','On')
set(handles.text15,'Visible','On')
set(handles.edit49,'Visible','On')
set(handles.text67,'Visible','On')
set(handles.text103,'Visible','Off')    
set(handles.edit67,'Visible','Off')  
set(handles.uitable1,'Visible','Off');
cd('..')

%set poup ups
af=(2:4);
a=num2cell(af); %transform number to cell
set(handles.cambios,'String',a) %set the string inputs for popu

handles.terracemdir=pwd;
addpath(handles.terracemdir)
addpath(handles.curves)

%load logos
lgt=handles.axes4;
axes (lgt);
[cdata,map] = imread('logo.tif'); 
imshow(cdata,map)

% Update handles structure
guidata(hObject, handles);



% --- Outputs from this function are returned to the command line.
function varargout = TerraceM_LEM_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
set(handles.text100,'String','Info:   Display options in the lower left corner allow controlling the number of video frames and the smooth of the sea-level curve to remove terrace artifacts. Modellimg parameters can be adjusted within the "Preliminary modeling interface". Models can run outside the adjusted plot boundaries resulting in error, (e.g. the slope is too low and the E0 is too high). The X axis adjust (Vx) can be used to extend the x axis and correct errors'); 

here=pwd;
axes(handles.axes2)
cla
colorbar('off')

try
sl=handles.sealevel;
catch
set(handles.text100,'String','Info:  Please select a sea-level curve before run a model')
return
end

%remove rise after LGM
trunca=handles.trunca;
if trunca==1
    sl.ans(sl.ans(:,1)<20000,2)=120;    
end

%select table or single input
if handles.varurate==1
load('urate.mat')
param.uplift_rate=U.urate(:,1);
else
param.uplift_rate=handles.Ur;
end

param.tmin=handles.mint;
param.tmax=handles.maxt;
param.sill=handles.sill;
param.dt=handles.dt;
param.dx=handles.dx;


param.initial_erosion=handles.Er;
param.slope_shelf=handles.slope;
param.h1=handles.axes2;
param.h2=handles.axes3;
param.wave_height=handles.wave;
param.snap=handles.snap;%number of frames
param.smth=handles.smuth;
param.cliff_diffusion=handles.diff;
param.vxx=handles.vx;
param.video=1;
param.cumula=get(handles.radiobutton2,'Value');

param2=param;
param2.cliff_diffusion=0;
param2.video=0;
%try
%Anderson function
%[LEM]=TerraceM_anderson(sl,maxt,mint,dt,dx,sill,slp,Ur,Er,diff,wave,vx,smth,video,h2,h3,snap,cumula);
[LEM]=TerraceM_anderson(sl,param);
%second run without difusion for shoreline angle and chornologic model
%[LEM2]=TerraceM_anderson(sl,maxt,mint,dt,dx,sill,slp,Ur,Er,0,wave,vx,smth,0);
[LEM2]=TerraceM_anderson(sl,param2);

handles.LEM=LEM;
handles.LEM2=LEM2;

handles.x=LEM.x_mod;
handles.z=LEM.z_mod;
handles.ero=LEM.ero_mod;
%sh capture
handles.x2=LEM2.x_mod;
handles.z2=LEM2.z_mod;
handles.xsea1=LEM2.xsea1;
handles.tsea1=LEM2.sea_rec;
handles.ysea1=LEM2.ysea1;

%SAVE MODELS

if isfield(handles,'statpath')==1
cd(handles.statpath)
%check for directory
try
cd('models')
catch
    mkdir('models')
    cd('models')
end

file2=sprintf('Models_%s',handles.sea_name);
%save. mat output
if exist(file2,'file')==0    
i=1;
MOD(i).Er=handles.Er;
MOD(i).slope=handles.slope;
MOD(i).mod=[handles.x',handles.z'];
MOD(i).modshcap=[handles.x2',handles.z2'];
MOD(i).timeshcap=[handles.xsea1',handles.ysea1',handles.tsea1'];
MOD(i).model=[handles.x',handles.z'];
MOD(i).ero=handles.ero;

%special Ur
if handles.varurate==1
MOD(i).Ur=param.uplift_rate;
else
MOD(i).Ur=handles.Ur;
end


MODEL=MOD;
save(file2,'MODEL')  
else
load(file2)
i=numel(MODEL)+1;
MOD=MODEL;

MOD(i).Er=handles.Er;
MOD(i).slope=handles.slope;
%MOD(i).mod=[handles.x',handles.z'];
MOD(i).modshcap=[handles.x2',handles.z2'];
MOD(i).timeshcap=[handles.xsea1',handles.ysea1',handles.tsea1'];
MOD(i).model=[handles.x',handles.z'];
MOD(i).ero=handles.ero;

if handles.varurate==1
MOD(i).Ur=param.uplift_rate;
else
MOD(i).Ur=handles.Ur;
end


MODEL=MOD;
save(file2,'MODEL')    
end  


if handles.dispshore==1
    
    if handles.disptime==1
    plote=1;
    else
    plote=0;
    end
    
    axes(handles.axes2)
    hold on
    
    [counter,mini]=TerraceM_recoccupation(handles.xsea1,handles.ysea1,handles.tsea1,plote);
    
    ratio=handles.ratio; 
    cycle=handles.cycle;%search ratio remove double shoreline angles
    
    [shoreline]=TerraceM_autoshoreline(mini,handles.x2',handles.z2',ratio,cycle);  
    ax2 = gca;
 
    t=round(shoreline(:,3),0)/1e3;%isolate time
    b = num2str(t); 
    c = cellstr(b);%convert to format for labels
    dx = (max(handles.x2)-min(handles.x2))/20; dy = 0; % avoid overlap
    
    if param.cumula==1
    plot(shoreline(:,1)/1e3,shoreline(:,2),'or','MarkerFaceColor','k');
    text((shoreline(:,1)-3*dx)/1e3,shoreline(:,2), c);    
    else
    plot(shoreline(:,1)/1e3,shoreline(:,2),'ok','MarkerFaceColor','k');
    text((shoreline(:,1)+dx)/1e3,shoreline(:,2), c);
    end
    
    
    if plote==1
    %    set(ax2,'SortMethod','childorder' ); %fix order plot
    end

    
if handles.savef==1
cd('..')
f1=figure('visible','off');
hold on
box on

newprof(:,1)=handles.xsea1/1e3;
newprof(:,2)=handles.ysea1;
newprof(:,3)=mini(:,2);

newprof=sortrows(newprof,1);
%plot(newprof(:,1), newprof(:,2),'-k')

plot(handles.x'/1e3,handles.z','-k')


%h = color_line3(handles.xsea1/1e3, handles.ysea1, mini(:,2), mini(:,2));%trick
h = color_line3(newprof(:,1), newprof(:,2), newprof(:,3), newprof(:,3));%trick

set(h,'linewidth',3,'linestyle','-');
colormap parula; 
cl=colorbar('westoutside');
title('Time along profile')
xlabel('Distance along profile (km)')
ylabel('Elevation (m)')

cl.Label.String = 'time (yr BP)';
cpos = cl.Position;
cpos(1) = 1.4*cpos(1);
cpos(2) = 3.5*cpos(2);
cpos(3) = 0.5*cpos(3);
cpos(4) = 0.25*cpos(4);
cl.Position = cpos;


plot(shoreline(:,1)/1e3,shoreline(:,2),'ok','MarkerFaceColor','k');
text((shoreline(:,1)+dx)/1e3,shoreline(:,2), c);
plot(newprof(:,1), newprof(:,2),'-k')

f1.Renderer='Painters';
%save  
rect=[2,5,17,12]; %[xmin ymin width height]
set(gcf,'PaperType','A4');
set(gcf,'PaperUnits','centimeters'); 
set(gcf,'Paperposition',rect);
fout4 = ('LEM_time.pdf');
saveas(gcf, fout4, 'pdf')
%close(f1)


f2=figure('visible','off');
hold on, box on
plot(handles.xsea1,handles.tsea1,'-c')
mini2=sortrows(mini,2);
%mini2=mini;
plot(mini2(:,1),mini2(:,2),'-k')
plot(shoreline(:,1),shoreline(:,3),'or');
plot(mini(:,1),mini(:,2),'.b')
title('Coastline position through time')

legend('Relative sea-level curve','Coastline position','Shoreline angle','Erosion period','Location','northwest')

xlabel('Distance along profile (m)')
ylabel('Time (yr)')
xlim([min(handles.xsea1)-0.3e4 max(handles.xsea1)+0.3e4])

f2.Renderer='Painters';
%save  
rect=[2,5,17,12]; %[xmin ymin width height]
set(gcf,'PaperType','A4');
set(gcf,'PaperUnits','centimeters'); 
set(gcf,'Paperposition',rect);
fout5 = ('LEM_coastline.pdf');
saveas(gcf, fout5, 'pdf')
 

f3=figure('visible','off');
clear cl

newprof2(:,1)=handles.xsea1/1e3;
newprof2(:,2)=handles.ysea1;
newprof2(:,3)=counter;
newprof2=sortrows(newprof2,1);

plot(handles.x'/1e3,handles.z','-k')

h = color_line3(newprof2(:,1), newprof2(:,2), newprof2(:,3), newprof2(:,3));%trick

set(h,'linewidth',3,'linestyle','-');
colormap parula; cl=colorbar('westoutside');
cl.Label.String = 'count';
cpos = cl.Position;
cpos(1) = 1.4*cpos(1);
cpos(2) = 3.5*cpos(2);
cpos(3) = 0.5*cpos(3);
cpos(4) = 0.25*cpos(4);
cl.Position = cpos;

title('Terrace reoccupation')
xlabel('Distance along profile (km)')
ylabel('Elevation (m)')

f3.Renderer='Painters';

%save  
rect=[2,5,17,12]; %[xmin ymin width height]
set(gcf,'PaperType','A4');
set(gcf,'PaperUnits','centimeters'); 
set(gcf,'Paperposition',rect);
fout6 = ('LEM_reoccupation.pdf');
saveas(gcf, fout6, 'pdf')


if cumula==1
f4=figure('visible','off');
ax=axes;
axito= get(handles.axes2,'children');
box on; hold on;

s=copyobj(axito,ax);

hold on
 plot(shoreline(:,1)/1e3,shoreline(:,2),'or','MarkerFaceColor','k');
    text((shoreline(:,1)-2.5*dx)/1e3,shoreline(:,2), c);    
title('Cummulative LEM')
xlabel('Distance along profile (km)')
ylabel('Elevation (m)')
%xlim([min(handles.xsea1)/1e3 max(handles.xsea1)/1e3])

f4.Renderer='Painters';
%save  
rect=[2,5,17,12]; %[xmin ymin width height]
set(gcf,'PaperType','A4');
set(gcf,'PaperUnits','centimeters'); 
set(gcf,'Paperposition',rect);
fout7 = ('LEM_cummulative.pdf');
saveas(gcf, fout7, 'pdf')

end

else

%set(handles.text100,'String','Info:  Output directory has not yet been configured, an output directory must be configured to run time model')
    
    
end
end

else
    set(handles.text100,'String','Info:  Output directory has not been configured, select an output directory if you want to save the results by pressing the button on the upper left corner')
end

cd(here)

guidata(hObject, handles);

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);

%PARAMETERS
%modelling parameters
type=handles.type;
Profile_number=handles.profsel;
trunc=handles.trunca2;

%model parameters
param.sill=handles.sill2;
param.tmin=handles.mint2;
param.tmax=handles.maxt2;
param.dt=handles.dt2;
param.dx=handles.dx2;
param.initial_erosion=handles.Er2;
param.cliff_diffusion=handles.diff2;
param.slope_shelf=handles.slp2;
param.wave_height=handles.wave2;
param.smth=handles.smuth;
param.vxx=handles.vx;
param.video=0;


%load sea level curve and adjust
try
sl=handles.sealevel;
catch
set(handles.text100,'String','Info:  Please select a sea-level curve before run a model')
return
end

%remove sea level rise after LGM
if trunc==1
    sl.ans(sl.ans(:,1)<20000,2)=120;    
end

%%%^^^^^^^^^^^^^^^^^^^^^%%%%
%%%% random optimization %%%%
if type==1 %%%%%%%%%%%random optimization%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
g=handles.iterations;

try
Ur=handles.Ur_random;
catch
set(handles.text100,'string','Info:  Uplift patterns have not been generated yet');
    
end

%wait bar and time of processing
tt=(5.5*g)/60;%5.5 is the mean elapsed time of LEM run in seconds
fprintf('Estimated time %.2f minutes',tt);
wb=waitbar(0,'Wait, runing models'); 
set(wb,'windowstyle','modal');

for i=1:g
clear LEMN
param.uplift_rate=Ur(i).Ur;   

if param.cliff_diffusion==0
%[LEMN]=TerraceM_anderson(sl,maxt,mint,dt,dx,sill,slp,uplift_rate,Er,diff,wave,vx,smth,video);
[LEMN]=TerraceM_anderson(sl,param);
LEMS(i).LEM=LEMN;
LEMS(i).LEM2=LEMN;

else
[LEMN]=TerraceM_anderson(sl,param);  

param2=param;
param2.cliff_diffusion=0;

[LEMN2]=TerraceM_anderson(sl,param2);  
LEMS(i).LEM=LEMN;
LEMS(i).LEM2=LEMN2;
end

wb=waitbar(i/g);
end

close(wb)

cd(handles.statpath)
file_lem=('LEM_RadnomOp.mat');
save(file_lem, 'LEMS','Ur');
cd(handles.terracemdir)


axes(handles.axes2)
cla reset

for j=1:numel(LEMS)

hold on    
plot(LEMS(j).LEM.x_mod/1e3,LEMS(j).LEM.z_mod,'-');    
    
end
xlabel('Distance (km)')
ylabel('Elevation (m)')

%%%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^%%%%
%%%% minimization using defined ranges %%%%
else %%%%%%%%%  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%

%ranges
%Ur
minUr=handles.minup;
dur=handles.dup;
maxUr=handles.maxup;
UrM=minUr:dur:maxUr;
%Er
minEr=handles.mine;
der=handles.de;
maxEr=handles.maxe;
ErM=minEr:der:maxEr;
%total models
g=numel(UrM)*numel(ErM);

%wait bar and time of processing
tt=(5.5*g)/60;%5.5 is the mean elapsed time of LEM run in seconds
fprintf('Estimated time %.2f minutes',tt);
wb=waitbar(0,'Wait, runing models'); 
set(wb,'windowstyle','modal');

param3=param;
%%%%%%%% the loop
for i=1:numel(UrM)
    for j=1:numel(ErM)
clear LEMN

param3.uplift_rate=UrM(i);
param3.initial_erosion=ErM(j);

%[LEMN]=TerraceM_anderson(sl,maxt,mint,dt,dx,sill,slp,UrM(i),ErM(j),diff,wave,vx,smth,video);    
[LEMN]=TerraceM_anderson(sl,param3);    

LEM(i)=LEMN;    
    end
wb=waitbar((i)/numel(UrM));   
end

close (wb)
%%%%%%%%%%%%

cd(handles.statpath)
file_lem=('LEM_RangeM.mat');
save(file_lem,'LEM');
cd(handles.terracemdir)

axes(handles.axes3)
cla

%plot all
axes(handles.axes2)
cla

for j=1:numel(LEM)
hold on    
plot(LEM(j).x_mod/1e3,LEM(j).z_mod,'-');       
end
xlabel('Distance (km)')
ylabel('Elevation (m)')
end






guidata(hObject, handles);

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%call handles
handles = guidata(hObject);
set(handles.text100,'string','Info:  To test the fit between model and profile you must run a model in the "Preliminary modelling interface" and then select a profile to fit. Select first the number of profile to fit, then the shoreline angle to tie the profile and assign an age to the tie-point shoreline angle. FInally the anlysis extent adjust the size of your analysis in km upwards and downwards from the shoreline angle ');
%station=handles.statsel;
profile=handles.profsel;
level=handles.levsel;
ratio=handles.ratio; 
cycle=handles.cycle;
%sealevel=handles.sealevel;
try
tsea1=handles.tsea1;%register of positions of sea-level through the model
xsea1=handles.xsea1;%position of shore through the model
ysea1=handles.ysea1;
catch
 set(handles.text100,'string','Info:  Run first a model in the "Preliminary modeling interface"');   
end


age=handles.age;%shoreline angle age
x=handles.x;%x final model
z=handles.z;%z final model

up=handles.up;
down=handles.down;

savepdf=handles.savepdf; %save results

%load shoreline angles identical to selected
sw_x=handles.swath(profile).x;
sw_zmin=handles.swath(profile).z_min;
sw_zmed=handles.swath(profile).z_mean;
sw_zmax=handles.swath(profile).z_max;
sw=[sw_x,sw_zmin,sw_zmed,sw_zmax];

sh(:,1)=handles.SHTAB(profile).level(level).DISTANCE_PROFILE;
sh(:,2)=handles.SHTAB(profile).level(level).ELEVATION;

%SHH(:,1)=handles.SHTAB(profile).level(1:end).DISTANCE_PROFILE;
%SHH(:,2)=handles.SHTAB(profile).level(1:end).ELEVATION;

%call function fitting profile function
mode=1;%plot mode selected
%ratio=150;
%cycle=15000;

%fit
[Results,MOD]=TerraceM_rms_fit(handles.LEM,handles.LEM2,profile,sw,sh,age,ratio,cycle,up,down,mode,savepdf);






guidata(hObject, handles);

% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1
handles = guidata(hObject);



contents = cellstr(get(hObject,'String')); %returns popupmenu1 contents as cell array
select=contents{get(hObject,'Value')}; %returns selected item from popupmenu1


handles.sea_name=select;
handles.sealevel=load(select);
S=load(select);
N=(S.ans); mi=min(N(:,1))/1e3; ma=max(N(:,1))/1e3;

set(handles.text100,'string',sprintf('Info:  TerraceM LEM contains a compilation of diverse sea-level curves. %s extends between %.1f and %.1f ka',handles.sea_name,mi,ma))  


guidata(hObject,handles);
    
% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function slope_Callback(hObject, eventdata, handles)
% hObject    handle to slope (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of slope as text
%        str2double(get(hObject,'String')) returns contents of slope as a double

handles = guidata(hObject);
slope=str2double(get(hObject,'String'));
handles.slope=slope;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function slope_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slope (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Ur_Callback(hObject, eventdata, handles), global global_struct4
% hObject    handle to Ur (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ur as text
%        str2double(get(hObject,'String')) returns contents of Ur as a double

handles = guidata(hObject);
Ur=str2double(get(hObject,'String'));
handles.Ur=Ur;
global_struct4.Ur=Ur;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function Ur_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ur (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Er_Callback(hObject, eventdata, handles)
% hObject    handle to Er (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Er as text
%        str2double(get(hObject,'String')) returns contents of Er as a double

handles = guidata(hObject);
Er=str2double(get(hObject,'String'));
handles.Er=Er;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function Er_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Er (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function dt_Callback(hObject, eventdata, handles),global global_struct3
% hObject    handle to dt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dt as text
%        str2double(get(hObject,'String')) returns contents of dt as a double
handles = guidata(hObject);
dt=str2double(get(hObject,'String'));
handles.dt=dt;
global_struct3.dt=dt;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function dt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function dx_Callback(hObject, eventdata, handles)
% hObject    handle to dx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dx as text
%        str2double(get(hObject,'String')) returns contents of dx as a double

handles = guidata(hObject);
dx=str2double(get(hObject,'String'));
handles.dx=dx;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function dx_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu5.
function popupmenu5_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu5 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu5

handles = guidata(hObject);
contents = cellstr(get(hObject,'String')); %returns popupmenu1 contents as cell array
select=contents{get(hObject,'Value')}; %returns selected item from popupmenu1

cd('sealevel')

clear handles.sealevel
handles.sealevel=load(select);
cd('..')

guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function popupmenu5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function maxtt2_Callback(hObject, eventdata, handles)
% hObject    handle to maxtt2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxtt2 as text
%        str2double(get(hObject,'String')) returns contents of maxtt2 as a double

handles = guidata(hObject);

maxt=str2double(get(hObject,'String'));
handles.maxt2=maxt;

guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function maxtt2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to maxtt2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function dxx2_Callback(hObject, eventdata, handles)
% hObject    handle to dxx2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dxx2 as text
%        str2double(get(hObject,'String')) returns contents of dxx2 as a double

handles = guidata(hObject);
dx=str2double(get(hObject,'String'));
handles.dx2=dx;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function dxx2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dxx2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function slpp2_Callback(hObject, eventdata, handles)
% hObject    handle to slpp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of slpp2 as text
%        str2double(get(hObject,'String')) returns contents of slpp2 as a double

handles = guidata(hObject);
slp=str2double(get(hObject,'String'));
handles.slp2=slp;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function slpp2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slpp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit19_Callback(hObject, eventdata, handles)
% hObject    handle to edit19 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit19 as text
%        str2double(get(hObject,'String')) returns contents of edit19 as a double

handles = guidata(hObject);
minup=str2double(get(hObject,'String'));
handles.minup=minup;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit19_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit19 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit20_Callback(hObject, eventdata, handles)
% hObject    handle to edit20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit20 as text
%        str2double(get(hObject,'String')) returns contents of edit20 as a double

handles = guidata(hObject);
maxup=str2double(get(hObject,'String'));
handles.maxup=maxup;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit20_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit21_Callback(hObject, eventdata, handles)
% hObject    handle to edit21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit21 as text
%        str2double(get(hObject,'String')) returns contents of edit21 as a double

handles = guidata(hObject);
mine=str2double(get(hObject,'String'));
handles.mine=mine;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit21_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit22_Callback(hObject, eventdata, handles)
% hObject    handle to edit22 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit22 as text
%        str2double(get(hObject,'String')) returns contents of edit22 as a double

handles = guidata(hObject);
maxe=str2double(get(hObject,'String'));
handles.maxe=maxe;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit22_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit22 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on selection change in profsel.
function profsel_Callback(hObject, eventdata, handles)
% hObject    handle to profsel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns profsel contents as cell array
%        contents{get(hObject,'Value')} returns selected item from profsel

handles = guidata(hObject);
contents = cellstr(get(hObject,'String')); %returns stationslist contents as cell array
prof_selection=(contents{get(hObject,'Value')}); %returns selected item from stationslist
handles.profsel=str2num(prof_selection);

%load shorelines.txt and check for existing shoreline levels
%cd(handles.stationsdir)


%%%%%%%%%%%%%%%%%%%% 
%load data from .mat shorelines
try
shtab=handles.SHTAB;


clear sh_opt lev2

n=numel(shtab(handles.profsel).level);
lev1=shtab(handles.profsel).level(:);
lev2=[lev1(1:n).LEVEL];
%%%%%%%%%%%%%%%%%%%%%

%display in popup
sh_opt=num2cell(lev2); %transform number to cell
set(handles.level,'String',sh_opt)

catch
  set(handles.text100,'string','Info:  No shorelines.mat or swath.mat files has been selected to fit the LEM, please select these files in the set inputs interface, in the upper left corner')  
end


guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function profsel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to profsel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function sh_age_Callback(hObject, eventdata, handles)
% hObject    handle to sh_age (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sh_age as text
%        str2double(get(hObject,'String')) returns contents of sh_age as a double

handles = guidata(hObject);
age=str2double(get(hObject,'String'));
handles.age=age;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function sh_age_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sh_age (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit13_Callback(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit13 as text
%        str2double(get(hObject,'String')) returns contents of edit13 as a double


% --- Executes during object creation, after setting all properties.
function edit13_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in level.
function level_Callback(hObject, eventdata, handles)
% hObject    handle to level (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns level contents as cell array
%        contents{get(hObject,'Value')} returns selected item from level

handles = guidata(hObject);
contents = cellstr(get(hObject,'String')); %returns stationslist contents as cell array
level_selection=(contents{get(hObject,'Value')}); %returns selected item from stationslist
handles.levsel=str2num(level_selection);

guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function level_CreateFcn(hObject, eventdata, handles)
% hObject    handle to level (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

terracemdir=handles.terracemdir;
stationsdir=handles.stationsdir;
station=handles.statsel;
profile=handles.profsel;

cd(stationsdir)
cd(station)

load(sprintf('RMS_%s_%u.mat',station,profile))

n=sqrt(numel(rms_dif));
figure
hist(abs(rms_dif),n)
h = findobj(gca,'Type','patch');
set(h,'FaceColor','r','EdgeColor','w')
cd(terracemdir)

% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
ero=handles.ero;
tsea1=handles.tsea1/1000;

figure
plot(tsea1,ero,'-b')
xlim([min(tsea1) max(tsea1)])
xlabel('time (ka)')
ylabel('erosion (m/a)')

% --- Executes on button press in checkbox3.
function checkbox3_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox3
handles = guidata(hObject);
statesave=get(hObject,'Value');
handles.savepdf=statesave;
guidata(hObject, handles);
% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


function edit25_Callback(hObject, eventdata, handles)
% hObject    handle to edit25 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit25 as text
%        str2double(get(hObject,'String')) returns contents of edit25 as a double

handles = guidata(hObject);
dup=str2double(get(hObject,'String'));
handles.dup=dup;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit25_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit25 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit26_Callback(hObject, eventdata, handles)
% hObject    handle to edit26 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit26 as text
%        str2double(get(hObject,'String')) returns contents of edit26 as a double

handles = guidata(hObject);
de=str2double(get(hObject,'String'));
handles.de=de;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit26_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit26 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit27_Callback(hObject, eventdata, handles)
% hObject    handle to edit27 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit27 as text
%        str2double(get(hObject,'String')) returns contents of edit27 as a double

handles = guidata(hObject);
up=str2double(get(hObject,'String'));
handles.up=up;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit27_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit27 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit28_Callback(hObject, eventdata, handles)
% hObject    handle to edit28 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit28 as text
%        str2double(get(hObject,'String')) returns contents of edit28 as a double

handles = guidata(hObject);
down=str2double(get(hObject,'String'));
handles.down=down;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit28_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit28 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit32_Callback(hObject, eventdata, handles)
% hObject    handle to edit32 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit32 as text
%        str2double(get(hObject,'String')) returns contents of edit32 as a double

handles = guidata(hObject);
sill=str2double(get(hObject,'String'));
handles.sill2=sill;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit32_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit32 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function sill_Callback(hObject, eventdata, handles)
% hObject    handle to sill (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sill as text
%        str2double(get(hObject,'String')) returns contents of sill as a double

handles = guidata(hObject);
sill=str2double(get(hObject,'String'));
handles.sill=sill;

set(handles.text100,'string','Info:  Sill effect truncated the sea level curve at the bottomo, whwere water level can not drop lower to a defined depth');
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function sill_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sill (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

try
sl=handles.sealevel;
t=sl.ans(:,1)/-1000;
s1=sl.ans(:,2);
age=handles.age;

s=smooth(-(s1),handles.smuth);

figure
hold on
%title('Loaction of shoreline age in sea-level curve')
plot(t,s,'-b')

%find sealevel
[c index]=min(abs(age+t));
spt=s(index);

%plot(age,spt,'MarkerEdgeColor','k','MarkerFaceColor','r')
plot(-age,spt,'sr','MarkerEdgeColor','k','MarkerFaceColor','r','MarkerSize',10)

xlabel('time (ka)');ylabel('depth (m)')
xlim([min(t) max(t)])
catch
    set(handles.text100,'string','Info:  ERROR !!, No sea level curve has been selected');
end


function mint_Callback(hObject, eventdata, handles), global global_struct
% hObject    handle to mint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mint as text
%        str2double(get(hObject,'String')) returns contents of mint as a double

handles = guidata(hObject);
mint=str2double(get(hObject,'String'));
handles.mint=mint;
global_struct.mint=mint;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function mint_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function maxt_Callback(hObject, eventdata, handles),global global_struct2
% hObject    handle to maxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxt as text
%        str2double(get(hObject,'String')) returns contents of maxt as a double

handles = guidata(hObject);
maxt=str2double(get(hObject,'String'));
handles.maxt=maxt;
global_struct2.maxt=maxt;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function maxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit36 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit36_Callback(hObject, eventdata, handles)
% hObject    handle to edit36 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit36 as text
%        str2double(get(hObject,'String')) returns contents of edit36 as a double

handles = guidata(hObject);
mint=str2double(get(hObject,'String'));
handles.mint2=mint;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit36_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit36 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function dtt2_Callback(hObject, eventdata, handles)
% hObject    handle to dtt2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dtt2 as text
%        str2double(get(hObject,'String')) returns contents of dtt2 as a double

handles = guidata(hObject);
dt=str2double(get(hObject,'String'));
handles.dt2=dt;

guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function dtt2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dtt2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function axes2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes2
handles = guidata(hObject);
handles.axes2=axis;
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function axes3_CreateFcn(hObject, eventdata, ~)
% hObject    handle to axes3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes3
handles = guidata(hObject);
handles.axes3=axis;
guidata(hObject, handles);


function wav2_Callback(hObject, eventdata, handles)
% hObject    handle to wav2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of wav2 as text
%        str2double(get(hObject,'String')) returns contents of wav2 as a double

handles = guidata(hObject);
wave=str2double(get(hObject,'String'));
handles.wave2=wave;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function wav2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to wav2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function wave_Callback(hObject, eventdata, handles)
% hObject    handle to wave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of wave as text
%        str2double(get(hObject,'String')) returns contents of wave as a double

handles = guidata(hObject);

wave=str2double(get(hObject,'String'));
handles.wave=wave;

guidata(hObject,handles);



% --- Executes during object creation, after setting all properties.
function wave_CreateFcn(hObject, eventdata, handles)
% hObject    handle to wave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function snap_Callback(hObject, eventdata, handles)
% hObject    handle to snap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of snap as text
%        str2double(get(hObject,'String')) returns contents of snap as a double

handles = guidata(hObject);

snap=str2double(get(hObject,'String'));
handles.snap=snap;

guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function snap_CreateFcn(hObject, eventdata, handles)
% hObject    handle to snap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function smuth_Callback(hObject, eventdata, handles)
% hObject    handle to smuth (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of smuth as text
%        str2double(get(hObject,'String')) returns contents of smuth as a double

handles = guidata(hObject);

smuth=str2double(get(hObject,'String'));
handles.smuth=smuth;

guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function smuth_CreateFcn(hObject, eventdata, handles)
% hObject    handle to smuth (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function vx_Callback(hObject, eventdata, handles)
% hObject    handle to vx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of vx as text
%        str2double(get(hObject,'String')) returns contents of vx as a double

handles = guidata(hObject);

vx=str2double(get(hObject,'String'));
handles.vx=vx;

guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function vx_CreateFcn(hObject, eventdata, handles)
% hObject    handle to vx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function diff_Callback(hObject, eventdata, handles)
% hObject    handle to diff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of diff as text
%        str2double(get(hObject,'String')) returns contents of diff as a double


handles = guidata(hObject);

diff=str2double(get(hObject,'String'));
handles.diff=diff;

guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function diff_CreateFcn(hObject, eventdata, handles)
% hObject    handle to diff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function slpdif2_Callback(hObject, eventdata, handles)
% hObject    handle to slpdif2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of slpdif2 as text
%        str2double(get(hObject,'String')) returns contents of slpdif2 as a double

handles = guidata(hObject);
difusion=str2double(get(hObject,'String'));
handles.diff2=difusion;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function slpdif2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slpdif2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in varurate.
function varurate_Callback(hObject, eventdata, handles)
% hObject    handle to varurate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of varurate

h=get(hObject,'Value');
handles = guidata(hObject);
handles.varurate=h;

try
    
    cd(handles.statpath)

if h==1 %activated

%load UR matrix if exists
    if exist('urate.mat','file')==2

    load('urate.mat')   
    disp('loaded')
    set(handles.text100,'string','Info:  Variable Ur matrix has been loaded')
    else
      set(handles.text100,'string','Info:  Uplift rate matrix does not exist. Press Create Ur button to create a new matrix of variable uplift rate');  
    end

end

 cd(handles.terracemdir)

catch
set(handles.text100,'string','Info: No output directory has been defined, please select an output folder to search for a variable uplift rate matrix or to store a new one');   
end

guidata(hObject,handles);


% --- Executes on button press in pushbutton16.
function pushbutton16_Callback(hObject, eventdata, handles), global global_struct global_struct2 global_struct3 global_struct4 global_struct5
% hObject    handle to pushbutton16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global_struct5.here2=pwd;
try
cd(handles.statpath)    


global_struct.mint=handles.mint;
global_struct2.maxt=handles.maxt;
global_struct3.dt=handles.dt;
global_struct4.Ur=handles.Ur;
global_struct5.here1=pwd;

TerraceM_UR_creator

cd(handles.terracemdir)


catch 
set(handles.text100,'string','Info:  No outputs directory has been defined, to run the LEM with variable uplift rates you must define a output directory to store the matrix containing the reccords of uplift versus time or to load a previously created');    
    
end


% --- Executes on button press in checkbox10.
function checkbox10_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox10


% --- Executes on button press in radiobutton2.
function radiobutton2_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
radiott=get(hObject,'Value'); 
radiott=get(handles.radiobutton2,'Value');
handles.radio2=radiott;

guidata(hObject,handles);
% Hint: get(hObject,'Value') returns toggle state of radiobutton2


% --- Executes on button press in radiobutton1.
function radiobutton1_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton1


% --- Executes on button press in pushbutton18.
function pushbutton18_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
%dir1=char(uigetdir(pwd,'Select topography'))

set(handles.text100,'String','Info:  Select an output folder different than the TerraceM LEM folder, for instance an output folder from TerraceM Maptools. Model results and fits will be stored in this folder.');

[PathName] = uigetdir('Select the outputs folder');
[~,dir1] = fileparts(PathName);

handles.statpath=PathName;
handles.statsel=char(dir1);

addpath(handles.statpath)%NEW

guidata(hObject, handles);


% --- Executes on button press in checkbox12.
function checkbox12_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox12
handles = guidata(hObject);
dispshore=get(hObject,'Value');
handles.dispshore=dispshore;
guidata(hObject, handles);


% --- Executes on button press in checkbox13.
function checkbox13_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox13

handles = guidata(hObject);
dispt=get(hObject,'Value');
handles.disptime=dispt;
set(handles.checkbox12,'value',1)
handles.dispshore=1;
guidata(hObject, handles);



function edit49_Callback(hObject, eventdata, handles)
% hObject    handle to edit49 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit49 as text
%        str2double(get(hObject,'String')) returns contents of edit49 as a double
handles = guidata(hObject);
handles.Er2=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit49_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit49 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in checkbox15.
function checkbox15_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox15
handles = guidata(hObject);
savef=get(hObject,'Value');
handles.savef=savef;
guidata(hObject, handles);



function edit51_Callback(hObject, eventdata, handles)
% hObject    handle to edit51 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit51 as text
%        str2double(get(hObject,'String')) returns contents of edit51 as a double

handles = guidata(hObject);

ratio=str2double(get(hObject,'String'));
handles.ratio=ratio;

guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit51_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit51 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit52_Callback(hObject, eventdata, handles)
% hObject    handle to edit52 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit52 as text
%        str2double(get(hObject,'String')) returns contents of edit52 as a double

handles = guidata(hObject);

cycle=str2double(get(hObject,'String'));
handles.cycle=cycle;

guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit52_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit52 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in radiobutton4.
function radiobutton4_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton4


% --- Executes on button press in radiobutton5.
function radiobutton5_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton5


% --- Executes on button press in pushbutton20.
function pushbutton20_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
%dir1=char(uigetdir(pwd,'Select topography'))

[FileName,PathName] = uigetfile('*.mat','Select the swaths file .mat (TerraceM maptools output)');
handles.swpath=PathName;
addpath(handles.swpath)%NEW


load(FileName)
handles.swath=swath;
as=numel(swath);  %number of profiles per station
handles.nim=as; %add number of profiles to handles
af=(1:as);
a=num2cell(af); %transform number to cell
set(handles.profsel,'String',a) %set the string inputs for profiles popup
set(handles.prof2,'String',a) %set the string inputs for profiles popup

set(handles.text100,'string','Info:  Swath profiles have been selected and loaded');


guidata(hObject, handles);

% --- Executes on button press in pushbutton21.
function pushbutton21_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
%dir1=char(uigetdir(pwd,'Select topography'))

[FileName,PathName] = uigetfile('*.mat','Select the shorelines file .mat (TerraceM maptools outputs)');
handles.shpath=PathName;
addpath(handles.shpath)%NEW

if exist(FileName,'file')~=0
%load(sprintf('%s_swath.mat',handles.statsel)); % load swaths.mat dataset
load(FileName)
handles.SHTAB=SHORELINE;
end

set(handles.text100,'string','Info:  Shoreline angles have been selected and loaded');
guidata(hObject, handles);


% --- Executes on button press in pushbutton22.
function pushbutton22_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton22 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

swath=handles.swath;
sh=handles.SHTAB;

selsh=handles.levsel;
selswath=handles.profsel;
slope=handles.slope;

%find higher than sea level
indx=find(swath(selswath).z_max>0);
x=swath(selswath).x;
x2=x(indx);
yy=(tand(slope)*x2)-swath(selswath).z_max(indx(1));

figure
hold on
plot(swath(selswath).x,swath(selswath).z_max,'-k')
plot(swath(selswath).x,swath(selswath).z_mean,'-','color',[0.4 0.4 0.4])
plot(swath(selswath).x,swath(selswath).z_min,'-','color',[0.7 0.7 0.7])

plot(x2,yy,'--r')

if swath(selswath).type_profile==1
plot(sh(selswath).level(selsh).DISTANCE_PROFILE,sh(selswath).level(selsh).ELEVATION,'o','MarkerEdgeColor','r','MarkerFaceColor','k','MarkerSize',10)
else
plot(max(swath(selswath).x)-(sh(selswath).level(selsh).DISTANCE_PROFILE),sh(selswath).level(selsh).ELEVATION,'o','MarkerEdgeColor','r','MarkerFaceColor','k','MarkerSize',10)    
end


% --- Executes on button press in trunk.
function trunk_Callback(hObject, eventdata, handles)
% hObject    handle to trunk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of trunk

h=get(hObject,'Value');
handles = guidata(hObject);

handles.trunca=h;

if h==1
  set(handles.text100,'string','Info:  This removes the las period of sea level rise after the LGM, allowing preserving marine terraces that otherwise will be deleted by the Holocene sea-level rise. This facilitate comparing profiles that preserve young terraces (e.g. MIS3) but should be used with care as it represent a non realistic scenario')  
    
end

guidata(hObject,handles);


% --- Executes when selected object is changed in uibuttongroup3.
function uibuttongroup3_SelectionChangedFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uibuttongroup3 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);

newButton=get(eventdata.NewValue,'tag');

switch newButton
    
case 'radiobutton4' %optimization

set(handles.uipanel9,'Visible','Off')
set(handles.uipanel10,'Visible','On')
set(handles.uipanel14,'Visible','On')
set(handles.edit49,'Visible','On')
set(handles.text67,'Visible','On')

handles.type=1;   
    
case 'radiobutton5' %minimization
      
set(handles.uipanel9,'Visible','On')
set(handles.uipanel10,'Visible','Off')
set(handles.uipanel14,'Visible','Off')
set(handles.edit49,'Visible','Off')
set(handles.text67,'Visible','Off')




handles.type=2;         
end

guidata(hObject, handles);


% --- Executes on button press in checkbox20.
function checkbox20_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox20
h=get(hObject,'Value');
handles = guidata(hObject);

handles.trunca2=h;

guidata(hObject,handles);

% --- Executes on selection change in prof2.
function prof2_Callback(hObject, eventdata, handles)
% hObject    handle to prof2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns prof2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from prof2


handles = guidata(hObject);
contents = cellstr(get(hObject,'String')); %returns stationslist contents as cell array
prof_selection=(contents{get(hObject,'Value')}); %returns selected item from stationslist
handles.profsel2=str2num(prof_selection);

%load shorelines.txt and check for existing shoreline levels
%cd(handles.stationsdir)


%%%%%%%%%%%%%%%%%%%% 
%load data from .mat shorelines
try
shtab=handles.SHTAB;
catch
  disp('no shorelines.mat files has been selected')  
end

clear sh_opt lev2

n=numel(shtab(handles.profsel2).level);
lev1=shtab(handles.profsel2).level(:);
lev2=[lev1(1:n).LEVEL];
%%%%%%%%%%%%%%%%%%%%%

%display in popup
sh_opt=num2cell(lev2); %transform number to cell
set(handles.levels2,'String',sh_opt)


guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function prof2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to prof2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in levels2.
function levels2_Callback(hObject, eventdata, handles)
% hObject    handle to levels2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns levels2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from levels2

handles = guidata(hObject);
contents = cellstr(get(hObject,'String')); %returns stationslist contents as cell array
level_selection=(contents{get(hObject,'Value')}); %returns selected item from stationslist
handles.levsel2=str2num(level_selection);

guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function levels2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to levels2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit62_Callback(hObject, eventdata, handles)
% hObject    handle to edit62 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit62 as text
%        str2double(get(hObject,'String')) returns contents of edit62 as a double
handles = guidata(hObject);
age=str2double(get(hObject,'String'));
handles.age2=age;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit62_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit62 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit63_Callback(hObject, eventdata, handles)
% hObject    handle to edit63 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit63 as text
%        str2double(get(hObject,'String')) returns contents of edit63 as a double
handles = guidata(hObject);
up=str2double(get(hObject,'String'));
handles.up2=up;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit63_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit63 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit64_Callback(hObject, eventdata, handles)
% hObject    handle to edit64 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit64 as text
%        str2double(get(hObject,'String')) returns contents of edit64 as a double

handles = guidata(hObject);
down=str2double(get(hObject,'String'));
handles.down2=down;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit64_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit64 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
 


% --- Executes on selection change in cambios.
function cambios_Callback(hObject, eventdata, handles)
% hObject    handle to cambios (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns cambios contents as cell array
%        contents{get(hObject,'Value')} returns selected item from cambios

handles = guidata(hObject);
contents = cellstr(get(hObject,'String')); %returns stationslist contents as cell array
num_cmabios=(contents{get(hObject,'Value')}); %returns selected item from stationslist
handles.changes=str2num(num_cmabios);

Ncolumns=4;
Nrows=handles.changes;

set(handles.uitable1,'Visible','On');
set(handles.uitable1,'Data',cell(Nrows,Ncolumns))


t=handles.uitable1;
t.Data{1,1} = num2str(handles.mint2);
t.Data{Nrows,2} = num2str(handles.maxt2);

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function cambios_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cambios (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit65_Callback(hObject, eventdata, handles)
% hObject    handle to edit65 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit65 as text
%        str2double(get(hObject,'String')) returns contents of edit65 as a double

handles = guidata(hObject);
IT=str2double(get(hObject,'String'));
handles.iterations=IT;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit65_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit65 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton23.
function pushbutton23_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);

tableData = get(handles.uitable1, 'data');
n=handles.iterations;
cambios=handles.changes;
dt=handles.dt2;

Tmin1=str2double(tableData{1,1});
Tmax1=str2double(tableData{cambios,2});

xi = (Tmin1*1e3:dt:Tmax1*1e3)';%create time matrix in yrs

%Ucol=str2double(tableData(:, 3:4));

%U=zeros(cambios,n);
%wb=waitbar(0,'Wait, generating random uplift patterns');
for i=1:cambios
    
    Umin=str2double(tableData{i,3});
    Umax=str2double(tableData{i,4});
    U(:,i)=Umin+rand(n,1)*(Umax-Umin);  
    
    Tmin=str2double(tableData{i,1});
    Tmax=str2double(tableData{i,2});
    T(:,i)=round(Tmin+rand(n,1)*(Tmax-Tmin),0);   
     
end


%clear other axes
axes(handles.axes2)
cla

%plot in subplot axes
axes(handles.axes3)
%figure
cla reset;
box on
set(gca,'Xdir','reverse')


for j=1:n

if cambios ==2
 
mtr=[Tmin1,U(j,1); ...  
    Tmax1,U(j,2)];
end

if cambios==3
 mtr=[Tmin1,U(j,1); ...  
    T(j,2),U(j,2); ...
    Tmax1,U(j,3)];   
    
end

if cambios ==4
 mtr=[Tmin1,U(j,1); ...  
    T(j,2),U(j,2); ...
    T(j,3),U(j,3);...
    Tmax1,U(j,4)];   

end

%wb=waitbar(n/j);

[Uc]=create_ur2(mtr,dt);

urate2=Uc.urate;
UV(j).Ur=urate2;
UV(j).X=xi./1e3;

TAB=tableData;

hold on
plot(xi./1e3,urate2,'-')


end
xlabel('Time (ka)')
ylabel('Uplift rate (m/ka)')
%xlim([min(xi)/1e3 max(xi)/1e3])
%ylim([min(urate2) max(urate2)])

handles.Ur_random=UV;

cd(handles.statpath)
save('Ur_random.mat','UV','TAB');
cd(handles.terracemdir)



guidata(hObject, handles);

% --- Executes when entered data in editable cell(s) in uitable1.
function uitable1_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.TABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
t=handles.uitable1;
dat = get(hObject,'Data');
edC=eventdata;

if numel(t.Data)/4==2
vals=[1,handles.changes,handles.changes*2];%static values
t.Data{1,2}='<- initial';
t.Data{2,1} = 'final ->';
end

if numel(t.Data)/4==3
vals=[1,handles.changes,handles.changes+1,handles.changes*2];%static values
t.Data{1,2}='<- initial';
t.Data{3,1} = 'final ->';
end

if numel(t.Data)/4==4
vals=[1,handles.changes,handles.changes*2];%static values
t.Data{1,2}='<- initial';
t.Data{4,1} = 'final ->';
end

t_ced(t,dat,edC,vals); %call function unedit some cells
guidata(hObject, handles);


% --- Executes when selected cell(s) is changed in uitable1.
function uitable1_CellSelectionCallback(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.TABLE)
%	Indices: row and column indices of the cell(s) currently selecteds
% handles    structure with handles and user data (see GUIDATA)

% --- Executes on button press in pushbutton24.
function pushbutton24_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton24 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);

profile=handles.profsel2;
level=handles.levsel2;
type=handles.type;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Always swath
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cd(handles.statpath)
    if type==1
    load(('LEM_RadnomOp.mat'))
    else
    load(('LEM_RangeM.mat'))    
    end
cd(handles.terracemdir)   
 


g=numel(LEMS);
age=handles.age2;%shoreline angle age
up=handles.up2;
down=handles.down2;
 
savepdf=0; %save results
 
%get swath
sw_x=handles.swath(profile).x;
sw_zmin=handles.swath(profile).z_min;
sw_zmed=handles.swath(profile).z_mean;
sw_zmax=handles.swath(profile).z_max;
sw=[sw_x,sw_zmin,sw_zmed,sw_zmax];

%get shoreline angle
sh(:,1)=handles.SHTAB(profile).level(level).DISTANCE_PROFILE;
sh(:,2)=handles.SHTAB(profile).level(level).ELEVATION;  

mode=0;%no plot mode selected
ratio=10;
cycle=5000;

cd(handles.statpath)
if exist(sprintf('RMS_RadnomOp_prof%.f.mat',profile),'file')==2   && handles.ovr1==0
load(sprintf('RMS_RadnomOp_prof%.f.mat',profile));
cd(handles.terracemdir)
    
else
%Ur=handles.Ur_random;
wb=waitbar(0,'Wait, runing models'); 
set(wb,'windowstyle','modal');


for i=1:g
%the FIT function
[Result(i),MOD(i)]=TerraceM_rms_fit(LEMS(i).LEM,LEMS(i).LEM2,profile,sw,sh,age,ratio,cycle,up,down,mode,savepdf);
wb=waitbar(i/g);
end
close(wb)

cd(handles.statpath)
if type ==1
file_lem=sprintf('RMS_RadnomOp_prof%.f.mat',profile);
save(file_lem, 'Result','MOD');
else
file_lem=sprintf('RMS_RangeM_prof%.f.mat',profile);
save(file_lem,'Result','MOD');    
end
cd(handles.terracemdir)

end

set(handles.text100,'string',sprintf('Info:  %u models has been fited and their statistics calculated, now proceed to find best fit, to identify the models taht can reproduce the swath profile topography',g));  


guidata(hObject, handles);


function edit67_Callback(hObject, eventdata, handles)
% hObject    handle to edit67 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit67 as text
%        str2double(get(hObject,'String')) returns contents of edit67 as a double
handles = guidata(hObject);
CH=str2double(get(hObject,'String'));
handles.chains=CH;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit67_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit67 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when selected object is changed in uibuttongroup6.
function uibuttongroup6_SelectionChangedFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uibuttongroup6 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);

newButton=get(eventdata.NewValue,'tag');

switch newButton
    
case 'radiobutton9' %optimization

set(handles.text103,'Visible','Off')    
set(handles.edit67,'Visible','Off')    
 
    
case 'radiobutton8' %optimization
 
set(handles.text103,'Visible','On')    
set(handles.edit67,'Visible','On')    
    
    
    
end

guidata(hObject, handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% --- Executes when calling Celleditacallback uitable1.
function t_ced(t,dat,edC,vals)
%   unedit some cells, works for GUIDE uitables
%   keep defined cells unchangeable or static with inmediately previous value
%   automatically update the uitable callback
%   based on Oleg Komarov example 2011
%   https://de.mathworks.com/matlabcentral/answers/2283-uitable-s-cells-as-a-readonly
        
              % Transform subscipts of selected cell into idx
              idx = sub2ind(size(dat),edC.Indices(1),edC.Indices(2));
              % If idx falls into defined range set back previous value
              if ismember(idx, vals)
                  data = get(t,'data');
                  data{idx} = edC.PreviousData;
                  set(t,'data',data)
              end
 


% --- Executes on button press in pushbutton25.
function pushbutton25_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton25 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

type=handles.type;
profile=handles.profsel2;
level=handles.levsel2;
%get swath
sw_x=handles.swath(profile).x;
sw_zmin=handles.swath(profile).z_min;
sw_zmed=handles.swath(profile).z_mean;
sw_zmax=handles.swath(profile).z_max;
sw=[sw_x,sw_zmin,sw_zmed,sw_zmax];

%get shoreline angle
sh(:,1)=handles.SHTAB(profile).level(level).DISTANCE_PROFILE;
sh(:,2)=handles.SHTAB(profile).level(level).ELEVATION;  

cd(handles.statpath)

if type ==1 %if random optimization or ranges

if exist(sprintf('RMS_RadnomOp_prof%.f.mat',profile),'file')==2  &&  exist('LEM_RadnomOp.mat','file')==2 %if exist file or not   
load(sprintf('RMS_RadnomOp_prof%.f.mat',profile));
load(('LEM_RadnomOp.mat'));
load('Ur_random.mat');

%NRMSE
if handles.minimize==1 
[minv,id_n]=(min(extractfield(Result,'NRMSE')));
end
%Area
if handles.minimize==2  
[minv,id_n]=(min(extractfield(Result,'Area')));
end


g=numel(Result);
x_delta=MOD(id_n).x_delta;

axes(handles.axes2)
cla
hold on
 
for j=1:g 
plot(LEMS(j).LEM.x_mod+x_delta*1e3,LEMS(j).LEM.z_mod,'color',[0.75 0.75 0.75])       
end
plot(LEMS(id_n).LEM.x_mod+x_delta*1e3,LEMS(id_n).LEM.z_mod,'color','k','LineWidth',1.5)
plot(sw(:,1),sw(:,4),'color','r','LineWidth',1.5)%-xdelta*1e3
plot(sh(:,1),sh(:,2),'or')
xlim([min(sw(:,1)) max(sw(:,1))])
ylim([min(sw(:,4)) max(sw(:,4))])

axes(handles.axes3)
cla
hold on
%all

plot(extractfield(UV,'X'),extractfield(UV,'Ur'),'-','color',[0.75 0.75 0.75])
%best fit
plot(UV(id_n).X,UV(id_n).Ur,'-k','LineWidth',2);  

set(handles.text100,'string','Info: The best fit model using Random Optimization has been displayed.');      


else %no files there
set(handles.text100,'string','Info:  Fits Models have not been created, go back to Fit Models button');      
end


else %ranges
    
    
load(sprintf('RMS_RangeM_prof%.f.mat',profile));



end

%if handles.plotite==1
%cd(handles.statpath)

ax1=handles.axes2;
txtdifX=ax1.XLim(2)-ax1.XLim(1);
txtdifY=ax1.YLim(2)-ax1.YLim(1);

ax2=handles.axes3;
    %fig1 = figure('visible','off');
    F1=figure;
    F1.Renderer='Painters';
    ax(1)=subplot(2,1,1);
    box on
    xlim(ax1.XLim)
    ylim(ax1.YLim)
    xlabel('Distance (m)')
    ylabel('Elevation (m)')
    
    if handles.minimize==1 
    text(ax1.XLim(1)+txtdifX/10,ax1.YLim(2)-txtdifY/10,sprintf('NRMSE = %.2f',minv))
    end
    
    if handles.minimize==2 
    text(ax1.XLim(1)+txtdifX/10,ax1.YLim(2)-txtdifY/10,sprintf('Area = %.2f',minv))
    end
    
    ax(2)=subplot(2,1,2);
    box on
    xlabel('Time (ka)')
    ylabel('Uplift rate (m/ka)')
    
    h1 = get(ax1,'Children');
    h2 = get(ax2,'Children');
    newh1 = copyobj(h1,ax(1));
    newh2 = copyobj(h2,ax(2));

    rect=[2,2,15,25]; %[xmin ymin width height]
    set(gcf,'PaperType','A4');
    set(gcf,'PaperUnits','centimeters'); 
    set(gcf,'Paperposition',rect);
        
    fout4 =sprintf('Best_fit_prof_%u.pdf',profile);       
    saveas(gcf,fout4,'pdf')    
    
%end
    
cd(handles.terracemdir)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



% --- Executes when selected object is changed in uibuttongroup7.
function uibuttongroup7_SelectionChangedFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uibuttongroup7 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


handles = guidata(hObject);

newButton=get(eventdata.NewValue,'tag');

switch newButton
    
case 'radiobutton10' %NRMSE


handles.minimize=1;   
    
case 'radiobutton11' %Area



handles.minimize=2;         
end

guidata(hObject, handles);


% --- Executes on button press in checkbox21.
function checkbox21_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox21
handles = guidata(hObject);
ovr=get(hObject,'Value');
handles.ovr1=ovr;
guidata(hObject, handles);


% --- Executes on button press in checkbox22.
function checkbox22_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox22 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox22
handles = guidata(hObject);

pl=get(hObject,'Value');
handles.plotite=pl;

guidata(hObject, handles);


% --- Executes on button press in checkbox23.
function checkbox23_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox23
