function [shoreline]=TerraceM_autoshoreline(mini,x_mod,z_mod,ratio,cycle)
%cycle=20000; %Minimum time range glacial cycles
%mindist=2000;

%%Autoshoreline
%automatically extract shorelne angles from table outputs of TerraceM LEM
% use a model with difussion=0, 
%mini is the cumulative intersections between shoreline at time t, x_mod
%and y_mod the topography of the model (use diff=0), cycle=10000 is the
%minimum separation between highstands to be recognized as shorelines
%output values are X and Z, t (are distance, elevation, age) in the model 


% autoshoreline
%maximum event near T0
[D0,I]=max(mini(:,1));
T0=mini(I,2);

% first diff
mini_dif=diff(mini(:,2));
mini_dif(end+1,1)=mini_dif(end,1);
min_dif2=mini_dif(mini_dif>cycle);%cut off to reduce nº of shoreline angles
minix2=mini(mini_dif>cycle,1); %10k is the range diference to select the tip of transgression from shoreline position curve
miniy2=mini(mini_dif>cycle,2);

%reduce vector
[latout,lonout] = reducem(minix2,miniy2,ratio);

%add first event
latout=vertcat(latout,D0);
lonout=vertcat(lonout,T0);
%using function
mindist = 2000;
X=[latout,lonout];
nX = sum(X.^2,2);

d = bsxfun(@plus,nX,nX')-2*X*X';
 [p,~,r] = dmperm(d<mindist^2);
 nvoxels = diff(r);

for n=find(nvoxels>1) 
   idx = p(r(n):r(n+1)-1);
   X(idx,:) = repmat(mean(X(idx,:),1),numel(idx),1); 
   X(idx(2:end),:) = nan;
 end
 X(any(isnan(X),2),:) = [];

 X2A=round(X(:,1),-1);  X2B=round(x_mod,-1);
 %find Z
idxs = arrayfun(@(x)find(X2B==x,1),X2A);
Z=z_mod(idxs)';

%find time
t=X(:,2);
% output

try
shoreline=[X(:,1), Z, t]; 
catch
shoreline=[X(:,1), Z', t];     
end

