%% reoccupation mapping (n? times sea level position occur along the profile)
function [counter,mini]=TerraceM_recoccupation(xsea1,ysea1,sea_rec,plote)

%counter is number of sea level stands at each interval in x
%mini is a two column vector where col 1 is x axis the and col 2 is the
%time, used to plot terraces coloured by time and locate shoreline angles
%h= handles of output figure

%example
%[counter,mini]=recoccupation(x,t); t=time x= a spatial coordinate from LEM
%both outputs of function Anderson3

X2=xsea1;
%YY=flipud(sea_rec')';
YY=sea_rec;
Y2=YY;
k=1;
counter=zeros(size(xsea1));
%allocate

hw = waitbar(0,'Wait, rebuilding model...');

for i=1:numel(xsea1)
tx=xsea1(i);%model x axis
X1=[tx,tx];
Y1=[min(sea_rec),max(sea_rec)];%model time y axis
%[X01,Y01] = intersections(X1,Y1,X2,Y2,'ROBUST');
%[X01,Y01] = polyxpoly(X1,Y1,X2,Y2);
L1(1,:)=X1';L1(2,:)=Y1';
L2(1,:)=X2';L2(2,:)=Y2';
P = InterX(L1,L2);
X01=P(1,:)';Y01=P(2,:)';


counter(k)=numel(X01);
mini(k,:)=[min(X01),min(Y01)];
k=k+1;

waitbar(i / numel(xsea1))
end

close(hw) 

if plote == 1
%graduated line
%figure;
hold on

newprof(:,1)=xsea1/1e3;
newprof(:,2)=ysea1;
newprof(:,3)=mini(:,2);

newprof=sortrows(newprof,1);
plot(newprof(:,1), newprof(:,2),'-k')%basic monochrome plot

%h = color_line3(xsea1/1e3, ysea1, mini(:,2), mini(:,2));%trick
h = color_line3(newprof(:,1), newprof(:,2), newprof(:,3), newprof(:,3));%trick

set(h,'linewidth',3,'linestyle','-');
colormap parula;
cl=colorbar('west');
cl.Label.String = 'time (yr BP)';

ax = gca;
axpos = ax.Position;
cpos = cl.Position;

cpos(1) = 1.2*cpos(1);
cpos(2) = 1.9*cpos(2);
cpos(3) = 0.5*cpos(3);
cpos(4) = 0.25*cpos(4);

cl.Position = cpos;
ax.Position = axpos;
end

