function varargout = TerraceM_Catalog(varargin)
% TERRACEM_CATALOG MATLAB code for TerraceM_Catalog.fig
%      TERRACEM_CATALOG, by itself, creates a new TERRACEM_CATALOG or raises the existing
%      singleton*.
%
%      H = TERRACEM_CATALOG returns the handle to a new TERRACEM_CATALOG or the handle to
%      the existing singleton*.
%
%      TERRACEM_CATALOG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TERRACEM_CATALOG.M with the given input arguments.
%
%      TERRACEM_CATALOG('Property','Value',...) creates a new TERRACEM_CATALOG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TerraceM_Catalog_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TerraceM_Catalog_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TerraceM_Catalog

% Last Modified by GUIDE v2.5 14-Apr-2019 10:57:56

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TerraceM_Catalog_OpeningFcn, ...
                   'gui_OutputFcn',  @TerraceM_Catalog_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before TerraceM_Catalog is made visible.
function TerraceM_Catalog_OpeningFcn(hObject, eventdata, handles, varargin),global Box Cs num txtab Zonen
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TerraceM_Catalog (see VARARGIN)

% Choose default command line output for TerraceM_Catalog
handles.output = hObject;

%%%%%%%%% global variables
Boxi=Box;
Coast=Cs;
numi=num;
texti=txtab;
zone=Zonen;
%%%%%%%%%%%%%%%%%%%%%%%

%fix headers of excell table
numi(1:2,:)=[];
texti(1:2,:)=[];

%get locations
LAT1=numi(:,1);
LONG1=numi(:,2);
%LAT2=numi(:,3);
%LONG2=numi(:,4);

%station location
X = extractfield(Boxi, 'X');
Y = extractfield(Boxi, 'Y');

%get mean position
Xutm=mean(X,'omitnan');
Yutm=mean(Y,'omitnan');

%separate strings of utmzone
if numel(zone)==3
a=zone(1);
b=zone(2);
c=zone(3);
utmzt=horzcat([a,b,' ',c]);
else
a=zone(1);
b=zone(2);  
utmzt=horzcat(['0',a,' ',b]);
end

%cover station to latlong
[LAT,LON]=utm2deg(Xutm,Yutm,utmzt);
%Reformat matrixes
A=[LAT,LON];
B=[LAT1,LONG1];

%compute Euclidean distances:
distances = sqrt(sum(bsxfun(@minus, B, A).^2,2));

%%%%%%%%%%%%%%%%
%find the nearest and use that as an index
% put distances in order to get nearest values (5)
distances2=distances;
distances2(:,2)=(1:1:numel(distances))';
distances2=sortrows(distances2,1);

Rest_vals=distances2(1:5,2);
%reccord values
for j=1:5
    Sites(j,:)=B(Rest_vals(j),:);
    idx1(j)=Rest_vals(j);    
end

axes(handles.axes1)

hold on
box on
axis equal

%get data from shapefile coast
Xc=extractfield(Coast,'X');
Yc=extractfield(Coast,'Y');

%Plot coast and points
plot(Xc,Yc,'-k')
plot(LONG1,LAT1,'ok','Markerfacecolor',[0.6 0.6 0.6],'Markersize',9)
plot(Sites(:,2),Sites(:,1),'ob','Markerfacecolor','c','Markersize',9)
plot(LON,LAT,'or','Markerfacecolor','r','Markersize',6)

%labeling
labels={texti(idx1(1),5),texti(idx1(2),5),texti(idx1(3),5),texti(idx1(4),5),texti(idx1(5),5)};
labelpoints(Sites(:,2),Sites(:,1), labels);

point=[LAT,LON];%point latlong
Sito=vertcat(Sites,point);%concatenate all
%fit limits
xlim([min(Sito(:,2))-(max(Sito(:,2))-min(Sito(:,2)))/4 max(Sito(:,2))+(max(Sito(:,2))-min(Sito(:,2)))/4])
ylim([min(Sito(:,1))-(max(Sito(:,1))-min(Sito(:,1)))/4 max(Sito(:,1))+(max(Sito(:,1))-min(Sito(:,1)))/4])

%fill the table
Data(:,1)=[texti(idx1(1),5),texti(idx1(2),5),texti(idx1(3),5),texti(idx1(4),5),texti(idx1(5),5)];%site
Data(:,2)=[texti(idx1(1),16),texti(idx1(2),16),texti(idx1(3),16),texti(idx1(4),16),texti(idx1(5),16)];%MIS
Data(:,3)={numi(idx1(1),15),numi(idx1(2),15),numi(idx1(3),15),numi(idx1(4),15),numi(idx1(5),15)};%elevation
Data(:,4)={numi(idx1(1),18),numi(idx1(2),18),numi(idx1(3),18),numi(idx1(4),18),numi(idx1(5),18)};%uplift
Data(:,5)=[texti(idx1(1),25),texti(idx1(2),25),texti(idx1(3),25),texti(idx1(4),25),texti(idx1(5),25)];%dating method
Data(:,6)=[texti(idx1(1),26),texti(idx1(2),26),texti(idx1(3),26),texti(idx1(4),26),texti(idx1(5),26)];%material
Data(:,7)=[texti(idx1(1),34),texti(idx1(2),34),texti(idx1(3),34),texti(idx1(4),34),texti(idx1(5),34)];%ref

colnames = {'Location','MIS','MIS-5 elevation (m)','MIS-5 Uplift (m/ka)','Dating method','Material','Authors'};%headers
%write table
set(handles.table,'data',Data,'ColumnName',colnames);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes TerraceM_Catalog wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = TerraceM_Catalog_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
