function varargout = TerraceM_MAP(varargin)
% TERRACEM_MAP MATLAB code for TerraceM_MAP.fig
%      TERRACEM_MAP, by itself, creates a new TERRACEM_MAP or raises the existing
%      singleton*.
%
%      H = TERRACEM_MAP returns the handle to a new TERRACEM_MAP or the handle to
%      the existing singleton*.
%
%      TERRACEM_MAP('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TERRACEM_MAP.M with the given input arguments.
%
%      TERRACEM_MAP('Property','Value',...) creates a new TERRACEM_MAP or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TerraceM_MAP_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TerraceM_MAP_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TerraceM_MAP

% Last Modified by GUIDE v2.5 14-Sep-2019 21:47:38

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TerraceM_MAP_OpeningFcn, ...
                   'gui_OutputFcn',  @TerraceM_MAP_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before TerraceM_MAP is made visible.
function TerraceM_MAP_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TerraceM_MAP (see VARARGIN)

% Choose default command line output for TerraceM_MAP
handles.output = hObject;

%load logos
lgt=handles.logotype;
axes (lgt);
[cdata,map] = imread('logo.tif'); 
imshow(cdata,map)

%handles
handles.selp=1;
handles.maping=1;
handles.update=0;
set(handles.catalog,'visible','off')  
% Update handles structure
% condition if to check existence of .path file
path = 'terracem_path.mat'; %path file
cdx=pwd; %local directory
%check if path file exist
if exist(fullfile(cdx, 'terracem_path.mat'), 'file')==2     
   load(path) %load path file 
    
    try
     
        
    if  strcmp(cdx,terracem_dir)==1
        handles.station=[];
        handles.statpath=[];
        handles.maindir=terracem_dir;
        handles.topotool=topotool;
        handles.station=station; 
        handles.topofile=topography;
        handles.swatsfile=shapefile;
        handles.pathname=PathName;
        handles.swatpathname= swathpathname;
        %set directories readed from terracem_path.mat
        set(handles.fullpath1,'String',handles.maindir) %print terracem directory path in fullpath1 bar
        set(handles.edit4,'String',handles.topotool) %print stations directory in fullpath2 bar
        set(handles.edit15,'String',handles.station)
        set(handles.topopath,'String',handles.topofile) 
        set(handles.swatspath,'String',handles.swatsfile)
        
        %prompt message
        set(handles.text38,'String',sprintf('Info =   Welcome to TerraceM.  %s directories have been loaded. \n           Press "Read Inputs" to proceed with this Station or select different files and stations names',handles.station));    
    else %If path file differs from directory achitecture      
        %command window prompt 
        Info=('Different terracem folder, Set the input directories again');
        T = evalc('Info');
        Tcell = regexp(T, '\n', 'split');
        set(handles.text38,'String',Tcell);
    
        handles.maindir=pwd;
        set(handles.fullpath1,'String',handles.maindir)
        handles.topotool=[];
        set(handles.uipanel3,'visible','on')
    end 
    
    catch 
        Info=('The path file is corrupt, please introduce again TerraceM inputs folders');
        T = evalc('Info');
        Tcell = regexp(T, '\n', 'split');
        set(handles.text38,'String',Tcell); 
    
    
    %delete('terracem_path.mat')  
    end
else
    %command window prompt 
    Info=('Set the input directories');
    T = evalc('Info');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
    
    handles.maindir=pwd;
    handles.topotool=[];
end  

addpath(handles.maindir);

guidata(hObject, handles);

% UIWAIT makes TerraceM_MAP wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = TerraceM_MAP_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton21.
function pushbutton21_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton22.
function pushbutton22_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton22 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Maindir
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
dir1=char(uigetdir(pwd,'Set the path to Terracem scripts'));
handles.maindir=char(dir1); %define handles for the path to terracem directory
set(handles.fullpath1,'String',dir1) %print terracem directory path in fullpath1 bar

Info=('The TerraceM folder is sually called TerraceM and contains all the TerraceM scripts, the one you are using to run this program rigth now');
        T = evalc('Info');        
        Tcell = regexp(T, '\n', 'split');      
        set(handles.text38,'String',Tcell);    

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ax1=axis;
handles = guidata(hObject);

h1 = waitbar(0,'Please wait, converting DEM...');
set(h1,'windowstyle','modal');

%load shapefile
cd(handles.swatpathname);
shapefile=handles.swatsfile;
Box=shaperead(sprintf('%s',shapefile));
% profiles
handles.box=Box;
nim=numel(Box);

cd(handles.pathname)

if exist(sprintf('%s',handles.station),'dir')==7
else
[s,mess,messid] = mkdir(sprintf('%s',handles.station));
end

waitbar(0.15);

Info=('Wait, processing topography');
%Change display using blank background or satllite imagery from GoogleMaps. Use "Project Plotter" to display profiles and the topography
T = evalc('Info');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);


try
addpath(handles.topotool);%topotoolbox
pt=sprintf('%s/utilities',handles.topotool);
addpath(pt)
catch
    disp('Topotoolbox path is missing, add path or select directory')
end

%check if obj was created
try
cd(handles.station)
handles.statpath=pwd;
catch
disp('ERROR: Define a station name') 
end

fileD1=sprintf('%s_dem.mat',handles.station);
fileD2=sprintf('%s_swath.mat',handles.station);

waitbar(0.3);

if exist(sprintf('%s_dem.mat',handles.station),'file')==0 
disp('Processing DEMS')
cd(handles.pathname)
DEM = GRIDobj(sprintf('%s',handles.topofile));
h1=waitbar(0.5);
DEM.Z(DEM.Z==0)=nan;
DEMe = elevateminima(DEM);
h1=waitbar(0.7);
DEMf = fillsinks(DEMe);
h1=waitbar(0.9);
clear DEM %overwrite original by filtered DEM
DEM=DEMf;
cd(handles.statpath)
save(fileD1,'DEM')
h1=waitbar(0.95);
else
    %load(sprintf('%s_dem.mat',handles.station))

    load(fileD1)
waitbar(0.75);
end
waitbar(0.99);
close(h1) 

Info=('Wait,processing profiles');
%Change display using blank background or satllite imagery from GoogleMaps. Use "Project Plotter" to display profiles and the topography
T = evalc('Info');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);

handles.DEM=DEM;

if exist(sprintf('%s_swath.mat',handles.station),'file')==0 
    h = waitbar(0,'Please wait, extracting profiles...');
    set(h,'windowstyle','modal');
    for i=1:numel(Box)%number of profiles
        swath(i)=TerraceM_makeswath(DEM,Box,(i));         
        waitbar(i / numel(Box));
    end 
close(h) 
save(fileD2,'swath')    
else
    
    if handles.update==0   
    load(fileD2)
    else
        h2 = waitbar(0,'Please wait...');
        set(h2,'windowstyle','modal');
        
        %%%%%%% Object oriented %%%%%%%%%%%%%%%%%%%%%%%
        for i=1:numel(Box)%number of profiles
            swath(i)=TerraceM_makeswath(DEM,Box,(i));  
            waitbar(i / numel(Box));
        end 
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        close(h2) 
        save(fileD2,'swath')  
    end
end

handles.swat=swath;
%figure
h3 = waitbar(0,'Please wait...');
%set(h3,'windowstyle','modal');


axes(handles.ax1)
cla reset

box on

%plot boxes
hold on
%hillshade(DEM)
imageschs(DEM,[],'ticklabels','nice','colormap','landcolor','colorbarlabel','Elevation (m)' ,'colorbar',1);
%colorbar('Location', 'South');
%c.Label.String = 'Elevation (m)';
for i=1:nim

waitbar(i / nim);
    
hold on
obj.h=plot(Box(i).X,Box(i).Y,'k-');
SFX(:,i)=Box(i).X;
SFY(:,i)=Box(i).Y;
hold on 

%limits
MAX=max(max(SFX)); MIX=min(min(SFX)); DX=MAX-MIX;
MAY=max(max(SFY)); MIY=min(min(SFY)); DY=MAY-MIY;

if DX>DY
xlim([(MIX-DX/8) (MAX+DX/8)])
else
ylim([(MIY-DY/8) (MAY+DY/8)])
end

set(gca,'YTickLabelRotation',90)
refreshdata(obj.h) %refresh data if plot changes
axis equal



end
close(h3)


structdata = struct('station',handles.station,'terracem_dir', handles.maindir, 'topotool', handles.topotool,'topography', handles.topofile,'shapefile',handles.swatsfile,'PathName',handles.pathname,'swathpathname',handles.swatpathname,'stationpath',handles.statpath); %define handles to save
cd(handles.maindir)%set the main directory
save('terracem_path.mat', '-struct', 'structdata')

%cd(handles.pathname)
cd(handles.statpath)

if exist(sprintf('%s_SHORELINES.mat',handles.station))==2

    load(sprintf('%s_SHORELINES.mat',handles.station));
    clear TOTI
k=1;
for i=1:(numel(SHORELINE))
jj=numel(SHORELINE(i).level); 
for j=1:jj    
TOTI(k,1)=SHORELINE(i).level(j);
k=k+1;
end
end

Ex=numel(extractfield(TOTI,'ELEVATION'));

Txtx=sprintf('Info= \n          Welcome to TerraceM-2. The project %s has been loaded. \n          Content: %d swath profiles and %d shoreline angles mapped',handles.station,numel(Box),Ex);


set(handles.text38,'String',Txtx);

else

Info=('Processing ready, now proceed to mapping interface');
T = evalc('Info');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
end

set(handles.catalog,'visible','on')  

guidata(hObject, handles);


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function fullpath1_Callback(hObject, eventdata, handles)
% hObject    handle to fullpath1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fullpath1 as text
%        str2double(get(hObject,'String')) returns contents of fullpath1 as a double
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function fullpath1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fullpath1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in pushbutton12.
function pushbutton12_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
dir3=char(uigetdir(pwd,'Set the path to Topotoolbox script files'));
handles.topotool=char(dir3); %define handles for the path to terracem directory
set(handles.edit4,'String',dir3) %print terracem directory path in fullpath1 bar


%('Proceed to Select the input files. The DEM in .tif/.asc and the swath profiles as polygons (boxes) .shp. Both overlapping.');
 %command window prompt 
    Info=('Proceed to select the input files. The DEM in .tif/.asc and the swath profiles as polygons (boxes) .shp. Both overlapping and UTM system.');
    T = evalc('Info');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);

% Update handles structure
guidata(hObject, handles);


function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton23.
function pushbutton23_Callback(hObject, eventdata, handles),global st1 st2 st3 
% hObject    handle to pushbutton23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);

st1.station=handles.station;
st2.statpath=handles.statpath;
st3.maindir=handles.maindir;

TerraceM_export;


guidata(hObject, handles);

% --- Executes on button press in pushbutton24.
function pushbutton24_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton24 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
here=pwd;
cd(handles.maindir);

TerraceM_upliftdet

cd(here);

guidata(hObject, handles);


% --- Executes on button press in pushbutton26.
function pushbutton26_Callback(hObject, eventdata, handles),global SS1 SS2 SS3 SS4 SS5 %handles.box
% hObject    handle to pushbutton26 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
%global variables
SS1.maindir=handles.maindir;
SS2.station=handles.station;
SS3.statpath=handles.statpath;
SS4.swat=handles.swat;
SS5.DEM=handles.DEM;

%cd(handles.maindir)
TerraceM_Profilebox

Info=('Graphic User Interface for interactive display of swath profiles and shoreline angles');
T = evalc('Info');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);

guidata(hObject, handles);

% --- Executes on button press in pushbutton25.
function pushbutton25_Callback(hObject, eventdata, handles), global st1 st2 st3 st4
% hObject    handle to pushbutton25 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);

st1.station=handles.station;
st2.statpath=handles.statpath;
st3.box=handles.box;
st4.DEM=handles.DEM;



Info=('Display project in map view and projection of shoreline angles along a custom profile');
T = evalc('Info');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
guidata(hObject, handles);

%cd(handles.maindir)
TerraceM_Projectplot


guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function logotype_CreateFcn(hObject, eventdata, handles)
% hObject    handle to logotype (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles = guidata(hObject);
handles.logotype=axis;

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function text38_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text38 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles = guidata(hObject);    
handles.text38=str2double(get(hObject,'String')); %returns contents of edit14 as a double
guidata(hObject, handles);


% --- Executes on button press in pushbutton27.
function pushbutton27_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton27 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
%dir1=char(uigetdir(pwd,'Select topography'))

[dir1,PathName] = uigetfile('*.tif; *.asc','Select the topography file');

handles.pathname=PathName;
handles.topofile=char(dir1); %define handles for the path to terracem directory
set(handles.topopath,'String',dir1) %print terracem directory path in fullpath1 bar
% Update handles structure
guidata(hObject, handles);


function topopath_Callback(hObject, eventdata, handles)
% hObject    handle to topopath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of topopath as text
%        str2double(get(hObject,'String')) returns contents of topopath as a double
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function topopath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to topopath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton28.
function pushbutton28_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton28 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
[dir1,PathNameswath] = uigetfile('*.shp','Select the topography file');

handles.swatsfile=char(dir1);
handles.swatpathname=char(PathNameswath);%define handles for the path to terracem directory
set(handles.swatspath,'String',dir1) %print terracem directory path in fullpath1 bar
% Update handles structure
guidata(hObject, handles);


function swatspath_Callback(hObject, eventdata, handles)
% hObject    handle to swatspath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of swatspath as text
%        str2double(get(hObject,'String')) returns contents of swatspath as a double
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function swatspath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to swatspath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton30.
function pushbutton30_Callback(hObject, eventdata, handles), global str1 str2 str3 str4 str5 str6
% hObject    handle to pushbutton30 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
str1.DEM=handles.DEM;
str2.swat=handles.swat;
str3.box=handles.box;
str4.station=handles.station;
str5.statpath=handles.statpath;
str6.maindir=handles.maindir;

if handles.selp==1 %call SCM prof analyzer
    
    TerraceM_SCM_staircase
    
else
  
     TerraceM_SCM
    
end





guidata(hObject, handles);


% --- Executes on button press in pushbutton31.
function pushbutton31_Callback(hObject, eventdata, handles),global s1 s2 s3 s4 s5
% hObject    handle to pushbutton31 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
%cd(handles.statpath)
%global variables
s1.stat=handles.station;
s2.statpath=handles.statpath;
s3.terracemdir=handles.maindir;
s4.swat=handles.swat;
s5.maping=handles.maping;

%call mapping function

TerraceM_shorelinemap
    
guidata(hObject, handles);


function edit15_Callback(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit15 as text
%        str2double(get(hObject,'String')) returns contents of edit15 as a double
handles = guidata(hObject);
handles.station=get(hObject,'String');
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox4.
function checkbox4_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox4

D=get(hObject,'Value');

if D==1
   
    set(handles.uipanel3,'visible','on')
    
    
else
    
  set(handles.uipanel3,'visible','off')  
    
end


% --- Executes when selected object is changed in uibuttongroup8.
function uibuttongroup8_SelectionChangedFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uibuttongroup8 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);



newButton=get(eventdata.NewValue,'tag');

switch newButton
    
case 'radioprof' %line swath plot

    handles.selp=1;
    
case 'radioarea' %grey swath plot 
      
     handles.selp=2;
        
end

guidata(hObject, handles);


% --- Executes when selected object is changed in uibuttongroup7.
function uibuttongroup7_SelectionChangedFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uibuttongroup7 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);

newButton=get(eventdata.NewValue,'tag');

switch newButton
    
case 'stair' %line swath plot
maping=1;
    
case 'cliff' %grey swath plot 
maping=2;
      
case 'stack' %grey swath plot 
 maping=3;
         
case 'dif' %grey swath plot 
maping=4;
             
end

handles.maping=maping;

guidata(hObject, handles);


% --- Executes on button press in checkbox5.
function checkbox5_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox5
handles = guidata(hObject);

handles.update=get(hObject,'Value');

guidata(hObject, handles);


% --- Executes on button press in radioprof.
function radioprof_Callback(hObject, eventdata, handles)
% hObject    handle to radioprof (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radioprof


% --- Executes on button press in catalog.
function catalog_Callback(hObject, eventdata, handles), global Box Cs num txtab Zonen
% hObject    handle to catalog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
%load data

maindir=handles.maindir;
DEM=handles.DEM;
here=pwd;

cd(maindir)
cd('World_terraces')
[num,txtab,raw]=xlsread('Database_10_04_2018.xls');
cd(maindir)
cd('coastline')
Cs=shaperead('ne_10m_coastline.shp');
cd(here)

Box=handles.box;


try
Zn=DEM.georef.GeoKeyDirectoryTag.PCSCitationGeoKey;
newStr = split(Zn);
Zonen=newStr{6};

catch
%manual input utmzone
Zonen=utmzone;

end

try
TerraceM_Catalog
catch
    disp('aborted')
end

guidata(hObject, handles);
