function varargout = TerraceM_Profilebox(varargin)
% TERRACEM_PROFILEBOX MATLAB code for TerraceM_Profilebox.fig
%      TERRACEM_PROFILEBOX, by itself, creates a new TERRACEM_PROFILEBOX or raises the existing
%      singleton*.
%
%      H = TERRACEM_PROFILEBOX returns the handle to a new TERRACEM_PROFILEBOX or the handle to
%      the existing singleton*.
%
%      TERRACEM_PROFILEBOX('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TERRACEM_PROFILEBOX.M with the given input arguments.
%
%      TERRACEM_PROFILEBOX('Property','Value',...) creates a new TERRACEM_PROFILEBOX or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TerraceM_Profilebox_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TerraceM_Profilebox_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TerraceM_Profilebox

% Last Modified by GUIDE v2.5 06-Feb-2018 09:53:41

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TerraceM_Profilebox_OpeningFcn, ...
                   'gui_OutputFcn',  @TerraceM_Profilebox_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before TerraceM_Profilebox is made visible.
function TerraceM_Profilebox_OpeningFcn(hObject, eventdata, handles, varargin),global SS1 SS2 SS3 SS4 SS5
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TerraceM_Profilebox (see VARARGIN)

% Choose default command line output for TerraceM_Profilebox
handles.output = hObject;

handles.maindir=SS1.maindir;
handles.station=SS2.station;
handles.statpath=SS3.statpath;
handles.swaths=SS4.swat;
handles.dem=SS5.DEM;
handles.lines=1;

nim=numel(handles.swaths);
%load('terracem_path.mat');

%handles.maindir=terracem_dir;
%handles.PathName=PathName;
%handles.topotool=topotool;
%handles.station=station;
%handles.swatpathname=swathpathname;
%handles.shapefile=shapefile;

%cd(handles.swatpathname);
%loas shapefiles
%Box=shaperead(sprintf('%s',handles.shapefile));
%handles.box=Box;
%nim=numel(Box);

%cd(PathName)
%cd(handles.station)
%cd(handles.statpath)

%load(sprintf('%s_swath.mat',handles.station));
%handles.swaths=swath;


%load(sprintf('%s_dem.mat',handles.station));
%handles.dem=DEM;

try
load(sprintf('%s_SHORELINES.mat',handles.station));
handles.shore=SHORELINE;
catch
disp('NO SHORELINES')
end


 
axes(handles.ax2)
DEMr=handles.dem;  
resize=DEMr.size(1)/100;
%subsample
DEMrs=resample(DEMr,DEMr.cellsize*resize);
imageschs(DEMrs,[],'colorbar',false,'colormap','parula','exaggerate',2,'percentclip',5,'ticklabels','nice');

%add number of profiles to handles
af=(1:nim);
a=num2cell(af);
set(handles.listbox2,'string', a)

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes TerraceM_Profilebox wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = TerraceM_Profilebox_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



% --- Executes on button press in slection.
function slection_Callback(hObject, eventdata, handles)
% hObject    handle to slection (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%save as pdf
handles.output = hObject;

profile=handles.prof;
nim=numel(handles.swaths);
DEM=handles.dem;
station=handles.station;
swat=handles.swaths;
SHORELINE=handles.shore;

f1=figure;
cla

if handles.lines==1
hold on, box on
plot(swat(profile).x,swat(profile).z_min,'-k');
plot(swat(profile).x,swat(profile).z_max,'-k');
plot(swat(profile).x,swat(profile).z_mean,'-k');
else
hold on, box on
U7=area(swat(profile).x,swat(profile).z_max);
U6=area(swat(profile).x,swat(profile).z_min);
set(U7,'FaceColor',[0.6 0.6 0.6],'edgeColor',[0.6 0.6 0.6]);
set(U6,'FaceColor',[1 1 1],'edgeColor',[0.6 0.6 0.6]);
set(gca,'Layer','top')

plot(swat(profile).x,swat(profile).z_min,'-k')
plot(swat(profile).x,swat(profile).z_max,'-k')
plot(swat(profile).x,swat(profile).z_mean,'-k')
    
end
 
try
 lev=numel(SHORELINE(profile).level);
 for j=1:lev
     %staircase
     X=SHORELINE(profile).level(j).DISTANCE_PROFILE;
     Z=SHORELINE(profile).level(j).ELEVATION;
     Ze=SHORELINE(profile).level(j).ERROR;     
     clif=SHORELINE(profile).met(j).REGRESSIONS.cliff;
     plat=SHORELINE(profile).met(j).REGRESSIONS.plat;

     %regression
     hold on
     plot(clif(:,1),clif(:,2),'-r');plot(clif(:,1),clif(:,3),'--r');plot(clif(:,1),clif(:,4),'--r')
     plot(plat(:,1),plat(:,2),'-r');plot(plat(:,1),plat(:,3),'--r');plot(plat(:,1),plat(:,4),'--r')
     %shoreline angle
     hold on
     errorbar(X,Z,Ze,'k')
     plot(X,Z,'o','MarkerFaceColor','r','MarkerSize',8,'MarkerEdgeColor','k')
     

     Zone=gca;
     xlimit=Zone.XLim; xl=xlimit(2)-xlimit(1);
     ylimit=Zone.YLim; yl=ylimit(2)-ylimit(1);
     y=Z+yl/10;
     x=X-xl/10;
     text(x,y,sprintf('%.2f $\\pm$ %.2f m ',Z,Ze),'interpreter','latex')
     
 end
    
catch
   disp('No shorelines') 
end
 
xlim([min(swat(profile).x),max(swat(profile).x)])
ylim([min(swat(profile).z_min),max(swat(profile).z_max)])
xlabel('Elevation (m)')
ylabel('Distance along profile (m)')

%check or add new folder PDF
%craete folders
Outdir=sprintf('%s_PDFs',handles.station);
if exist(Outdir,'dir')==7
else
mkdir(Outdir);
end

here=pwd;
cd(Outdir)

%set output
rect=[1 2 18 14];
set(gcf,'paperunits','centimeters','papertype','A4','paperposition',rect); 
fout = sprintf('%s_profile%u',station,profile);
saveas(gcf,fout,'pdf');
    
close(f1) 
cd(here)
guidata(hObject, handles);



% --- Executes on selection change in listbox2.
function listbox2_Callback(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox2
handles = guidata(hObject);

contents = cellstr(get(hObject,'String')); %returns stationslist contents as cell array
prof=char(contents{get(hObject,'Value')}); %returns selected item from stationslist
profile=str2double(prof);
handles.prof=profile;


%Box=handles.box;
nim=numel(handles.swaths);
DEM=handles.dem;
station=handles.station;
swat=handles.swaths;
%create swath
%swat=TerraceM_makeswath(DEM,Box,profile);  
%load shorelines
%(sprintf('%s_swath',station));

%figure
axes(handles.ax3)

cla

if handles.lines==1
hold on, box on
plot(swat(profile).x,swat(profile).z_min,'-k');
plot(swat(profile).x,swat(profile).z_max,'-k');
plot(swat(profile).x,swat(profile).z_mean,'-k');
else
hold on, box on
U7=area(swat(profile).x,swat(profile).z_max);
U6=area(swat(profile).x,swat(profile).z_min);
set(U7,'FaceColor',[0.6 0.6 0.6],'edgeColor',[0.6 0.6 0.6]);
set(U6,'FaceColor',[1 1 1],'edgeColor',[0.6 0.6 0.6]);
set(gca,'Layer','top')

plot(swat(profile).x,swat(profile).z_min,'-k')
plot(swat(profile).x,swat(profile).z_max,'-k')
plot(swat(profile).x,swat(profile).z_mean,'-k')
    
end

try
 SHORELINE=handles.shore;
 lev=numel(SHORELINE(profile).level);
 for j=1:lev
     
     X=SHORELINE(profile).level(j).DISTANCE_PROFILE;
     Z=SHORELINE(profile).level(j).ELEVATION;
     Ze=SHORELINE(profile).level(j).ERROR;
     
     if strcmp(SHORELINE(profile).met(j).METHOD,'staircase')==1 || strcmp(SHORELINE(profile).met(j).METHOD,'cliff')==1
     
     %staircase % cliff
     clif=SHORELINE(profile).met(j).REGRESSIONS.cliff;
     plat=SHORELINE(profile).met(j).REGRESSIONS.plat;
     
     
     %regression
     hold on
     plot(clif(:,1),clif(:,2),'-r');plot(clif(:,1),clif(:,3),'--r');plot(clif(:,1),clif(:,4),'--r')
     plot(plat(:,1),plat(:,2),'-r');plot(plat(:,1),plat(:,3),'--r');plot(plat(:,1),plat(:,4),'--r')
     %shoreline angle
     hold on
     errorbar(X,Z,Ze,'k')
     plot(X,Z,'o','MarkerFaceColor','r','MarkerSize',8,'MarkerEdgeColor','k')    
     else
     end
     
     
     
     if strcmp(SHORELINE(profile).met(j).METHOD,'stack')==1
     
     plat=SHORELINE(profile).met(j).REGRESSIONS.plat;
     plot(plat(:,1),plat(:,2),'--r')   
     errorbar(X,Z,Ze,'k')
     plot(X,Z,'o','MarkerFaceColor','r','MarkerSize',8,'MarkerEdgeColor','k')  
     end
     
     Zone=gca;
     xlimit=Zone.XLim; xl=xlimit(2)-xlimit(1);
     ylimit=Zone.YLim; yl=ylimit(2)-ylimit(1);
     y=Z+yl/10;
     x=X-xl/10;
     text(x,y,sprintf('%.2f $\\pm$ %.2f m ',Z,Ze),'interpreter','latex')
  
     
     
 end
    
catch
   disp('No shorelines') 
end

xlim([min(swat(profile).x),max(swat(profile).x)])
ylim([min(swat(profile).z_min),max(swat(profile).z_max)])
ylabel('Elevation (m)')
xlabel('Distance along profile (m)')

%inset
axes(handles.ax2)

%limits
mnx=min(swat(profile).prof_X);
mxx=max(swat(profile).prof_X);
mdx=(mxx-mnx)/3;
mny=min(swat(profile).prof_Y);
mxy=max(swat(profile).prof_Y);
mdy=(mxy-mny)/5;

axis equal
hold on

for j=1:nim
hold on
plot(swat(j).prof_X,swat(j).prof_Y,'-k')    
end
hold on
plot(swat(profile).prof_X,swat(profile).prof_Y,'-r')


axis square

%xlim([mnx-mdx,mxx+mdx]);
%ylim([mny-mdy,mxy+mdy]);

%save
handles.profile=profile;
handles.swatsel=swat(profile);

handles.output = hObject;
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function listbox2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function uibuttongroup1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uibuttongroup1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles = guidata(hObject);
guidata(hObject, handles);


% --- Executes when selected object is changed in uibuttongroup1.
function uibuttongroup1_SelectionChangedFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uibuttongroup1 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
newButton=get(eventdata.NewValue,'tag');

station=handles.station;
profile=handles.profile;
swat=handles.swaths;
try
SHORELINE=handles.shore;
catch
end


%load(sprintf('%s_swaths',station));

switch newButton
    
case 'rb1'  
handles.lines=1;
handles.area=0;

%Fig
axes(handles.ax3)
cla
hold on, box on
obj.h=plot(swat(profile).x,swat(profile).z_min,'-k');
obj.j=plot(swat(profile).x,swat(profile).z_max,'-k');
obj.k=plot(swat(profile).x,swat(profile).z_mean,'-k');

try
 lev=numel(SHORELINE(profile).level);
 

 for j=1:lev
     %staircase
     X=SHORELINE(profile).level(j).DISTANCE_PROFILE;
     Z=SHORELINE(profile).level(j).ELEVATION;
     Ze=SHORELINE(profile).level(j).ERROR;
  
     clif=SHORELINE(profile).met(j).REGRESSIONS.cliff;
     plat=SHORELINE(profile).met(j).REGRESSIONS.plat;
     %regression
     hold on
     plot(clif(:,1),clif(:,2),'-r');plot(clif(:,1),clif(:,3),'--r');plot(clif(:,1),clif(:,4),'--r')
     plot(plat(:,1),plat(:,2),'-r');plot(plat(:,1),plat(:,3),'--r');plot(plat(:,1),plat(:,4),'--r')
     errorbar(X,Z,Ze,'k')
     plot(X,Z,'s','MarkerFaceColor','r','MarkerSize',8,'MarkerEdgeColor','k')  
     
     Zone=gca;
     xlimit=Zone.XLim; xl=xlimit(2)-xlimit(1);
     ylimit=Zone.YLim; yl=ylimit(2)-ylimit(1);
     y=Z+yl/10;
     x=X-xl/10;
     text(x,y,sprintf('%.2f $\\pm$ %.2f m ',Z,Ze),'interpreter','latex')
 end
    
catch
   disp('No shorelines') 
end
xlabel('Elevation (m)')
ylabel('Disntance along profile (m)')
xlim([min(swat(profile).x) max(swat(profile).x)]); 
%ylim([min(swat(profile).z_min) max(swat(profile).z_max)])
refreshdata(obj.h)
drawnow


case 'rb2'
handles.lines=0;
handles.area=1; 

%fig
axes(handles.ax3)
cla
hold on, box on
U7=area(swat(profile).x,swat(profile).z_max);
U6=area(swat(profile).x,swat(profile).z_min);
set(U7,'FaceColor',[0.6 0.6 0.6],'edgeColor',[0.6 0.6 0.6]);
set(U6,'FaceColor',[1 1 1],'edgeColor',[0.6 0.6 0.6]);
set(gca,'Layer','top')

plot(swat(profile).x,swat(profile).z_min,'-k')
plot(swat(profile).x,swat(profile).z_max,'-k')
plot(swat(profile).x,swat(profile).z_mean,'-k')

try
 lev=numel(SHORELINE(profile).level);
 for j=1:lev
     %staircase
     X=SHORELINE(profile).level(j).DISTANCE_PROFILE;
     Z=SHORELINE(profile).level(j).ELEVATION;
     Ze=SHORELINE(profile).level(j).ERROR;
     hold on
     errorbar(X,Z,Ze,'k')
     plot(X,Z,'s','MarkerFaceColor','r','MarkerSize',8,'MarkerEdgeColor','k')    
 
     clif=SHORELINE(profile).met(j).REGRESSIONS.cliff;
     plat=SHORELINE(profile).met(j).REGRESSIONS.plat;
     %regression
     hold on
     plot(clif(:,1),clif(:,2),'-r');plot(clif(:,1),clif(:,3),'--r');plot(clif(:,1),clif(:,4),'--r')
     plot(plat(:,1),plat(:,2),'-r');plot(plat(:,1),plat(:,3),'--r');plot(plat(:,1),plat(:,4),'--r')
 
          Zone=gca;
     xlimit=Zone.XLim; xl=xlimit(2)-xlimit(1);
     ylimit=Zone.YLim; yl=ylimit(2)-ylimit(1);
     y=Z+yl/10;
     x=X-xl/10;
     text(x,y,sprintf('%.2f $\\pm$ %.2f m ',Z,Ze),'interpreter','latex')
     
 end
    
catch
   disp('No shorelines') 
end

xlabel('Elevation (m)')
ylabel('Disntance along profile (m)')
xlim([min(swat(profile).x) max(swat(profile).x)]); 
    
end

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function pushbutton10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
