function varargout = TerraceM_Projectplot(varargin)
% TERRACEM_PROJECTPLOT MATLAB code for TerraceM_Projectplot.fig
%      TERRACEM_PROJECTPLOT, by itself, creates a new TERRACEM_PROJECTPLOT or raises the existing
%      singleton*.
%
%      H = TERRACEM_PROJECTPLOT returns the handle to a new TERRACEM_PROJECTPLOT or the handle to
%      the existing singleton*.
%
%      TERRACEM_PROJECTPLOT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TERRACEM_PROJECTPLOT.M with the given input arguments.
%
%      TERRACEM_PROJECTPLOT('Property','Value',...) creates a new TERRACEM_PROJECTPLOT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TerraceM_Projectplot_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TerraceM_Projectplot_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TerraceM_Projectplot

% Last Modified by GUIDE v2.5 17-May-2019 12:25:06

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TerraceM_Projectplot_OpeningFcn, ...
                   'gui_OutputFcn',  @TerraceM_Projectplot_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before TerraceM_Projectplot is made visible.
function TerraceM_Projectplot_OpeningFcn(hObject, eventdata, handles, varargin), global st1 st2 st3 st4 
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TerraceM_Projectplot (see VARARGIN)

% Choose default command line output for TerraceM_Projectplot
handles.output = hObject;

handles.station=st1.station;
handles.statpath=st2.statpath;
handles.box=st3.box;
handles.dem=st4.DEM;

%gui handles
%handles.resoluti=6;
handles.azimuti=315;
handles.exa=1;
handles.savepro=0;

%profiles
Box=handles.box;
nim=numel(Box);

%colors
load('Colorslpdir.mat')
handles.GX=GX;
%addpath(handles.statpath)
%load(sprintf('%s_dem.mat',handles.station));
%DEM.Z(DEM.Z<0) = nan;
%handles.dem=DEM;
DEM=handles.dem;

resolution=DEM.cellsize*DEM.size(1)/1000;
set(handles.edit1,'string',num2str(resolution))
handles.resoluti=resolution;
%plot
axes(handles.ax1)
DEMr=resample(DEM,DEM.cellsize*resolution);
hillshade(DEMr,'azimuth',handles.azimuti,'exaggerate',handles.exa)

hold on
%plot profiles
for i=1:nim
obj.h=plot(Box(i).X,Box(i).Y,'k-');
hold on
end

obj = scalebar;
obj.XUnit = 'm';
axis equal

%%%% plot shorelines
fileid=sprintf('%s_SHORELINES.mat',handles.station);

if exist(fileid,'file')==0 
else
load(fileid)
k=1;

for prof=1:numel(SHORELINE)    
    for level=1:numel(SHORELINE(prof).level)
    shore=SHORELINE(prof).level(level);
    
    if isempty(shore.UTM_X)==1
    md1(k,1)=NaN;%x
    md1(k,2)=NaN;%y
    md1(k,3)=NaN;%Z
    md1(k,4)=NaN;%Ze
    md1(k,5)=NaN;%level      
    else       
    md1(k,1)=shore.UTM_X;%x
    md1(k,2)=shore.UTM_Y;%y
    md1(k,3)=shore.ELEVATION;%Z
    md1(k,4)=shore.ERROR;%Ze
    md1(k,5)=shore.LEVEL;%level    
    end
    
    k=k+1;
     
    Un=unique(md1(:,5));
    Un(isnan(Un))=[];  
    nmj=numel(Un);
    CM = jet(nmj);

    for j=1:nmj   
    hold on
    plot(md1(md1(:,5)==Un(j),1),md1(md1(:,5)==Un(j),2),'ok','Markerfacecolor',CM(j,:),'MarkerEdgeColor','k')
    end    
    end
end
handles.md1=md1;
end


%%% shorelines plot

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes TerraceM_Projectplot wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = TerraceM_Projectplot_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double
handles = guidata(hObject);
handles.resoluti=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double

handles = guidata(hObject);
handles.azimuti=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double

handles = guidata(hObject);
handles.exa=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
station=handles.station;
lm=gca;

f=figure;

df=subplot(5,1,1:5);
axis equal
fig1 = get(handles.ax1,'children');
copyobj(fig1,df);

ylim(lm.YLim)
xlim(lm.XLim)

%check or add new folder PDF
%craete folders
Outdir=sprintf('%s_PDFs',handles.station);
if exist(Outdir,'dir')==7
else
mkdir(Outdir);
end

here=pwd;
cd(Outdir)


rect=[1,2,18,25]; %[xmin ymin width height]
set(gcf,'PaperType','A4');
set(gcf,'PaperUnits','centimeters'); 
set(gcf,'Paperposition',rect);
fout4 = sprintf('%s_PROJECTPLOT.pdf',station);
saveas(gcf,fout4,'pdf')
close(f)
cd(here)

guidata(hObject, handles);


function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double


% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when selected object is changed in uibuttongroup1.
function uibuttongroup1_SelectionChangedFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uibuttongroup1 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
Box=handles.box;
station=handles.station;
nim=numel(Box);

newButton=get(eventdata.NewValue,'tag');
DEM=handles.dem;
DEMr=resample(DEM,DEM.cellsize*handles.resoluti);
station=handles.station;
GX=handles.GX;

ASP = aspect(DEMr);
G = gradient8(DEMr,'degree');

switch newButton
    
case 'shad' 
    
axes(handles.ax1)
cla
hillshade(DEMr,'azimuth',handles.azimuti,'exaggerate',handles.exa)

%hillshade(DEMr,'azimuth',handles.azimuti,'exaggerate',handles.exa,'altitude',40)
hold on

%legend
axis equal
obj = scalebar;
obj.XUnit = 'm';
hbb=colorbar('Visible','off');

cla(handles.ax2)
set(handles.ax2,'visible','off')

case 'color' 
cla(handles.ax2)
set(handles.ax2,'visible','off')
axes(handles.ax1)
cla
imageschs(DEMr,[],'colorbar',true,'colormap','landcolor','exaggerate',handles.exa,'percentclip',5,'azimuth',handles.azimuti,'nancolor',[1 1 1]);
hold on

%legend
axis equal
obj = scalebar;
obj.XUnit = 'm';

hcb=colorbar;
colorTitleHandle = get(hcb,'Title');
set(colorTitleHandle ,'String','Elevation (m)');
    
case 'slope' 
cla(handles.ax2)
set(handles.ax2,'visible','off')
axes(handles.ax1)
cla    
imageschs(DEMr,G,'colorbar',true,'colormap','summer','percentclip',15,'exaggerate',handles.exa,'nancolor',[1 1 1]);
hold on

%legend
axis('equal')
obj = scalebar;
obj.XUnit = 'm';

hcb=colorbar;
colorTitleHandle = get(hcb,'Title');
set(colorTitleHandle ,'String','Slope (deg)');

case 'dirslope' 
  
     
%clasify aspect
C2= reclassify(ASP,'definedintervals',[0,22.5,67.5,112.5,157.5,202.5,247.5,292.5,337.5]);       
C1= reclassify(G,'definedintervals',[0,10,20,40]);       


%C1= reclassify(G,'equalquantiles',4);

    DR2=C1*C2;
    %DR2=plus(C1,C2);
    imageschs(DEMr,DR2,'colorbar',false,'percentclip',1,'colormap',GX,'exaggerate',handles.exa,'nancolor',[1 1 1])
 
%scale
axis('equal')
obj = scalebar;
obj.XUnit = 'm';  
hbb=colorbar('Visible','off');

% Legend
set(handles.ax2,'visible','on')
myImage = imread('Dirslope.jpg');
set(handles.ax2,'Units','pixels');
resizePos = get(handles.ax2,'Position');
myImage= imresize(myImage, [resizePos(3) resizePos(3)]);
axes(handles.ax2);
imshow(myImage);
set(handles.ax2,'Units','normalized');


end

%plot shoreline angles
if handles.shh == 1
    
shapes=handles.shapes;
n=numel(shapes);

for i=1:n
 
md1(i,1)=shapes(i).X;   
md1(i,2)=shapes(i).Y;  
md1(i,3)=shapes(i).Z;  
md1(i,4)=shapes(i).Ze;  
md1(i,5)=shapes(i).level;      
end

handles.md1=md1;
%hold on
%plot(md1(:,1),md1(:,2),'ok','Markerfacecolor','r')

 Un=unique(md1(:,5));
 Un(isnan(Un))=[];
 nmj=numel(Un);
 CM = jet(nmj);


for j=1:nmj   
    hold on
    plot(md1(md1(:,5)==Un(j),1),md1(md1(:,5)==Un(j),2),'ok','Markerfacecolor',CM(j,:),'MarkerEdgeColor','k')
end
 
 


else
fileid=sprintf('%s_SHORELINES.mat',station);


if exist(fileid,'file')==0 
else
load(fileid)
k=1;

for prof=1:numel(SHORELINE)    
    for level=1:numel(SHORELINE(prof).level)
    %X_utm=SHORELINE(prof).level(level).UTM_X;
    %Y_utm=SHORELINE(prof).level(level).UTM_Y;
    shore=SHORELINE(prof).level(level);
    
    hold on
    %plot(X_utm,Y_utm,'ok','Markerfacecolor','r')
    
    
    if isempty(shore.UTM_X)==1
    md1(k,1)=NaN;%x
    md1(k,2)=NaN;%y
    md1(k,3)=NaN;%Z
    md1(k,4)=NaN;%Ze
    md1(k,5)=NaN;%level      
        
    else
        
    md1(k,1)=shore.UTM_X;%x
    md1(k,2)=shore.UTM_Y;%y
    md1(k,3)=shore.ELEVATION;%Z
    md1(k,4)=shore.ERROR;%Ze
    md1(k,5)=shore.LEVEL;%level
    
    end
    
    k=k+1;
     
    Un=unique(md1(:,5));
    Un(isnan(Un))=[];  
    nmj=numel(Un);
    CM = jet(nmj);


    for j=1:nmj   
    hold on
    plot(md1(md1(:,5)==Un(j),1),md1(md1(:,5)==Un(j),2),'ok','Markerfacecolor',CM(j,:),'MarkerEdgeColor','k')
    end
    
    
    
    end
end
handles.md1=md1;
end
end


hold on
%plot profiles
for i=1:nim
plot(Box(i).X,Box(i).Y,'k-');
hold on
end


 

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

f=figure;

if isempty('handles.dp')==0

    try
dp=handles.dp;
    catch
        msgbox('Please draw or load a profile before starting')
    end

%call handles
%shore=handles.shore;

dkm=handles.dkm;
dx=handles.dx;
dy=handles.dy;

hold on
box on


%cartesian plane conditions for profiles
if dx>0 && dy>0  
xlim([-dkm 0])

proj_filt1=dp(dp(:,3)<=0,:);
proj_filt=proj_filt1(proj_filt1(:,3)>=-dkm,:);
a=1; %a is a parameter for data export

elseif dx<0 && dy<0 
xlim([0 dkm/1000]) 

proj_filt1=dp(dp(:,3)>=0,:);
proj_filt=proj_filt1(proj_filt1(:,3)<dkm,:);
a=3;

elseif dx>0 && dy<0  
xlim([-dkm/1000 0]) 

proj_filt1=dp(dp(:,3)<=0,:);
proj_filt=proj_filt1(proj_filt1(:,3)>=-dkm,:);
a=4;

else
xlim([0 dkm/1000]) 
proj_filt1=dp(dp(:,3)>=0,:);    
proj_filt=proj_filt1(proj_filt1(:,3)<=dkm,:);  
a=2;

end

hold on
errorbar(proj_filt(:,3)/1e3,proj_filt(:,4),(proj_filt(:,5)),'ok') 
Un=unique(proj_filt(:,6));
Un(isnan(Un))=[];
nmj=numel(Un);
CM = jet(nmj);


for j=1:nmj   
    hold on
    %plot(proj_filt(proj_filt(:,6)==Un(j),3)/1e3,proj_filt(proj_filt(:,6)==Un(j),4),'o','MarkerEdgeColor','k','MarkerFaceColor',[(j/nmj) 0 1-j/nmj],'markersize',7)%color for shoreine levels   
    plot(proj_filt(proj_filt(:,6)==Un(j),3)/1e3,proj_filt(proj_filt(:,6)==Un(j),4),'color',CM(j,:),'marker','o')

end

ylabel('Elevation (m)')
xlabel('Distance along profile (km)')
title('Projected shorelines')
handles.proj_filt=proj_filt; %constrained and filtered shorelines
handles.yLimits = get(gca,'YLim');  %# Get the range of the y axis
handles.xLimits = get(gca,'XLim');  %# Get the range of the y axis
else
msgbox('No profiles load or drawn yet')    
end   

if handles.savepro==1

%check or add new folder PDF
%craete folders
Outdir=sprintf('%s_PDFs',handles.station);
if exist(Outdir,'dir')==7
else
mkdir(Outdir);
end

here=pwd;
cd(Outdir)


rect=[1,8,20,7]; %[xmin ymin width height]
set(gcf,'PaperType','A4');
set(gcf,'PaperUnits','centimeters'); 
set(gcf,'Paperposition',rect);
fout4 = sprintf('%s_projected_shorelines.pdf',handles.station);
saveas(gcf,fout4,'pdf')
cd(here)
close(f)
    
    
end
    
guidata(hObject, handles); %save handles


% --- Executes on button press in savepro.
function savepro_Callback(hObject, eventdata, handles)
% hObject    handle to savepro (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of savepro
handles = guidata(hObject); %define handles
handles.savepro=get(hObject,'Value');
guidata(hObject, handles);


% --- Executes on button press in shh.
function shh_Callback(hObject, eventdata, handles)
% hObject    handle to shh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of shh
handles = guidata(hObject);
handles.shh=get(hObject,'Value');

try
[dir1,PathName] = uigetfile('*.shp','Select the shorelines shapefile');
shfile=char(dir1);
shpathname=char(PathName);

here=pwd;
cd(shpathname)
handles.shapes=shaperead(shfile);
cd(here)
catch
    disp('Loading shapefile aborted')
end


guidata(hObject, handles);

% --- Executes on button press in color.
function color_Callback(hObject, eventdata, handles)
% hObject    handle to color (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of color


% --- Executes on button press in shad.
function shad_Callback(hObject, eventdata, handles)
% hObject    handle to shad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of shad


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject); %define handles
md=handles.md1;

md(isnan(md(:,1)),:)=[];

axes(handles.ax1)

hold on
[xl1,yl1] = ginput(1);
plot(xl1,yl1,'*g')
[xl2,yl2] = ginput(1);
plot(xl2,yl2,'*g')

l(:,1)=[xl1,xl2];
l(:,2)=[yl1,yl2];

%plot profile
plot(l(:,1),l(:,2),'-g'); %plot of profile
type=1;
dp=projection(l,md,type);
dp=sortrows(dp,3);
%profile geometry
dx=l(1,1)-l(2,1);
dy=l(1,2)-l(2,2);
dkm=sqrt((l(1,1)-l(2,1))^2+(l(1,2)-l(2,2))^2);


%save handles
handles.dp=dp;
handles.dx=dx;
handles.dy=dy;
handles.dkm=dkm;

guidata(hObject, handles); %save handles


% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject); %define handles
% Hint: get(hObject,'Value') returns toggle state of radiobutton12

%load shapefile    
[Filename,PathName]=uigetfile('*.shp','Select shapefile');

here=pwd;

cd(PathName)

    if isequal(Filename,0)
    disp('User selection Canceled')
    return
    
    else
    S4 = shaperead(Filename);    
    l(:,1)=[S4.X];
    l(:,2)=[S4.Y];     
    end
cd(here)    
%plot profile    
hold on
p1=plot(l(:,1),l(:,2),'-g'); %plot of profile
p2=plot(l(1,1),l(1,2),'*g'); %point1
p3=plot(l(2,1),l(2,2),'*g'); %point2

%define profile geometry
dx=l(1,1)-l(2,1);
dy=l(1,2)-l(2,2);
m=(dy/dx);
m2=-1/m;
an=-atan(m)*180/pi;
anr=an*pi/180;
ddg=sqrt((l(1,1)-l(2,1))^2+(l(1,2)-l(2,2))^2);
dkm=(ddg);
b=l(1,2)-m*l(1,1);

%text in plot
str1=num2str(dkm/1000); %m to km
h=text(min(l(:,1))+((max(l(:,1))-min(l(:,1)))/2)-((max(l(:,1))-min(l(:,1)))/25), min(l(:,2))+(max(l(:,2))-min(l(:,2)))/2,sprintf('%s km',str1),'FontSize',12);
h.Color='green';
m2 = atand(m) ;
set(h,'Rotation',m2);



%call handles
md1=handles.md1;

%rotate and reproject data
for i=1:length(md1(:,1))
    b2=md1(i,2)-m2*md1(i,1);
    Pnx=(b2-b)/(m-m2);
    Pny=m*Pnx+b;
    Pn=[Pnx Pny];
    dp(i,1)=Pn(1,1); %xp
    dp(i,2)=Pn(1,2); %yp
    dp(i,3)=((l(1,2)-dp(i,2))/sin(anr)); % distance in km
    dp(i,4)=md1(i,3); %Z
    dp(i,5)=md1(i,4); %Ze
    dp(i,6)=md1(i,5);%shore
end

%save handles
handles.dp=dp;
handles.dx=dx;
handles.dy=dy;
handles.dkm=dkm;
guidata(hObject, handles); %save handles
