function varargout = TerraceM_SCM(varargin)
% TERRACEM_SCM2 MATLAB code for TerraceM_SCM2.fig
%      TERRACEM_SCM2, by itself, creates a new TERRACEM_SCM2 or raises the existing
%      singleton*.
%
%      H = TERRACEM_SCM2 returns the handle to a new TERRACEM_SCM2 or the handle to
%      the existing singleton*.
%
%      TERRACEM_SCM2('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TERRACEM_SCM2.M with the given input arguments.
%
%      TERRACEM_SCM2('Property','Value',...) creates a new TERRACEM_SCM2 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TerraceM_SCM2_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TerraceM_SCM2_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TerraceM_SCM2

% Last Modified by GUIDE v2.5 22-Mar-2019 14:21:01

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TerraceM_SCM2_OpeningFcn, ...
                   'gui_OutputFcn',  @TerraceM_SCM2_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
clc

% --- Executes just before TerraceM_SCM2 is made visible.
function TerraceM_SCM2_OpeningFcn(hObject, eventdata, handles, varargin), global str1 str2 str3 str4 str5 str6
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TerraceM_SCM2 (see VARARGIN)

% Choose default command line output for TerraceM_SCM2
handles.output = hObject;

%parameters default
handles.edit2=10;
handles.maxslope=15;
handles.maxrough=4;
handles.edit6=15;
handles.edit7=4;
handles.minel=8;
handles.maxel=500;
handles.levels=3;
handles.saveshp=0;
handles.tipo=1;
handles.midr=0.5;
handles.madr=0.1;

try
%Golbal parameters
handles.DEM=str1.DEM;
handles.station=str4.station;
handles.statpath=str5.statpath;
handles.maindir=str6.maindir;
disp('TerraceM_SCM')
catch
disp('TerraceM_SCM isolated')
prompt = {'Enter a Station name (do not use spaces)'};
title = 'Manual SCM inputs';    
%dialogs    
answer = inputdlg(prompt,title);      
filterspec = {'*.tif', 'DEM Files (*.tif)'};
[FileName,PathName] = uiget(pwd,'Title','Select the DEM file (*.tif)','ExtensionFilter',filterspec);   
Topotoolbox_path = uigetdir2(pwd,'Select the Topotoolbox folder');
PathName=char(PathName);
FileName=char(FileName);
addpath(Topotoolbox_path{1,1});
addpath(PathName);

h1 = waitbar(0,'Please wait, converting DEM...');
DEM = GRIDobj(FileName);
waitbar(0.5)
DEM.Z(DEM.Z==0)=nan;
DEMe = elevateminima(DEM);
waitbar(0.7)
DEMf = fillsinks(DEMe);
waitbar(0.9)

handles.DEM=DEMf;   
handles.statpath=PathName;

handles.maindir=pwd;
handles.station=answer{1, 1} ; 

fileD1=sprintf('%s_dem.mat',handles.station);
here=pwd;
cd(PathName)
save(fileD1,'DEM')
waitbar(0.99)
close(h1) 

end

%set directories
addpath(handles.maindir)
addpath(handles.statpath)

%load logos
lgt=handles.uipanel6;
axes (lgt);
[cdata,map] = imread('logo.tif'); 
imshow(cdata,map)

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes TerraceM_SCM2 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = TerraceM_SCM2_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
 

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output = hObject;

dems=handles.DEMS;
[dem,x,y]=GRIDobj2mat(dems);

k=1;
%x=x';
%convert mesh to points
%for i=1:numel(x)
%for j=1:numel(y)
%points(k,1) =x(i,1);
%points(k,2) =y(j,1);
%points(k,3)=dem(j,i);
%k=k+1;
%end
%end


M=mesh2kml(x,y,dem,'Zone.kml'); 


guidata(hObject, handles);


function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double
handles = guidata(hObject);
handles.edit2=str2double(get(hObject,'String')); %returns contents of edit2 as a double
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);

station=handles.station;
figure;

 hSub1 = subplot(2,2,1); box on
 title('Slope histogram')
  xlabel('Slope (º)'); ylabel('count')
 hSub2 = subplot(2,2,2); box on
 title('Roughness histogram)')
  xlabel('Roughness'); ylabel('count')
 hSub3 = subplot(2,2,[3, 4]); box on
 title('SCM elevation histogram')
 xlabel('Elevation (m)'); ylabel('count')
 
 fig1 = get(handles.axes1,'children');
 fig2 = get(handles.axes3,'children');
 fig3 = get(handles.axes5,'children');
 
 copyobj(fig1,hSub1);
 copyobj(fig2,hSub2);
 copyobj(fig3,hSub3);

rect=[3,2,16,18]; %[xmin ymin width height]
set(gcf,'PaperType','A4');
set(gcf,'PaperUnits','centimeters'); 
set(gcf,'Paperposition',rect);
fout4 = sprintf('Histograms_%s.pdf',station);
saveas(gcf,fout4,'pdf')

 %Save

function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double
handles = guidata(hObject);
handles.levels=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
guidata(hObject, handles);

histline=handles.histline;
levels=handles.levels;
delta=0.1;
[maxtab, mintab]=peakdet(histline(:,2), delta, histline(:,1));

while numel(maxtab(:,1))~=levels
delta=delta+0.05;
[maxtab, mintab]=peakdet(histline(:,2), delta, histline(:,1));
end

%update
axes(handles.axes5)
ax = gca;
ym=ax.YLim;
xm=ax.XLim;

cla
hold on
plot(histline(:,1),histline(:,2),'-k')
plot(maxtab(:,1),maxtab(:,2),'dk','MarkerFaceColor','r','MarkerSize',10)
%plot(histline(:,1),log(histline(:,2)),'-c')
xlim(xm)
handles.maxtab=maxtab;

guidata(hObject, handles);
% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
guidata(hObject, handles);
maxtab=handles.maxtab;

if length(maxtab(1,:))==2
maxtab(:,3)=zeros;
maxtab(:,4)=1:numel(maxtab(:,1));%add level number
else    
    %do nothing
end

Theader={'Elevation','count','Elevation range','level'};
Tdata = table_dialog(maxtab,Theader,'Shoreline levels and elevation ranges');
handles.maxtab=Tdata;

axes(handles.axes5)
hold on
errorbar(Tdata(:,1),Tdata(:,2),Tdata(:,3)/2,'horizontal','.k')

guidata(hObject, handles);

% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
DEMS=handles.DEMS;%topo SCM
%write geotif
GRIDobj2geotiff(DEMS)

guidata(hObject, handles);

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
guidata(hObject, handles);

%define handles
DEMr=handles.DEMr;
SCM=handles.DEMr;
G=handles.G;
R=handles.R;
maxslope=handles.maxslope;
maxrough=handles.maxrough;
CCA=handles.zoom1;

if handles.tipo==1
%set null high roughness and higher slopes
G.Z(G.Z(:)>maxslope)=NaN;
R.Z(R.Z(:)>maxrough)=NaN;

else
%set null low roughness and lower slopes > isolating cliff
G.Z(G.Z(:)<maxslope)=NaN;
R.Z(R.Z(:)<maxrough)=NaN;

end

%normalize values
G.Z=G.Z/maxslope;
R.Z=R.Z/maxrough;

%combine proportionally using lineal equation
%proportion
Percentage_slope=50;
Percentage_rough=50;

%equation
SCM.Z=(G.Z*(Percentage_slope/10))+(R.Z*(Percentage_rough/10));
handles.SCM=SCM;

set(handles.ubut,'selectedobject',handles.surfcm)

axes(handles.axes4)
imageschs(DEMr,SCM,'colorbar',1,'colorbarlabel','SCM');
ylim(CCA.YLim)
xlim(CCA.XLim)
axis equal

axes(handles.axes5)
cla

guidata(hObject, handles);


% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
guidata(hObject, handles);

DEM1=handles.DEM;
resize=handles.edit2;

DEMr=resample(DEM1,DEM1.cellsize*resize);

%ASP = aspect(DEMr);
G = gradient8(DEMr,'degree');
R   = roughness(DEMr,'tri');
%R = stdfilt(G);

handles.DEMr=DEMr;
handles.G=G;
handles.R=R;



axes(handles.axes1)
%hist(G.Z(:),40,'b');
h = histogram(G.Z(:),'Normalization','count');
h.FaceColor='r';
h.NumBins=40;
xlabel('Slope (deg)')
ylabel('count')
h.EdgeColor=[1 1 1];

handles.h=h;
nper=handles.maxslope;
vline(nper,'k',sprintf('Slope = %.0f',nper));

axes(handles.axes3)
h2 = histogram(R.Z(:),'Normalization','count');
h2.FaceColor='b';
h2.NumBins=40;
h2.EdgeColor=[1 1 1];
xlabel('Roughness')

handles.h2=h2;
nper2=handles.maxrough;
handles.vline=vline(nper2,'k',sprintf('Roughness = %.0f',nper2));
%xlim([0 max(max(max(R.Z(:))))]);
xlim([0 prctile(R.Z(:),99.5)])

axes(handles.axes4)
hillshade(DEMr,'azimuth',315,'exaggerate',2)

handles.zoom1=gca;

guidata(hObject, handles);





% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);

maxslope=handles.maxslope;

DEMr=handles.DEMr;
G=handles.G;
%R=handles.R;

axes(handles.axes4);
CCA=gca;
handles.zoom1=CCA;


axes(handles.axes1);
gca;
%hist(G.Z(:),40,'b');
h = histogram(G.Z(:),'Normalization','count');
h.FaceColor='r';
h.NumBins=40;
h.EdgeColor=[1 1 1];
vline(maxslope,'k',sprintf('Slope = %.1f',maxslope));
xlabel('Slope (deg)')
ylabel('Count)')
set(handles.ubut,'selectedobject',handles.slop);

axes(handles.axes5)
cla

axes(handles.axes4);
cla

%Define ranges

if handles.tipo==1
G.Z(G.Z(:)>maxslope)=NaN;
else
G.Z(G.Z(:)<maxslope)=NaN;    
end

imageschs(DEMr,G,'colormap','hot','colorbar',1,'colorbarlabel','Slope (deg)');
%keep view
ylim(handles.zoom1.YLim)
xlim(handles.zoom1.XLim)
axis equal


guidata(hObject, handles);


% --- Executes on button press in pushbutton11.
function pushbutton11_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);

maxrough=handles.maxrough;
R=handles.R;
DEMr=handles.DEMr;

axes(handles.axes4);
CCA=gca;
handles.zoom1=CCA;

axes(handles.axes3)
cla
%hist(G.Z(:),40,'b');
h = histogram(R.Z(:),'Normalization','count');
h.FaceColor='b';
h.NumBins=40;
h.EdgeColor=[1 1 1];
vline(maxrough,'k',sprintf('Roughness = %.1f',maxrough));
xlabel('Roughness')
xlim([0 prctile(R.Z(:),99.5)])

set(handles.ubut,'selectedobject',handles.roug);

axes(handles.axes4);
cla
%set ranges
if handles.tipo==1
R.Z(R.Z(:)>maxrough)=NaN;
else
R.Z(R.Z(:)<maxrough)=NaN;
end

imageschs(DEMr,R,'colormap','cool','colorbar',1,'colorbarlabel','Roughness');

ylim(CCA.YLim)
xlim(CCA.XLim)
axis equal

axes(handles.axes5)
cla

guidata(hObject, handles);


function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double
handles = guidata(hObject);
handles.maxslope=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double

handles = guidata(hObject);
handles.maxrough=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton13.
function pushbutton13_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
SCM=handles.SCM;
DEMr=handles.DEMr;
station=handles.station;

try
handles = rmfield(handles, 'CR');
handles = rmfield(handles, 'C');
catch
end


C = reclassify(SCM,'definedintervals',[0 10]);
C.Z(C.Z(:)==0)=NaN;
handles.C=C;

set(handles.ubut,'selectedobject',handles.maske);
axes(handles.axes4);
cla
imageschs(DEMr,C,'colorbar',0)
axis equal

try
CCA=handles.zoom1;
ylim(CCA.YLim)
xlim(CCA.XLim)
catch
end

axes(handles.axes5)
cla

%save shapefile for manual editing
if handles.saveshp==1
    
h=waitbar(0.2,'Please wait');    
[MS,x,y] = GRIDobj2polygon(C,'Geometry','Polygon','simplify',true,'tol',0,'multipart',true,'holes',true);

waitbar(0.4)%wait
%craete folders
Outdir=sprintf('%s_EXPORT',handles.station);
if exist(Outdir,'dir')==7
else
mkdir(Outdir);
end

here=pwd;
cd(Outdir)
%%%
waitbar(0.6)%wait

[xcll,ycll] = polysplit(x,y);
npl=numel(xcll);

%attributes table and splitting
for i=1:npl
MSf(i).X=xcll{i,1};
MSf(i).Y=ycll{i,1};
MSf(i).ID=i;
MSf(i).Geometry='Polygon';
end
%

%%%%%%
if handles.tipo==1
shapewrite(MSf, sprintf('%s_PATCH_SCM_plat.shp',handles.station));
else
shapewrite(MSf, sprintf('%s_PATCH_SCM_cliff.shp',handles.station));
    
end

waitbar(0.9)

%%%%%

cd(here)

close(h)

end

guidata(hObject, handles);

% --- Executes on button press in pushbutton14.
function pushbutton14_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);

%SCM=handles.SCM;
DEMr=handles.DEMr;
DEMS=handles.DEMr;
station=handles.station;

try
C=handles.CR;
catch
C=handles.C;
end

maxel=handles.maxel;
minel=handles.minel;

DEMS.Z(isnan(C.Z(:)))=NaN;
%manual constraint
DEMS.Z(DEMS.Z(:)<minel)=NaN;
DEMS.Z(DEMS.Z(:)>maxel)=NaN;

%elevation histogram
axes(handles.axes5);
cla reset
hi=histogram(DEMS.Z);
hi.FaceColor=[0.6 0.6 0.6];
hi.Normalization = 'count';
yval=hi.Values;
xval1=hi.BinLimits;
xval=linspace(xval1(1),xval1(2),numel(yval));
xlabel('Elevation (m)')
ylabel('Count')

%hold on
%plot(xval,yval,'-r')
handles.histline=[xval',yval'];

%plot display
set(handles.ubut,'selectedobject',handles.topomask);

axes(handles.axes4);
cla
imageschs(DEMr,DEMS);
hcb=colorbar;
colorTitleHandle = get(hcb,'Title');
titleString = 'Elevation (m)';
set(colorTitleHandle ,'String',titleString);
axis equal
handles.DEMS=DEMS;%topo SCM

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function uipanel6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles = guidata(hObject);
handles.uipanel6=axis;

guidata(hObject, handles);


% --- Executes on button press in pushbutton16.
function pushbutton16_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
maxtab=handles.maxtab;
DEMS=handles.DEMS;
DEMr=handles.DEMr;
minel=handles.minel;
maxel=handles.maxel;

set(handles.ubut,'selectedobject',handles.tlevs);
axes(handles.axes4);
cla

for i= 1:numel(maxtab(:,1))    
    A(i)=maxtab(i,1)-maxtab(i,3);%calculate range extension
    B(i)=maxtab(i,1)+maxtab(i,3); 
    
        levelin=maxtab(i,4);


C2   = reclassify(DEMS,'definedintervals',[A(i),B(i)]);
C2.Z(C2.Z(:)==0)=NaN;%delete unnecessary levels
C2.Z(C2.Z(:)==3)=NaN;
C2.Z(C2.Z(:)==1)=NaN;
%C2.Z(C2.Z(:)==2)=i;
C2.Z(C2.Z(:)==2)=levelin;%i

%regenrate
Cx(i).Z=C2.Z;
end

clear i
%combine masks
A=Cx(1).Z;
for i=2:numel(maxtab(:,1))
B=Cx(i).Z;
Ct=pegote(A,B);%my special function
A=Ct;%overwrite
end

C2.Z=A;
%imageschs(DEMr,Cx(2),'colorbar',false)
imageschs(DEMr,C2,'colorbar',false)

handles.levelsmap=C2;

guidata(hObject, handles);


function edit8_Callback(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit8 as text
%        str2double(get(hObject,'String')) returns contents of edit8 as a double
handles = guidata(hObject);
handles.minel=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit9_Callback(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit9 as text
%        str2double(get(hObject,'String')) returns contents of edit9 as a double
handles = guidata(hObject);
handles.maxel=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton18.
function pushbutton18_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);

DEMr=handles.DEMr;
G=handles.G;
R=handles.R;

MASK = createmask(DEMr);

DEMb=DEMr;
DEMb.Z(MASK.Z(:)==0)=NaN;
%remove nan
DEMc=comenan(DEMb);


axes(handles.axes4)
cla
hold on
imageschs(DEMc,DEMc,'colormap',[.9 .8 .7],'colorbar',false)
G = gradient8(DEMc,'degree');
R = roughness(DEMc,'tri');

axes(handles.axes1)
%hist(G.Z(:),40,'b');
h = histogram(G.Z(:),'Normalization','count');
h.FaceColor='r';
h.NumBins=40;
h.EdgeColor=[1 1 1];

handles.h=h;
nper=handles.maxslope;
vline(nper,'k');

axes(handles.axes3)
h2 = histogram(R.Z(:),'Normalization','count');
h2.FaceColor='b';
h2.NumBins=40;
h2.EdgeColor=[1 1 1];

handles.h2=h2;
nper2=handles.maxrough;
handles.vline=vline(nper2,'k');

clear handles.DEMr handles.R handles.G
handles.DEMr=DEMc;
handles.G=G;
handles.R=R;
%end
guidata(hObject, handles);


% --- Executes on button press in pushbutton19.
function pushbutton19_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton19 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
levelsmap=handles.levelsmap;
%write geotif
GRIDobj2geotiff(levelsmap)

guidata(hObject, handles);


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1
handles = guidata(hObject);
handles.saveshp=get(hObject,'Value');
disp('handles.saveshp')
guidata(hObject, handles);

% --- Executes on button press in pushbutton20.
function pushbutton20_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);

[dir1,PathName] = uigetfile('*.shp','Select the edited shapefile');
here=pwd;

cd(PathName)
PL=shaperead(dir1); 
cd(here)

DEM=handles.DEM;
C = polygon2GRIDobj(DEM,PL);
%C = reclassify(C1,'definedintervals',[0 10]);
Cd=double(C.Z);
Cd(Cd(:)==0)=NaN;
C.Z=Cd;

try
handles.C=[];
catch
end
handles.C=C;

set(handles.ubut,'selectedobject',handles.maske);
axes(handles.axes4);
cla
imageschs(DEM,C,'colorbar',false)

axes(handles.axes5)
cla

guidata(hObject, handles);


% --- Executes when selected object is changed in uibuttongroup3.
function uibuttongroup3_SelectionChangedFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uibuttongroup3 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
newButton=get(eventdata.NewValue,'tag');

switch newButton
    
case 'clasic' %line swath plot

    handles.tipo=1;
    
case 'inv' %grey swath plot 
      
     handles.tipo=2;
        
end

guidata(hObject, handles);


% --- Executes on button press in pushbutton21.
function pushbutton21_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);

DEMr=handles.DEMr;
C=handles.C;
mindr=handles.midr;%min area drainage
mandr=handles.madr;%max buffer length

%extract river network
FD = FLOWobj(DEMr);
S  = STREAMobj(FD,'unit','mapunits','minarea',mindr*1e6);%mapunits=meters
SS = STREAMobj2GRIDobj(S);


[zmax,mask] = maplateral(S,DEMr,mandr*1e3,@max);

C.Z(mask.Z(:)==1)=NaN;
C.Z(SS.Z(:)==1)=NaN;

axes(handles.axes4)
cla
hold on
imageschs(DEMr,C,'colorbar',false)
%imageschs(DEMr,mask)
%plot(S,'b','LineWidth',1.5)
colorbar('off')
axis equal

axes(handles.axes5)
cla
hold on
box on
imageschs(DEMr,mask)
plot(S,'b','LineWidth',1.5)
colorbar('off')
axis equal

handles.DEMr=DEMr;
handles.CR=C;
xlabel('')
ylabel('')
guidata(hObject, handles);


function edit10_Callback(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit10 as text
%        str2double(get(hObject,'String')) returns contents of edit10 as a double

handles = guidata(hObject);
handles.midr=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit11_Callback(hObject, eventdata, handles)
% hObject    handle to edit11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit11 as text
%        str2double(get(hObject,'String')) returns contents of edit11 as a double

handles = guidata(hObject);
handles.madr=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
