function varargout = TerraceM_SCM_staircase(varargin)
% TERRACEM_SCM_STAIRCASE MATLAB code for TerraceM_SCM_staircase.fig
%      TERRACEM_SCM_STAIRCASE, by itself, creates a new TERRACEM_SCM_STAIRCASE or raises the existing
%      singleton*.
% varargin
%      H = TERRACEM_SCM_STAIRCASE returns the handle to a new TERRACEM_SCM_STAIRCASE or the handle to
%      the existing singleton*.
%
%      TERRACEM_SCM_STAIRCASE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TERRACEM_SCM_STAIRCASE.M with the given input arguments.
%
%      TERRACEM_SCM_STAIRCASE('Property','Value',...) creates a new TERRACEM_SCM_STAIRCASE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TerraceM_SCM_staircase_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TerraceM_SCM_staircase_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TerraceM_SCM_staircase

% Last Modified by GUIDE v2.5 16-Sep-2019 09:32:10

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TerraceM_SCM_staircase_OpeningFcn, ...
                   'gui_OutputFcn',  @TerraceM_SCM_staircase_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
clc

% --- Executes just before TerraceM_SCM_staircase is made visible.
function TerraceM_SCM_staircase_OpeningFcn(hObject, eventdata, handles, varargin), global str1 str2 str3 str4
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TerraceM_SCM_staircase (see VARARGIN)

% Choose default command line output for TerraceM_SCM_staircase
handles.output = hObject;

%default handles
handles.edit2=1;
handles.maxslope=15;
handles.maxrough=4;
handles.edit6=15;
handles.edit7=4;
handles.minel=8;
handles.maxel=500;
handles.levels=3;
handles.prof=1;

%global
handles.DEMi=str1.DEM;
handles.swat=str2.swat;
handles.box=str3.box;
handles.station=str4.station;
disp('TerraceM_SCM')


%load logos
lgt=handles.axes6;
axes (lgt);
[cdata,map] = imread('logo2.tif'); 
imshow(cdata,map)

%populate listbox
%only put folder names new version
nameFolds=1:numel(handles.swat);
set(handles.listbox1,'string', nameFolds) % define listbox_1 elements (Stations)


%check pre mapping existence
fileid=sprintf('%s_SCM.mat',handles.station);

if exist(fileid,'file')==2
    load(fileid)

nscm=numel(SCM);
nswat=numel(handles.swat);

if nscm==nswat  
Info=('All profiles mapped, go to "PROCESS PROFILES"');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell);  
else 
nrem=nswat-nscm;
Info=sprintf('%s profiles not yet mapped',num2str(nrem));
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell);      
end

end


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes TerraceM_SCM_staircase wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = TerraceM_SCM_staircase_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double
handles = guidata(hObject);
handles.edit2=str2double(get(hObject,'String')); %returns contents of edit2 as a double
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double
handles = guidata(hObject);
handles.levels=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
guidata(hObject, handles);

histline=handles.histline;
levels=handles.levels;
delta=0.1;
[maxtab, mintab]=peakdet(histline(:,2), delta, histline(:,1));

try
    
while numel(maxtab(:,1))~=levels
delta=delta+0.05;
[maxtab, mintab]=peakdet(histline(:,2), delta, histline(:,1));
end

catch

Info=('Imposible finding the number of levels requested');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell);  


end


%update
axes(handles.axes5)
ax = gca;
ym=ax.YLim;
xm=ax.XLim;

cla
hold on
plot(histline(:,1),histline(:,2),'-k')
plot(maxtab(:,1),maxtab(:,2),'dk','MarkerFaceColor','r','MarkerSize',10)
xlim(xm);
xlabel('Elevation (m)'),ylabel('count')
handles.maxtab=maxtab;

Info=('Now set elevation ranges and assign levels');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell); 


guidata(hObject, handles);


% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
guidata(hObject, handles);
maxtab=handles.maxtab;

if length(maxtab(1,:))==2
maxtab(:,3)=zeros;%zeros to fill empty cells
maxtab(:,4)=1:numel(maxtab(:,1));%add level number
else    
    %do nothing
end

Theader={'Elevation','count','Elevation range','level'};
Tdata = table_dialog(maxtab,Theader,'Shoreline levels and elevation ranges');
handles.maxtab=Tdata;
histline=handles.histline;

axes(handles.axes5)
ax = gca;
ym=ax.YLim;
xm=ax.XLim;

cla
hold on
errorbar(Tdata(:,1),Tdata(:,2),Tdata(:,3)/2,'horizontal','.k')
hold on
plot(histline(:,1),histline(:,2),'-k')
plot(Tdata(:,1),Tdata(:,2),'dk','MarkerFaceColor','r','MarkerSize',10)

xlim(xm)
xlabel('Elevation (m)'),ylabel('count')


guidata(hObject, handles);


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
guidata(hObject, handles);

%define handles
DEM=handles.DEM;
SCM=handles.DEM;
G=handles.G;
R=handles.R;
maxslope=handles.maxslope;
maxrough=handles.maxrough;
Box=handles.box;
profile=handles.prof;

%set null high roughness and higher slopes
G.Z(G.Z(:)>maxslope)=NaN;
R.Z(R.Z(:)>maxrough)=NaN;

%normalize values
G.Z=G.Z/maxslope;
R.Z=R.Z/maxrough;

%combine proportionally using lineal equation
%proportion
Percentage_slope=50;
Percentage_rough=50;

%equation
SCM.Z=(G.Z*(Percentage_slope/10))+(R.Z*(Percentage_rough/10));

set(handles.ubut,'selectedobject',handles.surfcm)

axes(handles.axes4)
imageschs(DEM,SCM);
hold on
plot(Box(profile).X,Box(profile).Y,'-k')
xlim(handles.xlim)
ylim(handles.ylim)

handles.SCM=SCM;

axes(handles.axes5)
cla


Info=('The SCM linearly combine the values of slope and roughness lower than the thresholds, the SCM display the areas of low slope and smooth topography');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell); 


guidata(hObject, handles);


% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
guidata(hObject, handles);

DEM1=handles.DEMi;
resize=handles.edit2;
swath=handles.swat;
Box=handles.box;
profile=handles.prof;

%crop
DEMrc=swath(profile).SDEM;
%I=polygon2GRIDobj(DEMr,Box(profile));
%DEMrc.Z(I.Z(:)==0)=NaN;

%subsample
DEMr=resample(DEMrc,DEM1.cellsize*resize);

G = gradient8(DEMr,'degree');
R   = roughness(DEMr,'tri');
%R = stdfilt(G);
clear handles.DEM

%update
handles.DEM=DEMr;
handles.G=G;
handles.R=R;

%ranges
xm=min(Box(profile).X);xn=max(Box(profile).X);
ym=min(Box(profile).Y);yn=max(Box(profile).Y);
dx=(xn-xm)/12;
dy=(yn-ym)/12;

%plot
axes(handles.axes4)
cla
%hillshade(handles.DEM,'azimuth',315,'exaggerate',2) %'nancolor',[1 1 1]
imageschs(DEMr,[],'colormap','landcolor','nancolor',[1 1 1]);

hold on
plot(Box(profile).X,Box(profile).Y,'-r')
handles.xlim=[xm-dx xn+dx];
handles.ylim=[ym-dx yn+dx];
xlim(handles.xlim)
ylim(handles.ylim)

axis('equal')


axes(handles.axes1)
%hist(G.Z(:),40,'b');
h = histogram(G.Z(:),'Normalization','count');
h.FaceColor='r';
h.NumBins=40;
h.EdgeColor=[1 1 1];

handles.h=h;
nper=handles.maxslope;
vline(nper,'k');
xlabel('Slope (º)'), ylabel('count')

axes(handles.axes3)
h2 = histogram(R.Z(:),'Normalization','count');
h2.FaceColor='b';
h2.NumBins=40;
h2.EdgeColor=[1 1 1];
xlabel('Roughness (º)'), ylabel('count')

handles.h2=h2;
nper2=handles.maxrough;
handles.vline=vline(nper2,'k');


Info=('Set Slope and Roughness thresholds to create the SCM');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell); 


guidata(hObject, handles);



% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);

maxslope=handles.maxslope;
Box=handles.box;
profile=handles.prof;
DEM=handles.DEM;
G=handles.G;
%R=handles.R;

axes(handles.axes1);
gca;
%hist(G.Z(:),40,'b');
h = histogram(G.Z(:),'Normalization','count');
h.FaceColor='r';
h.NumBins=40;
h.EdgeColor=[1 1 1];
vline(maxslope,'k');


set(handles.ubut,'selectedobject',handles.slop);
axes(handles.axes4);
cla

%G2=G<maxslope;
G.Z(G.Z(:)>maxslope)=NaN;
imageschs(DEM,G,'colormap','hot');
hold on
plot(Box(profile).X,Box(profile).Y,'-k')
xlim(handles.xlim)
ylim(handles.ylim)


axes(handles.axes5)
cla

Info=('Slope threshold has been defined, if is ok proceed to "Set Roughness"');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell); 

guidata(hObject, handles);


% --- Executes on button press in pushbutton11.
function pushbutton11_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);

maxrough=handles.maxrough;
R=handles.R;
DEM=handles.DEM;
Box=handles.box;
profile=handles.prof;

axes(handles.axes3)
cla
%hist(G.Z(:),40,'b');
h = histogram(R.Z(:),'Normalization','count');
h.FaceColor='b';
h.NumBins=40;
h.EdgeColor=[1 1 1];

vline(maxrough,'k');

set(handles.ubut,'selectedobject',handles.roug);
axes(handles.axes4);
cla

R.Z(R.Z(:)>maxrough)=NaN;
imageschs(DEM,R,'colormap','cool');
hold on
plot(Box(profile).X,Box(profile).Y,'-k')
xlim(handles.xlim)
ylim(handles.ylim)


axes(handles.axes5)
cla

Info=('Roughness threshold has been defined, if is ok proceed to "Calculate SCM panel"');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell); 

guidata(hObject, handles);


function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double
handles = guidata(hObject);
handles.maxslope=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double

handles = guidata(hObject);
handles.maxrough=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton13.
function pushbutton13_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
SCM=handles.SCM;
DEM=handles.DEM;
station=handles.station;
Box=handles.box;
profile=handles.prof;

C   = reclassify(SCM,'definedintervals',[0 10]);
C.Z(C.Z(:)==0)=NaN;
handles.C=C;

set(handles.ubut,'selectedobject',handles.maske);
axes(handles.axes4);
cla
imageschs(DEM,C,'colorbar',false)
hold on
plot(Box(profile).X,Box(profile).Y,'-k')
xlim(handles.xlim)
ylim(handles.ylim)

axes(handles.axes5)
cla

Info=('Patches of low slope and roughness enclosing the terrace/shoreline treads');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell); 


guidata(hObject, handles);

% --- Executes on button press in pushbutton14.
function pushbutton14_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);

%SCM=handles.SCM;
DEM=handles.DEM;
DEMS=handles.DEM;
station=handles.station;
C=handles.C;
maxel=handles.maxel;
minel=handles.minel;
Box=handles.box;
profile=handles.prof;

DEMS.Z(isnan(C.Z(:)))=NaN;
%manual constraint
DEMS.Z(DEMS.Z(:)<minel)=NaN;
DEMS.Z(DEMS.Z(:)>maxel)=NaN;

%elevation histogram
axes(handles.axes5);
cla

if DEM.cellsize <= 1
hi=histogram(DEMS.Z,150);%50 %90 %150
elseif DEM.cellsize <= 5
hi=histogram(DEMS.Z,100);
else
hi=histogram(DEMS.Z,50);    
end


hi.FaceColor=[0.6 0.6 0.6];
hi.Normalization = 'count';
yval=hi.Values;
xval1=hi.BinLimits;
xval=linspace(xval1(1),xval1(2),numel(yval));
xlabel('Elevation (m)'),ylabel('count')

xlim([min(xval) max(xval)])
%hold on
%plot(xval,yval,'-r')
handles.histline=[xval',yval'];

%plot display
set(handles.ubut,'selectedobject',handles.topomask);

try
axes(handles.axes4);
cla
imageschs(DEM,DEMS);
hold on
plot(Box(profile).X,Box(profile).Y,'-k')
xlim(handles.xlim)
ylim(handles.ylim)

handles.DEMS=DEMS;%topo SCM
catch
Info=('Elevation values out of range');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell); 

end

Info=('SCM color-coded by elevation');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell); 


guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function uipanel6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles = guidata(hObject);
handles.uipanel6=axis;

guidata(hObject, handles);


% --- Executes on button press in pushbutton16.
function pushbutton16_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
maxtab=handles.maxtab;
DEMS=handles.DEMS;
DEM=handles.DEM;
minel=handles.minel;
maxel=handles.maxel;
Box=handles.box;
profile=handles.prof;

set(handles.ubut,'selectedobject',handles.tlevs);
    
for i= 1:numel(maxtab(:,1))    
    A(i)=maxtab(i,1)-maxtab(i,3);%calculate range extension
    B(i)=maxtab(i,1)+maxtab(i,3); 
    
    levelin=maxtab(i,4);

C2   = reclassify(DEMS,'definedintervals',[A(i),B(i)]);
C2.Z(C2.Z(:)==0)=NaN;%delete unnecessary levels
C2.Z(C2.Z(:)==3)=NaN;
C2.Z(C2.Z(:)==1)=NaN;
C2.Z(C2.Z(:)==2)=levelin;%i
%regenrate
Cx(i).Z=C2.Z;
end



clear i
%combine masks
A=Cx(1).Z;
for i=2:numel(maxtab(:,1))
B=Cx(i).Z;
Ct=pegote(A,B);%my special function
A=Ct;%overwrite
end

C2.Z=A;

axes(handles.axes4);
cla
imageschs(DEM,C2,'colorbar',false)
hold on
plot(Box(profile).X,Box(profile).Y,'-k')
xlim(handles.xlim)
ylim(handles.ylim)

handles.levelsmap=C2;

Info=('Is mapping OK?, then "SAVE SWATH DATA" ');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell); 

guidata(hObject, handles);


function edit8_Callback(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit8 as text
%        str2double(get(hObject,'String')) returns contents of edit8 as a double
handles = guidata(hObject);
handles.minel=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit9_Callback(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit9 as text
%        str2double(get(hObject,'String')) returns contents of edit9 as a double
handles = guidata(hObject);
handles.maxel=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton21.
function pushbutton21_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);

%here=pwd;
%cd(handles.stationpath)

profile=handles.prof;
station=handles.station;
%%%%%%%%%% SCM export to structure
RASTER = struct('SCM',handles.SCM,'MASK', handles.C,'SCMEL', handles.DEMS,'LEVE', handles.levelsmap); %define handles to save
TABLES  = struct('LEVELS',handles.maxtab,'MAXSLP',handles.maxslope,'MAXROU',handles.maxrough);

fileid=sprintf('%s_SCM.mat',station);

if exist(fileid,'file')==2
    load(fileid)
end



SCM(profile).Rasters=RASTER;
SCM(profile).Tables=TABLES;

save(fileid, 'SCM')

Info=('Swath data has been saved, use "PROCESS PROFILES to visualize it"');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell); 


guidata(hObject, handles);

% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1
handles = guidata(hObject);
contents = cellstr(get(hObject,'String'));
sele=contents{get(hObject,'Value')};

handles.prof=str2num(sele);
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton27.
function pushbutton27_Callback(hObject, eventdata, handles), global SCM station
% hObject    handle to pushbutton27 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);


Info=('Here you go for full processing and comparison of your mapped profiles');
T = evalc('Info');        
Tcell = regexp(T, '\n', 'split');      
set(handles.text38,'String',Tcell); 



station=handles.station;
fileid=sprintf('%s_SCM.mat',handles.station);

try
TC=load(fileid);
catch
  msgbox('First save the results')  
end





SCM=TC.SCM;

TerraceM_lakelevels;
