%% Terracem_Free-face function
function [shoreline,points,regr]=TerraceM_cliff(swat,slo,ra) 
%====

% Set free-face slope and error
%fface(1,1)=ra; %Plio-Pleist. Konya limestone (70 5) (slo ra)
%fface(1,2)=slo;

%load swath profile values
x=swat.x; %distance along profile
mi=swat.z_min; %min values%
me=swat.z_mean; %mean values
ma=swat.z_max; %max values
slp=swat.slope; %slope values


hold on
plot(x,ma,'k')
plot(x,me,'color',[0.3 0.3 0.3])
plot(x,mi,'color',[0.6 0.6 0.6])
%hleg1 = legend('Max topography','Mean topography','Min topography','Location','SouthEast');
%xlim([min(x) max(x)]);
grid on 
box on
yl1=ylabel('Elevation (m)'); 
xl1=xlabel('Distance along profile (m)');

%plot of slope of maximum topography

disp('enter outcrop position of paleocliff free face');
%input free-face
        [face(1,1),face(1,2)]=ginputc(1,'Color','r');%       
        plot(face(1,1),face(1,2),'sk','markerfacecolor','k');
        disp('enter top and bottom of paleo abrasion platform');
        [plat(1,1),plat(1,2)]=ginputc(1,'Color','b');       
        [plat(2,1),plat(2,2)]=ginputc(1,'Color','b'); 
        

da(:,1)=x; 
da(:,2)=ma; 
md=swat; 
ny=length(md(:,1)); 


platx=[plat(1,1),plat(1,2),plat(2,1),plat(2,2)];
clifx=[face(1,1),face(1,2)];

da=sortrows(da,1);

% select points for fitting cliff
daclif=da(da(:,1)>=face(1,1),:);
%daclif=daclif1(daclif1(:,1)<=plat(1,2),:);
% select points for fitting platform
daplat1=da(da(:,1)<=plat(1,1),:);
daplat=daplat1(daplat1(:,1)>=plat(2,1),:);


%linear regressions
% free-face and cliff
xc=(daclif(:,1));
yc=face(1,2)-((daclif(:,1)-face(1,1))/tand(90+slo));
yc2=face(1,2)-((daclif(:,1)-face(1,1))./tand(90-ra+slo)); %-error

if slo+ra<90
yc1=face(1,2)-((daclif(:,1)-face(1,1))./tand(90+ra+slo));%+error
else
    %check this
yc1=face(1,2)-((daclif(:,1)-face(1,1))./tand(90+ra+slo));%+error
end

%first order fit for cliff
[pclif,sclif]=polyfit(xc,yc,1);
[pclif1,sclif1]=polyfit(xc,yc1,1);
[pclif2,sclif2]=polyfit(xc,yc2,1);

% first order fit for platform
xp=daplat(:,1); yp=daplat(:,2);
[pplat,splat]=polyfit(xp,yp,1);

% extrapolate both
%d=abs(mean(diff(xc)));
d=0.1;
xx=min(xp):d:face(1,1); xx=xx';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[p_clif,d_clif]=polyval(pclif,xx,sclif);
[p_clif1,d_clif1]=polyval(pclif1,xx,sclif1);
[p_clif2,d_clif2]=polyval(pclif2,xx,sclif2);
[p_plat,d_plat]=polyval(pplat,xx,splat);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% locate intersection
mc=pclif(1,1); 
ic=pclif(1,2); 
mp=pplat(1,1); 
ip=pplat(1,2);
sh=[(-ic+ip)/(mc-mp),(ip*mc-ic*mp)/(mc-mp)];
shx=sh(1,1); 
shz=sh(1,2);

[shzp,shzep]=polyval(pplat,shx,splat);
% propagate 2s error by intersecting 2s regressions
% intersect max
mc=pclif1(1,1); ic=pclif1(1,2);
sh1=[(-ic+ip)/(mc-mp),(ip*mc-ic*mp)/(mc-mp)];
shx1=sh1(1,1); 
shz1=sh1(1,2);
[shzc1,shzec1]=polyval(pplat,shx1,splat);

% intersect min
mc2=pclif2(1,1); ic2=pclif2(1,2);
sh2=[(-ic2+ip)/(mc2-mp),(ip*mc2-ic2*mp)/(mc2-mp)];
shx2=sh2(1,1); 
shz2=sh2(1,2);
[shzc2,shzec2]=polyval(pplat,shx2,splat);

% calculate error
shze1=shz1-shzec1;
shze2=shz2+shzec2;
shze=(shze2-shze1);

cla
hold on
plot(x,ma,'-b'), grid on, box on %ma
plot(x,mi,'-k'), grid on, box on %ma
plot(xp,yp,'ok','markerfacecolor','b','MarkerSize',4)
plot(xx,p_plat,'r-',xx,p_plat+2*d_plat,'r--',xx,p_plat-2*d_plat,'r--') %platform
plot(xx,p_clif,'r-');
plot(xx,p_clif1,'r--');
plot(xx,p_clif2,'r--');

plot(face(1,1),face(1,2),'sk','markerfacecolor','r');
errorbar(shx,shz,shze,'ok','markerfacecolor','k');
axis([min(da(:,1)) max(da(:,1)) min(da(:,2)) max(da(:,2))]); 


%adjust label
xplus=(max(xx)-min(xx));


text(shx-xplus,shz,sprintf('%.2f $\\pm$ %.2f m',shz,shze),'FontSize',12,'BackgroundColor',[1 1 1],'interpreter','latex'); %Shoreline angle value and location
text(shx+xplus/4,shz,sprintf('Cliff angle %.f $\\pm$ %.f m',slo,ra),'FontSize',12,'BackgroundColor',[1 1 1],'interpreter','latex'); %Shoreline angle value and location

box on
yl1=ylabel('Elevation (m)'); 
xl1=xlabel('Distance along swath(m)');


point2utm=Terracem_point2utm(swat,sh);

Rx=point2utm(:,1); %UTM E
Ry=point2utm(:,2); %UTM N

shoreline=[Rx Ry shx shz shze]; %number of shoreline,E, N, distance along profile,z ze
if nargout > 1
%points=vertcat(platx',clifx');
points=vertcat([xc,yc],[xp,yp]);

%regressions
regr.cliff=[xx,p_clif,p_clif1,p_clif2];
regr.plat=[xx,p_plat,p_plat+2*d_plat,p_plat-2*d_plat];

end