function varargout = TerraceM_export(varargin)
% TERRACEM_EXPORT MATLAB code for TerraceM_export.fig
%      TERRACEM_EXPORT, by itself, creates a new TERRACEM_EXPORT or raises the existing
%      singleton*.
%
%      H = TERRACEM_EXPORT returns the handle to a new TERRACEM_EXPORT or the handle to
%      the existing singleton*.
%
%      TERRACEM_EXPORT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TERRACEM_EXPORT.M with the given input arguments.
%
%      TERRACEM_EXPORT('Property','Value',...) creates a new TERRACEM_EXPORT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TerraceM_export_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TerraceM_export_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TerraceM_export

% Last Modified by GUIDE v2.5 03-Feb-2018 21:54:48

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TerraceM_export_OpeningFcn, ...
                   'gui_OutputFcn',  @TerraceM_export_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before TerraceM_export is made visible.
function TerraceM_export_OpeningFcn(hObject, eventdata, handles, varargin), global st1 st2 st3
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TerraceM_export (see VARARGIN)

% Choose default command line output for TerraceM_export
handles.output = hObject;

handles.station=st1.station;
handles.statpath=st2.statpath;
handles.maindir=st3.maindir;

%cd(handles.statpath);



% Update handles structure
guidata(hObject, handles);

% UIWAIT makes TerraceM_export wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = TerraceM_export_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output = hObject;
station=handles.station;
statpath=handles.statpath;
cd(handles.statpath)
%here=pwd;

load(sprintf('%s_SHORELINES.mat',station))
load(sprintf('%s_swath.mat',station));

ii=numel(SHORELINE);

ps=6;
pg=ceil(ii/ps);%six profiles per page


for i=1:ii
clear sw cliff plat points SH
    xt=rem(i-1,ps)+1;
    
    if xt==1
        figure;
    end
    
    subplot(3,2,xt)
box on
title(sprintf('Profile %s',num2str(i)))
    
jj=numel(SHORELINE(i).met);    %profile

sw(:,1)=swath(i).x;
sw(:,2)=swath(i).z_min;
sw(:,3)=swath(i).z_mean;
sw(:,4)=swath(i).z_max;

hold on
plot(sw(:,1),sw(:,2),'-','color',[0.6 0.6 0.6])
plot(sw(:,1),sw(:,3),'-','color',[0.3 0.3 0.3])
plot(sw(:,1),sw(:,4),'-','color',[0 0 0])
hold off

for j=1:jj   %level
    clear cliff plat points SH
try    
cliff=SHORELINE(i).met(j).REGRESSIONS.cliff;   
plat=SHORELINE(i).met(j).REGRESSIONS.plat;   
points=SHORELINE(i).met(j).POINTS;  

SH(1)=SHORELINE(i).level(j).DISTANCE_PROFILE;  
SH(2)=SHORELINE(i).level(j).ELEVATION;   
SH(3)=SHORELINE(i).level(j).ERROR;  
    
hold on
plot(points(:,1),points(:,2),'.b','Markersize',8)
plot(cliff(:,1),cliff(:,2),'--r')
plot(cliff(:,1),cliff(:,4),'--r')
plot(cliff(:,1),cliff(:,3),'-r')
plot(plat(:,1),plat(:,2),'--r')
plot(plat(:,1),plat(:,4),'--r')
plot(plat(:,1),plat(:,3),'-r')

hold on

errorbar(SH(1),SH(2),SH(3),'ok')
plot(SH(1),SH(2),'ok','MarkerFaceColor','r','Markersize',6)

%text on plot

xL = get(gca,'XLim'); yL = get(gca,'YLim');
dxL=xL(2)-xL(1); dyL=yL(2)-yL(1);
text(SH(1)-dxL/4,SH(2)+(SH(2)-yL(1))/9,sprintf('%.1f +/- %.1f m',SH(2),SH(3)),'FontSize',8); %Shoreline angle value and location


catch
end

end 

xlabel('Distance (m)'); ylabel('Elevation (m)');
xlim([min(sw(:,1)) max(sw(:,1))])
dd=max(sw(:,4))-min(sw(:,2));
ylim([min(sw(:,2))-dd/9 max(sw(:,4))+dd/9])

%save pdf
if xt==ps  || i==ii

%check or add new folder PDF
%craete folders
Outdir=sprintf('%s_PDFs',station);
if exist(Outdir,'dir')==7
else
mkdir(Outdir);
end

cd(Outdir)
rect=[1 0 19 29];
set(gcf,'paperunits','centimeters');
set(gcf,'papertype','A4');
set(gcf,'paperposition',rect);
fout=sprintf('Repository_%.f',ceil(i/ps));
saveas(gcf,fout,'pdf');
cd(handles.statpath)
end

end



% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.output = hObject;
station=handles.station;
fileid=sprintf('%s_SHORELINES.mat',station);
load(fileid)
k=1;
for prof=1:numel(SHORELINE)    
    for level=1:numel(SHORELINE(prof).level)
        shore(k,:)=SHORELINE(prof).level(level);
        k=k+1;
    end
end

%craete folders
Outdir=sprintf('%s_EXPORT',handles.station);
if exist(Outdir,'dir')==7
else
mkdir(Outdir);
end

here=pwd;
cd(Outdir)

T = struct2table(shore);
writetable(T,sprintf('%s_shorelines.txt',station),'Delimiter',' ');%.xls

cd(here)
% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output = hObject;
station=handles.station;
fileid=sprintf('%s_SHORELINES.mat',station);
load(fileid)
k=1;
for prof=1:numel(SHORELINE)    
    for level=1:numel(SHORELINE(prof).level)
        shore(k,:)=SHORELINE(prof).level(level);
        k=k+1;
    end
end

%craete folders
Outdir=sprintf('%s_EXPORT',handles.station);
if exist(Outdir,'dir')==7
else
mkdir(Outdir);
end

here=pwd;
cd(Outdir)

%create table
T = struct2table(shore);
writetable(T,sprintf('%s_shorelines.xls',station));%.xls

cd(here)
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.output = hObject;
station=handles.station;
fileid=sprintf('%s_SHORELINES.mat',station);
load(fileid)
k=1;
for prof=1:numel(SHORELINE)    
    for level=1:numel(SHORELINE(prof).level)
        shore(k,:)=SHORELINE(prof).level(level);
        k=k+1;
    end
end

%craete folders
Outdir=sprintf('%s_EXPORT',handles.station);
if exist(Outdir,'dir')==7
else
mkdir(Outdir);
end

here=pwd;
cd(Outdir)

%export to shapefile
[Tracks(1:length(shore)).Geometry] = deal('Point');
for i = 1:length(shore)
    [Tracks(i).station]= shore(i).STATION;
    [Tracks(i).profile]= shore(i).PROFILE;
    [Tracks(i).level]= shore(i).LEVEL;
    [Tracks(i).X]= shore(i).UTM_X;
    [Tracks(i).Y]= shore(i).UTM_Y;
    [Tracks(i).distance]= shore(i).DISTANCE_PROFILE;
    [Tracks(i).Z]= shore(i).ELEVATION;
    [Tracks(i).Ze]= shore(i).ERROR;        
end

%outputs
fout=sprintf('%s_shorelines.shp',station);
%check if no data is in table and remove
for j=1:numel(Tracks)
   code(j)=isempty(Tracks(j).station);
end
code_n=find(code==1);
Tracks(code_n)=[];

shapewrite(Tracks, fout);

cd(here)
