function varargout = TerraceM_lakelevels(varargin)
% TERRACEM_LAKELEVELS MATLAB code for TerraceM_lakelevels.fig
%      TERRACEM_LAKELEVELS, by itself, creates a new TERRACEM_LAKELEVELS or raises the existing
%      singleton*.
%
%      H = TERRACEM_LAKELEVELS returns the handle to a new TERRACEM_LAKELEVELS or the handle to
%      the existing singleton*.
%
%      TERRACEM_LAKELEVELS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TERRACEM_LAKELEVELS.M with the given input arguments.
%
%      TERRACEM_LAKELEVELS('Property','Value',...) creates a new TERRACEM_LAKELEVELS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TerraceM_lakelevels_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TerraceM_lakelevels_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TerraceM_lakelevels

% Last Modified by GUIDE v2.5 24-Apr-2019 12:39:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TerraceM_lakelevels_OpeningFcn, ...
                   'gui_OutputFcn',  @TerraceM_lakelevels_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before TerraceM_lakelevels is made visible.
function TerraceM_lakelevels_OpeningFcn(hObject, eventdata, handles, varargin), global SCM station
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TerraceM_lakelevels (see VARARGIN)

% Choose default command line output for TerraceM_lakelevels
handles.output = hObject;



handles.SCM=SCM;
handles.station=station;
SCM1=handles.SCM;


set(handles.popupmenu1,'string',(1:numel(handles.SCM)));
set(handles.popupmenu2,'string',(1:numel(handles.SCM)));


%get limits
for i=1:numel(SCM1)
    
    Mx(i,1)=max(SCM1(i).Rasters.SCMEL);
    Mn(i,1)=min(SCM1(i).Rasters.SCMEL);
    
   KK=unique(SCM1(i).Rasters.LEVE.Z);
    LL(:,i)=max(KK);
end

%color codes
ccl=max(LL);
CL = linspecer(ccl);%25
CL= flipud(CL);

handles.CL=CL;
handles.ymax=max(Mx);
handles.ymin=min(Mn);


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes TerraceM_lakelevels wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = TerraceM_lakelevels_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output = hObject;


SCM=handles.SCM;
CL=handles.CL;



figure
n=numel(SCM);

for i=1:n
    
    
 subplot(1,n,i)   
 title(sprintf('Profile_%s',num2str(i)))  
 
 Lev=SCM(i).Rasters.LEVE;%levels
 Ele=SCM(i).Rasters.SCMEL;%elevation
 %get level values
lle1=unique(Lev.Z);
lle= rmmissing(lle1);   


box on
for lv = 1:numel(lle)
    
level=double(lle(lv));   
    
L1=Ele;
L1.Z(Lev.Z(:)~=level)=NaN;  
 
pd = fitdist(L1.Z(:),'Normal');
x_pdf = [min(L1.Z(:)):0.01:max(L1.Z(:))];
y = pdf(pd,x_pdf);
 
%get the max
Mxp(lv,1)=max(y);
%here the figure
 
%title(sprintf('%s',station))
hold on
plot((y),(x_pdf),'-','color',CL(level,:),'linewidth',1.5);
hold on
 
ym=max(y);
ym2=ym+ym/6;
plot([0 ym2],[pd.mu pd.mu],'-k')
text(double(ym2),double(pd.mu),sprintf('%s',num2str(level)));

if i~=1
set(gca, 'YTick', [])   
elseif i==1
ylabel('Elevation (m)');       
end

if ceil(n/2)==i
xlabel('Probability density');    
end

end
xlim([0 max(Mxp)])
ylim([handles.ymin handles.ymax])


end


% Update handles structure
guidata(hObject, handles);



% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%handles = guidata(hObject);
handles.output = hObject;
SH1=handles.SH1;%probabilities of shorelines
SH2=handles.SH2;%probabilities of shorelines

level1 = extractfield(SH1,'level');
level2 = extractfield(SH2,'level');
%concatenate
level_plus=(horzcat(level1,level2)');
%find doubles values apt for comparison
[C,idx]=unique(level_plus,'stable');%don't sort
idx=setxor(idx,1:numel(level_plus));
levels_comp=level_plus(idx);
%nr levels for loop
ncomp=numel(levels_comp);


mup1=extractfield(SH1,'mu');
mup2=extractfield(SH2,'mu');
sigmap1=extractfield(SH1,'sigma');
sigmap2=extractfield(SH2,'sigma');

figure

title(sprintf('Profile %s v/s %s',num2str(handles.profsel1),num2str(handles.profsel2)))

for j=1:ncomp
hold on
box on
lelup=levels_comp(j);  

mu1=mup1(find(level1==lelup));
mu2=mup2(find(level2==lelup));
sigma1=sigmap1(find(level1==lelup));
sigma2=sigmap2(find(level2==lelup));

%diference using mu and sigma from each pdf


Nwmu=(mu1-mu2);
Nwsigma=(sigma1+sigma2);

r = normrnd(Nwmu,Nwsigma,[1,9000]);
r2 = makedist('Normal','mu',Nwmu,'sigma',Nwsigma);

%ynn = pdf( 'normal',r , Nwmu , Nwsigma);
ynn = pdf( r2 , r)*3;

errorbar(lelup,(Nwmu),sqrt(Nwsigma),'.k')
plot(lelup,(Nwmu),'ok','MarkerEdgeColor','k','MarkerFaceColor',[0,0,0]);

mutu(j,2)=Nwmu;
mutu(j,1)=lelup;
mutu(j,3)=Nwsigma;
end
%fit line
[Ofitline,Delta1] = polyfit(mutu(:,1),mutu(:,2),1);
[ypval,delta]=polyval(Ofitline,mutu(:,1),Delta1);

hold on
plot(mutu(:,1),ypval,'-b')
plot(mutu(:,1),ypval+delta,'--b')
plot(mutu(:,1),ypval-delta,'--b')

plot([min(mutu(:,1)-1), max(mutu(:,1)+1)],[0 0],'.-k')
%set(gca, 'XDir','reverse')


xlabel('Shoreline level')
ylabel('Offset (m)')


guidata(hObject, handles);
% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);



handles.output = hObject;


SCM=handles.SCM;
CL=handles.CL;



figure%('visible','off')

n=numel(SCM);%all the levels

kk=1;
for i=1:n
    
    
 %subplot(1,n,i)   
 title(sprintf('Profile_%s',num2str(i)))  
 
 Lev=SCM(i).Rasters.LEVE;%levels
 Ele=SCM(i).Rasters.SCMEL;%elevation
 %get level values
lle1=unique(Lev.Z);
lle= rmmissing(lle1);   

k=1;

box on
for lv = 1:numel(lle)
    
level=double(lle(lv));   
    
L1=Ele;
L1.Z(Lev.Z(:)~=level)=NaN;  
 
%pd = fitdist(L1.Z(:),'Normal');
%x_pdf = [min(L1.Z(:)):0.001:max(L1.Z(:))];
%y = pdf(pd,x_pdf);

h2=histogram(L1.Z(:));
clear chi2crit
[h,p,stats] = chi2gof(L1.Z(:)); %take stats.chi2stat as chicalc
chi2crit = chi2inv(0.05,stats.df);%1-0.5 =95% 0.05 is the 5 % 5 is degrees of fredom from stats.df


n_obs = h2.Values;

v = h2.BinWidth * 0.5 + h2.BinEdges(1:end-1);
n_exp = normpdf(v,nanmean(L1.Z(:)),nanstd(L1.Z(:)));
 %The data need to be scaled so that they are similar to the original data set.
n_exp = n_exp / sum(n_exp);
n_exp = sum(n_obs) * n_exp;
    
chi2calc = sum((n_obs - n_exp).^2 ./ n_exp);

Chicrit(i,lv)=chi2crit;
%Chicalc(i,lv)=stats.chi2stat;
Chicalc(i,lv)=chi2calc;
Chip(i,lv)=p;
ChiClass(i,lv)=h;




end
hold on
plot(Chicrit(i,:),Chicalc(i,:),'o')

end

%figure
%plot(Chicrit(1,:),Chicalc(1,:),'o')




guidata(hObject, handles);

% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1

handles = guidata(hObject);
SCM=handles.SCM;
handles = guidata(hObject);
contents = cellstr(get(hObject,'String')); %returns stationslist contents as cell array
prof_selection=(contents{get(hObject,'Value')}); %returns selected item from stationslist
handles.profsel1=str2num(prof_selection);

Lev=SCM(handles.profsel1).Rasters.LEVE;%levels
Ele=SCM(handles.profsel1).Rasters.SCMEL;%elevation


%get level values
lle1=unique(Lev.Z);
lle= rmmissing(lle1);

%color codes
CL= handles.CL;

axes(handles.axes1)
cla
box on
for lv = 1:numel(lle)
    
level=double(lle(lv));   
    
L1=Ele;
L1.Z(Lev.Z(:)~=level)=NaN;  

pd = fitdist(L1.Z(:),'Normal');
x_pdf = [min(L1.Z(:)):0.01:max(L1.Z(:))];
y = pdf(pd,x_pdf);

%get the max
Mxp(lv,1)=max(y);

%here the figure
hold on
plot((y),(x_pdf),'-','color',CL(level,:),'linewidth',1.5);
hold on

ym=max(y);
ym2=ym+ym/6;


plot([0 ym2],[pd.mu pd.mu],'-k')
text(double(ym2),double(pd.mu),sprintf('%s',num2str(level)));



SHORELINES1(lv).level=level;
SHORELINES1(lv).mu=double(pd.mu);
SHORELINES1(lv).sigma=double(pd.sigma);

end

handles.SH1=SHORELINES1;

xlim([0 max(Mxp)])
ylim([handles.ymin handles.ymax])
xlabel('Probability density');
ylabel('Elevation (m)');

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2
handles = guidata(hObject);
SCM=handles.SCM;
handles = guidata(hObject);
contents = cellstr(get(hObject,'String')); %returns stationslist contents as cell array
prof_selection=(contents{get(hObject,'Value')}); %returns selected item from stationslist
handles.profsel2=str2num(prof_selection);

Lev=SCM(handles.profsel2).Rasters.LEVE;%levels
Ele=SCM(handles.profsel2).Rasters.SCMEL;%elevation


%get level values
lle1=unique(Lev.Z);
lle= rmmissing(lle1);

%color codes
%ccl=max(lle1);
%CL = linspecer(ccl);%25
%CL= flipud(CL);
CL= handles.CL;

axes(handles.axes2)
cla
box on
for lv = 1:numel(lle)
    
level=double(lle(lv));   
    
L1=Ele;
L1.Z(Lev.Z(:)~=level)=NaN;  

pd = fitdist(L1.Z(:),'Normal');
x_pdf = [min(L1.Z(:)):0.01:max(L1.Z(:))];
y = pdf(pd,x_pdf);

%get the max
Mxp(lv,1)=max(y);
%here the figure

%title(sprintf('%s',station))
hold on
plot((y),(x_pdf),'-','color',CL(level,:),'linewidth',1.5);
hold on

ym=max(y);
ym2=ym+ym/6;
plot([0 ym2],[pd.mu pd.mu],'-k')
text(double(ym2),double(pd.mu),sprintf('%s',num2str(level)));

SHORELINES2(lv).level=level;
SHORELINES2(lv).mu=double(pd.mu);
SHORELINES2(lv).sigma=double(pd.sigma);

end

handles.SH2=SHORELINES2;


xlim([0 max(Mxp)])
ylim([handles.ymin handles.ymax])
xlabel('Probability density');
ylabel('Elevation (m)');

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

guidata(hObject, handles);

SCM1=handles.SCM;
maxtab=SCM1(handles.profsel1).Tables.LEVELS;

Theader={'Elevation','count','Elevation range','level'};
Tdata = table_dialog(maxtab,Theader,'Modify shoreline levels to improve lateral correlation');

handles.SCM(handles.profsel1).Tables.LEVELS=Tdata;

fileid=sprintf('%s_SCM.mat',handles.station);

if exist(fileid,'file')==2
    load(fileid)
end

SCM(handles.profsel1).Tables.LEVELS=Tdata;

save(fileid, 'SCM')

guidata(hObject, handles);


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

guidata(hObject, handles);

SCM2=handles.SCM;
maxtab=SCM2(handles.profsel2).Tables.LEVELS;

Theader={'Elevation','count','Elevation range','level'};
Tdata = table_dialog(maxtab,Theader,'Modify shoreline levels to improve lateral correlation');

handles.SCM(handles.profsel2).Tables.LEVELS=Tdata;

fileid=sprintf('%s_SCM.mat',handles.station);

if exist(fileid,'file')==2
    load(fileid)
end

SCM(handles.profsel2).Tables.LEVELS=Tdata;

save(fileid, 'SCM')

guidata(hObject, handles);


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
guidata(hObject, handles);

SCM=handles.SCM;
%%%%%%%%% right side %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
maxtab1=SCM(handles.profsel1).Tables.LEVELS;
DEMS1=SCM(handles.profsel1).Rasters.SCMEL;

%recalculate SCM with new levels
for i= 1:numel(maxtab1(:,1))    
A1(i)=maxtab1(i,1)-maxtab1(i,3);%calculate range extension
B1(i)=maxtab1(i,1)+maxtab1(i,3); 
    
levelin1=maxtab1(i,4);

C12=reclassify(DEMS1,'definedintervals',[A1(i),B1(i)]);
C12.Z(C12.Z(:)==0)=NaN;%delete unnecessary levels
C12.Z(C12.Z(:)==3)=NaN;
C12.Z(C12.Z(:)==1)=NaN;
C12.Z(C12.Z(:)==2)=levelin1;%i
%regenrate
C1x(i).Z=C12.Z;
end

clear i
%combine masks
A1=C1x(1).Z;
for i=2:numel(maxtab1(:,1))
B1=C1x(i).Z;
C1t=pegote(A1,B1);%my special function
A1=C1t;%overwrite
end

C12.Z=A1;

SCM(handles.profsel1).Rasters.LEVE=C12;


%%%%%%%%%%%%%%left side%%%%%%%%%%%
maxtab2=SCM(handles.profsel2).Tables.LEVELS;
DEMS2=SCM(handles.profsel2).Rasters.SCMEL;

%recalculate SCM with new levels
for i= 1:numel(maxtab2(:,1))    
A2(i)=maxtab2(i,1)-maxtab2(i,3);%calculate range extension
B2(i)=maxtab2(i,1)+maxtab2(i,3); 
    
levelin2=maxtab2(i,4);

C22=reclassify(DEMS2,'definedintervals',[A2(i),B2(i)]);
C22.Z(C22.Z(:)==0)=NaN;%delete unnecessary levels
C22.Z(C22.Z(:)==3)=NaN;
C22.Z(C22.Z(:)==1)=NaN;
C22.Z(C22.Z(:)==2)=levelin2;%i
%regenerate
C2x(i).Z=C22.Z;
end

clear i
%combine masks
A2=C2x(1).Z;

%try
for i=2:numel(maxtab2(:,1))
B2=C2x(i).Z;
C2t=pegote(A2,B2);%my special function
A2=C2t;%overwrite
end
%catch
%msgbox('Restar TerraceM_lakeleves, memory overload')    
%end

C22.Z=A2;
SCM(handles.profsel2).Rasters.LEVE=C22;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% NOW PLOT ALL%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% left side %%%%%%%%%%

Lev1=SCM(handles.profsel1).Rasters.LEVE;%levels
%get level values
lle1=unique(Lev1.Z);
lle= rmmissing(lle1);
%color codes

CL= handles.CL;

axes(handles.axes1)
cla
box on
for lv = 1:numel(lle)
level=double(lle(lv));      
L1=DEMS1;
L1.Z(Lev1.Z(:)~=level)=NaN;  
pd = fitdist(L1.Z(:),'Normal');
x_pdf = [min(L1.Z(:)):0.01:max(L1.Z(:))];
y = pdf(pd,x_pdf);
%get the max
Mxp1(lv,1)=max(y);
%here the figure
hold on
plot((y),(x_pdf),'-','color',CL(level,:),'linewidth',1.5);
hold on
ym=max(y); ym2=ym+ym/6;
plot([0 ym2],[pd.mu pd.mu],'-k')
text(double(ym2),double(pd.mu),sprintf('%s',num2str(level)));


SHORELINES1(lv).level=level;
SHORELINES1(lv).mu=double(pd.mu);
SHORELINES1(lv).sigma=double(pd.sigma);

end

handles.SH1=SHORELINES1;

ylim([handles.ymin handles.ymax])
xlim([0 max(Mxp1)])
xlabel('Probability density');
ylabel('Elevation (m)');

clear level lv lle1 lle ccl CL pd ym2 ym y2
%%%%%%%%%% right side %%%%%%%%%%
Lev2=SCM(handles.profsel2).Rasters.LEVE;%levels
%get level values
lle1=unique(Lev2.Z);
lle= rmmissing(lle1);
%color codes

CL= handles.CL;

axes(handles.axes2)
cla
box on
for lv = 1:numel(lle)
level=double(lle(lv));      
L2=DEMS2;
L2.Z(Lev2.Z(:)~=level)=NaN;  
pd = fitdist(L2.Z(:),'Normal');
x_pdf2 = [min(L2.Z(:)):0.01:max(L2.Z(:))];
y2 = pdf(pd,x_pdf2);
%get the max
Mxp2(lv,1)=max(y2);
%here the figure
hold on
plot((y2),(x_pdf2),'-','color',CL(level,:),'linewidth',1.5);
hold on
ym=max(y2); ym2=ym+ym/6;
plot([0 ym2],[pd.mu pd.mu],'-k')
text(double(ym2),double(pd.mu),sprintf('%s',num2str(level)));

SHORELINES2(lv).level=level;
SHORELINES2(lv).mu=double(pd.mu);
SHORELINES2(lv).sigma=double(pd.sigma);

end

handles.SH2=SHORELINES2;

ylim([handles.ymin handles.ymax])
xlim([0 max(Mxp2)])
xlabel('Probability density');
ylabel('Elevation (m)');


%%%%%%%%%%%%%%%%%%%%% update handles


handles.SCM(handles.profsel1).Rasters.LEVE=C12;
handles.SCM(handles.profsel2).Rasters.LEVE=C22;
disp('handles updated')

%%%%%%%%%%%%%%%%%%%%%%% save rasters


fileid=sprintf('%s_SCM.mat',handles.station);

if exist(fileid,'file')==2
    load(fileid)
end

SCM(handles.profsel2).Rasters.LEVE=C22;
SCM(handles.profsel1).Rasters.LEVE=C12;
save(fileid, 'SCM')


guidata(hObject, handles);


% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
