function varargout = TerraceM_shorelinemap(varargin)
% TERRACEM_SHORELINEMAP MATLAB code for TerraceM_shorelinemap.fig
%      TERRACEM_SHORELINEMAP, by itself, creates a new TERRACEM_SHORELINEMAP or raises the existing
%      singleton*.
%
%      H = TERRACEM_SHORELINEMAP returns the handle to a new TERRACEM_SHORELINEMAP or the handle to
%      the existing singleton*.
%
%      TERRACEM_SHORELINEMAP('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TERRACEM_SHORELINEMAP.M with the given input arguments.
%
%      TERRACEM_SHORELINEMAP('Property','Value',...) creates a new TERRACEM_SHORELINEMAP or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TerraceM_shorelinemap_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TerraceM_shorelinemap_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TerraceM_shorelinemap

% Last Modified by GUIDE v2.5 11-Nov-2018 22:40:09

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TerraceM_shorelinemap_OpeningFcn, ...
                   'gui_OutputFcn',  @TerraceM_shorelinemap_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before TerraceM_shorelinemap is made visible.
function TerraceM_shorelinemap_OpeningFcn(hObject, eventdata, handles, varargin),global s1 s2 s3 s4 s5
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TerraceM_shorelinemap (see VARARGIN)

% Choose default command line output for TerraceM_shorelinemap
handles.output = hObject;

%global
handles.station=s1.stat;
handles.statpath=s2.statpath;
handles.maindir=s3.terracemdir;
handles.swat=s4.swat;
handles.maping=s5.maping;


%textbox handles
handles.slo=70;
handles.ra=5;  
handles.D=0;
handles.level=1;
handles.fringes=1;
handles.peak=0.3;

handles.theta=50;
handles.Kdiff=0.8;
handles.T1=0.05;
handles.Tdt=0.05;
handles.T2=35;
set(handles.axes2,'visible','off')

%set visibility
if handles.maping==1 %staircase
set(handles.cliffpanel,'visible','off')  
set(handles.stackpanel,'visible','off')  
set(handles.difpanel,'visible','off')
set(handles.cent,'visible','off')  
set(handles.uplimit,'visible','off') 
set(handles.shl,'visible','off') 
set(handles.text18,'visible','off')
set(handles.text19,'visible','off')

end

if handles.maping==2 %fix cliff
set(handles.stackpanel,'visible','off')  
set(handles.difpanel,'visible','off')  
set(handles.cent,'visible','off') 
set(handles.uplimit,'visible','off') 
set(handles.shl,'visible','off') 
set(handles.text18,'visible','off')
set(handles.text19,'visible','off')
end

if handles.maping==3 %stack
set(handles.cliffpanel,'visible','off')  
set(handles.difpanel,'visible','off')  
set(handles.cent,'visible','off')
set(handles.text3,'visible','off')
set(handles.text18,'visible','off')
set(handles.text19,'visible','off')
set(handles.text4,'visible','off')
set(handles.lev,'visible','off') 
end

if handles.maping==4 %diffusion
set(handles.cliffpanel,'visible','off')  
set(handles.stackpanel,'visible','off')  
set(handles.cent,'visible','off')
set(handles.shl,'visible','off') 
set(handles.uplimit,'visible','off') 
end

    
%pupulate list
nameFolds=1:numel(handles.swat);
set(handles.listbox1,'string', nameFolds) 

try
load(sprintf('%s_SHORELINES.mat',handles.station));
handles.shore=SHORELINE;
catch
disp('NO SHORELINES')
end

%cd(handles.statpath)
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes TerraceM_shorelinemap wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = TerraceM_shorelinemap_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function slo_Callback(hObject, eventdata, handles)
% hObject    handle to slo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of slo as text
%        str2double(get(hObject,'String')) returns contents of slo as a double
handles = guidata(hObject);
handles.slo=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function slo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ra_Callback(hObject, eventdata, handles)
% hObject    handle to ra (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ra as text
%        str2double(get(hObject,'String')) returns contents of ra as a double
handles = guidata(hObject);
handles.ra=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function ra_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ra (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);

zoom off
pan off

prof=handles.prof;
station=handles.station;
swat=handles.swat;
maping=handles.maping;
level=handles.level;
D=handles.D;

%prepare axes
axes(handles.axes1)
ax = gca;
yl=ax.YLim ;
xl=ax.XLim ;
cla
xlim(xl);ylim(yl);
xlabel('Distance along swath (m)'); ylabel('Elevation (m)')

%plot SCM
if D==1
 
try
    
U=handles.U;
SCMPR=handles.SCMPR;   
colors = jet(numel(U));
for i=1:numel(U)
SCMPR1=SCMPR(SCMPR(:,5)==i,:);
hold on
plot(SCMPR1(:,3),SCMPR1(:,4),'.','Color',colors(i,:));
end
catch
end
end 


%plot shorelines if exists
farbe=0.8;
try
 SHORELINE=handles.shore;
 lev=numel(SHORELINE(prof).level);
 for j=1:lev
     
     X=SHORELINE(prof).level(j).DISTANCE_PROFILE;
     Z=SHORELINE(prof).level(j).ELEVATION;
     Ze=SHORELINE(prof).level(j).ERROR;
     
     if strcmp(SHORELINE(prof).met(j).METHOD,'staircase')==1 || strcmp(SHORELINE(prof).met(j).METHOD,'cliff')==1     
     %staircase % cliff
     clif=SHORELINE(prof).met(j).REGRESSIONS.cliff;
     plat=SHORELINE(prof).met(j).REGRESSIONS.plat;         
     %regression
     hold on
     plot(clif(:,1),clif(:,2),'-','Color',[farbe farbe farbe]);plot(clif(:,1),clif(:,3),'--','Color',[farbe farbe farbe ]);plot(clif(:,1),clif(:,4),'--','Color',[farbe farbe farbe ])
     plot(plat(:,1),plat(:,2),'-','Color',[farbe farbe farbe ]);plot(plat(:,1),plat(:,3),'--','Color',[farbe farbe farbe ]);plot(plat(:,1),plat(:,4),'--','Color',[farbe farbe farbe ])
     %shoreline angle
     hold on
     plot(X,Z,'o','MarkerFaceColor',[farbe farbe farbe ],'MarkerSize',8,'MarkerEdgeColor',[farbe farbe farbe ])    
     else
     end
        
     if strcmp(SHORELINE(prof).met(j).METHOD,'stack')==1     
     plat=SHORELINE(prof).met(j).REGRESSIONS.plat;
     plot(plat(:,1),plat(:,2),'--','Color',[farbe farbe farbe ])   
     plot(X,Z,'o','MarkerFaceColor',[farbe farbe farbe ],'MarkerSize',8,'MarkerEdgeColor',[farbe farbe farbe ])  
     end   
     
 end
    
catch
end

%apply mapping function
%staircase
if maping==1
[shoreline,points,regr]=TerraceM_staircase(swat(prof));
met='staircase';
end

%cliff
if maping==2
slo=handles.slo;
ra=handles.ra;    
[shoreline,points,regr]=TerraceM_cliff(swat(prof),slo,ra);
met='cliff';
end

%stack mapping
if maping==3
peak=handles.peak;    
fringes=handles.fringes;
[shoreline,points,regr]=Terracem_stacks(swat(prof),peak,fringes); 
met='stack';    
end


if maping==4  
thetadegrees=handles.theta;
k=handles.Kdiff;
t1=handles.T1;
ti=handles.Tdt;
t2=handles.T2;
[shoreline,points,regr,rms]=TerraceM_diff(swat(prof),thetadegrees,k,t1,ti,t2);   
met='dif';



%
set(handles.axes2,'visible','on')
axes(handles.axes2)
cla
hold on, box on
plot(rms.ktrange,rms.rms,'b')
plot(rms.bestkt,rms.bestrms,'ok','markerfacecolor','w')
line([0 rms.bestkt],[rms.bestrms rms.bestrms],'Linestyle','--','color','k');
line([rms.bestkt rms.bestkt],[0 rms.bestrms],'Linestyle','--','color','k');
title('RMS misfit')
xlabel('Kt (m^2)')
ylabel('RMS (m)')

text(rms.bestkt,max(rms.rms),sprintf('Kt=%.0f',rms.bestkt))

end


%axes(handles.axes1)


%%%%%%%%%% Save all %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% export to structure
try
SH  = struct('STATION',station,'PROFILE',prof,'LEVEL',level,'UTM_X',shoreline(1),'UTM_Y',shoreline(2),'DISTANCE_PROFILE',shoreline(3),'ELEVATION',shoreline(4),'ERROR',shoreline(5));
fileid=sprintf('%s_SHORELINES.mat',station);
catch
disp('insuficient points for interpolation')    
end


if exist(fileid,'file')==2
    load(fileid)
end

mo=struct('METHOD',met,'REGRESSIONS',regr,'POINTS',points);

SHORELINE(prof).level(level)=SH;
SHORELINE(prof).met(level)=mo;

save(fileid,'SHORELINE')


%update shoreline angles
try
load(sprintf('%s_SHORELINES.mat',handles.station));
handles.shore=SHORELINE;
catch
disp('NO SHORELINES')
end



guidata(hObject, handles);


function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double

handles = guidata(hObject);
handles.theta=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit8_Callback(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit8 as text
%        str2double(get(hObject,'String')) returns contents of edit8 as a double
handles = guidata(hObject);
handles.Kdiff=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit9_Callback(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit9 as text
%        str2double(get(hObject,'String')) returns contents of edit9 as a double

handles = guidata(hObject);
handles.T1=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit10_Callback(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit10 as text
%        str2double(get(hObject,'String')) returns contents of edit10 as a double
handles = guidata(hObject);
handles.Tdt=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit12_Callback(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit12 as text
%        str2double(get(hObject,'String')) returns contents of edit12 as a double
handles = guidata(hObject);
handles.T2=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end







function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double

handles = guidata(hObject);
handles.peak=str2double(get(hObject,'String'));
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1

handles = guidata(hObject);
contents = cellstr(get(hObject,'String'));
sele=contents{get(hObject,'Value')};
handles.prof=str2num(sele);
profile=handles.prof;
D=handles.D;

%swath
swat=handles.swat;
clear SW
SW=swat(handles.prof);
type=SW.type_profile;

if D==1
    
try
%SCM
SCM=handles.SCM;

%gridobjects
OBJlev1=SCM(handles.prof).Rasters.LEVE;
OBJel1=SCM(handles.prof).Rasters.SCMEL;

%resample
resize=1;
%OBJlev=resample(OBJlev1,OBJlev1.cellsize*OBJlev1.size(1)/resize);
%OBJel=resample(OBJel1,OBJel1.cellsize*OBJel1.size(1)/resize);

OBJlev=resample(OBJlev1,OBJlev1.cellsize*resize);
OBJel=resample(OBJel1,OBJel1.cellsize*resize);

%convert to matlab
[le,xl,yl]=GRIDobj2mat(OBJlev);
[z,x,y]=GRIDobj2mat(OBJel);

le(isnan(le)==1)=0;%nan to 0
z(isnan(z)==1)=0;%nan to 0

xpt=zeros(size(z));
ypt=zeros(size(z));
%collated
xpt=x(ones(numel(y),1),:);
ypt=y(:,ones(numel(x),1));

% matrix to xyz
xyz = [xpt(:),ypt(:),z(:)];
xyz2= [xpt(:),ypt(:),le(:)];
xyz(:,4)=xyz2(:,3);%add to col

xyz(xyz(:,4)==0,:)=[]; %remove nan's

%fullfill listbox
U=unique(xyz(:,4));
set(handles.listbox2,'string', U); 

%project SCM to profile
l=[SW.prof_X',SW.prof_Y'];
SCMPR=projection(l,xyz,type);
handles.SCMPR=SCMPR;
handles.U=U;

catch
   disp('No SCM maping on this profile')
   handles.SCMPR=[];
end
end

%preview plot
axes(handles.axes1)
cla


try
colors = jet(numel(U));
for i=1:numel(U)
SCMPR1=SCMPR(SCMPR(:,5)==i,:);
hold on

plot(SCMPR1(:,3),SCMPR1(:,4),'.','Color',colors(i,:));
end
catch
end

hold on
plot(SW.x,SW.z_min,'color',[0.6 0.6 0.6])
plot(SW.x,SW.z_mean,'color',[0.3 0.3 0.3])
plot(SW.x,SW.z_max,'k')
xlim([min(SW.x) max(SW.x)]);
ylim([min(SW.z_min) max(SW.z_max)]);


%plot shorelines if exists
farbe=0.8;
try
 SHORELINE=handles.shore;
 lev=numel(SHORELINE(profile).level);
 for j=1:lev
     
     X=SHORELINE(profile).level(j).DISTANCE_PROFILE;
     Z=SHORELINE(profile).level(j).ELEVATION;
     Ze=SHORELINE(profile).level(j).ERROR;
     
     if strcmp(SHORELINE(profile).met(j).METHOD,'staircase')==1 || strcmp(SHORELINE(profile).met(j).METHOD,'cliff')==1
     
     %staircase % cliff
     clif=SHORELINE(profile).met(j).REGRESSIONS.cliff;
     plat=SHORELINE(profile).met(j).REGRESSIONS.plat;
         
     %regression
     hold on
     plot(clif(:,1),clif(:,2),'-','Color',[farbe farbe farbe]);plot(clif(:,1),clif(:,3),'--','Color',[farbe farbe farbe ]);plot(clif(:,1),clif(:,4),'--','Color',[farbe farbe farbe ])
     plot(plat(:,1),plat(:,2),'-','Color',[farbe farbe farbe ]);plot(plat(:,1),plat(:,3),'--','Color',[farbe farbe farbe ]);plot(plat(:,1),plat(:,4),'--','Color',[farbe farbe farbe ])
     %shoreline angle
     hold on
     %errorbar(X,Z,Ze,'k')
     plot(X,Z,'o','MarkerFaceColor',[farbe farbe farbe ],'MarkerSize',8,'MarkerEdgeColor',[farbe farbe farbe ])    
     else
     end
        
     if strcmp(SHORELINE(profile).met(j).METHOD,'stack')==1     
     plat=SHORELINE(profile).met(j).REGRESSIONS.plat;
     plot(plat(:,1),plat(:,2),'--','Color',[farbe farbe farbe ])   
     %errorbar(X,Z,Ze,'k')
     plot(X,Z,'o','MarkerFaceColor',[farbe farbe farbe ],'MarkerSize',8,'MarkerEdgeColor',[farbe farbe farbe ])  
     end   
     
 end
    
catch
%    disp('hola')
end
%%%%%%%%%%%%%%%%%%%%%%%%


xlabel('Distance along swath (m)'); ylabel('Elevation (m)')

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox2.
function listbox2_Callback(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox2

handles = guidata(hObject);
contents = cellstr(get(hObject,'String'));
sele=contents{get(hObject,'Value')};
handles.level=str2num(sele);

%SCMPR=handles.SCMPR;

%PR2=SCMPR(SCMPR(:,5)==handles.level,:);

%axes(handles.axes1)
%pc=plot(PR2(:,3),PR2(:,4),'.r');


guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function listbox2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1
handles = guidata(hObject);
station=handles.station;
D=get(hObject,'Value');

if D==1
set(handles.listbox2,'visible','on')  
set(handles.lev,'visible','off') 
%error here
try
load(sprintf('%s_SCM',station))
handles.SCM=SCM;
catch
msgbox('No SCM has been maped on profiles')    
end
end


if D==0 
set(handles.listbox2,'visible','off')
%error here
%try
set(handles.lev,'visible','on') 
%catch
%end

end

handles.D=D;

guidata(hObject, handles);


function lev_Callback(hObject, eventdata, handles)
% hObject    handle to lev (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of lev as text
%        str2double(get(hObject,'String')) returns contents of lev as a double
handles = guidata(hObject);
handles.level=str2double(get(hObject,'String'));
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function lev_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lev (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit15_Callback(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit15 as text
%        str2double(get(hObject,'String')) returns contents of edit15 as a double

handles = guidata(hObject);
handles.fringes=str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
