function varargout = TerraceM_upliftdet(varargin)
% TERRACEM_UPLIFTDET MATLAB code for TerraceM_upliftdet.fig
%      TERRACEM_UPLIFTDET, by itself, creates a new TERRACEM_UPLIFTDET or raises the existing
%      singleton*.
%
%      H = TERRACEM_UPLIFTDET returns the handle to a new TERRACEM_UPLIFTDET or the handle to
%      the existing singleton*.
%
%      TERRACEM_UPLIFTDET('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TERRACEM_UPLIFTDET.M with the given input arguments.
%
%      TERRACEM_UPLIFTDET('Property','Value',...) creates a new TERRACEM_UPLIFTDET or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TerraceM_upliftdet_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TerraceM_upliftdet_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TerraceM_upliftdet

% Last Modified by GUIDE v2.5 20-Aug-2019 18:22:03

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TerraceM_upliftdet_OpeningFcn, ...
                   'gui_OutputFcn',  @TerraceM_upliftdet_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before TerraceM_upliftdet is made visible.
function TerraceM_upliftdet_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TerraceM_upliftdet (see VARARGIN)

% Choose default command line output for TerraceM_upliftdet
handles.output = hObject;

%opent TerraceM path
path = 'terracem_path.mat'; %path file
cdx=pwd; %local directory
%check if path file exist
if exist(fullfile(cdx, 'terracem_path.mat'), 'file')==2     
        load(path) %load path file       
        handles.station=station;
        handles.statpath=stationpath;
        handles.maindir=terracem_dir;
        handles.topotool=topotool;
        handles.station=station;    
        
end

handles.mint=0;
handles.maxt=250;
handles.uncert=12;
handles.tuncert=0;
handles.levsel=1;
handles.corr=0;
handles.boxx=1;
handles.RR2=0;
handles.tackle=0;

cd('..')
cd('TerraceM_LEM')
cd('sealevel')

here2=pwd;
listing = dir(here2);
listing(1:3)=[];

num=numel({listing.name});
handles.num=num;

for q=1:num
M(q).sl=load(listing(q).name); 
M(q).name=listing(q).name; 
handles.M(q).sl=M(q).sl;
end



clear q

axes(handles.axes1)
for q=1:num
%N1=vertcat(load(listing(q).name))
hold on
plot(M(q).sl.ans(:,1)/1e3,-M(q).sl.ans(:,2),'-')

N1=vertcat(M(q).sl.ans); %sea level
end 

N2=sortrows(N1,1);
%remove equal
D=diff(N2(:,1));
[k2,col2] = find(~D);
N2(k2,:)=[];
handles.N2=N2;

plot(N2(:,1)/1e3,-smooth(N2(:,2),10),'-k','LineWidth',3)
plot((N2(:,1)/1e3)+handles.tuncert,-smooth(N2(:,2)+handles.uncert,10),'--k','LineWidth',1)
plot((N2(:,1)/1e3)-handles.tuncert,-smooth(N2(:,2)-handles.uncert,10),'--k','LineWidth',1)

xlim([handles.mint handles.maxt])
xlabel('Time (ka)')
ylabel('Sea level (m)')
cd(handles.maindir)

set(handles.edit6,'visible','off');  
set(handles.edit7,'visible','off');  
set(handles.edit8,'visible','off');  
set(handles.text6,'visible','off');  
set(handles.text7,'visible','off');  
set(handles.text8,'visible','off');  
set(handles.r2,'Visible','Off')
set(handles.levo,'Visible','Off')
set(handles.axes4,'Visible','Off')
set(handles.textinfo,'String','Information: Select a shapefile (.shp) with the shoreline angles (this is the output of the mapping tool after exporting to .shp). Then select the range to display the sea level curves and the uncertainties of the sea-level curve','FontSize',10);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes TerraceM_upliftdet wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = TerraceM_upliftdet_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1
handles.output = hObject;
contents = cellstr(get(hObject,'String')); 
handles.levsel= str2num(contents{get(hObject,'Value')});
set(handles.textinfo,'String','Information: Slect a terrace level and correlate with sea-level position (usually highstands). Mark the position interactively in the plot. Diferent colors denotes different authors, the black line is a movil mean of with a lowpass of 10 ka.');

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output = hObject;

M=handles.M;
N2=handles.N2;

%plot in axes
axes(handles.axes1)
cla
num=handles.num;
for q=1:num
%N1=vertcat(load(listing(q).name))
hold on
plot(M(q).sl.ans(:,1)/1e3,-M(q).sl.ans(:,2),'-')

end 

%remove equal
D=diff(N2(:,1));
[k2,col2] = find(~D);
N2(k2,:)=[];

handles.N2=N2;

plot(N2(:,1)/1e3,-smooth(N2(:,2),10),'-k','LineWidth',3)
plot((N2(:,1)/1e3)+handles.tuncert,-smooth(N2(:,2)+handles.uncert,10),'--k','LineWidth',1)
plot((N2(:,1)/1e3)-handles.tuncert,-smooth(N2(:,2)-handles.uncert,10),'--k','LineWidth',1)


xlim([handles.mint handles.maxt])

guidata(hObject, handles);


function uncert_Callback(hObject, eventdata, handles)
% hObject    handle to uncert (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of uncert as text
%        str2double(get(hObject,'String')) returns contents of uncert as a double
handles.output = hObject;

handles.uncert=str2double(get(hObject,'String'));

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function uncert_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uncert (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function tuncert_Callback(hObject, eventdata, handles)
% hObject    handle to tuncert (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of tuncert as text
%        str2double(get(hObject,'String')) returns contents of tuncert as a double
handles.output = hObject;

handles.tuncert=str2double(get(hObject,'String'));

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function tuncert_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tuncert (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function mint_Callback(hObject, eventdata, handles)
% hObject    handle to mint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mint as text
%        str2double(get(hObject,'String')) returns contents of mint as a double

handles.output = hObject;

handles.mint=str2double(get(hObject,'String'));

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function mint_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function maxt_Callback(hObject, eventdata, handles)
% hObject    handle to maxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxt as text
%        str2double(get(hObject,'String')) returns contents of maxt as a double

handles.output = hObject;

handles.maxt=str2double(get(hObject,'String'));

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function maxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to maxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output = hObject;

Sh=handles.shorelines;
level=handles.levsel;
sl_error=handles.uncert;
t_error=handles.tuncert;

lev_el=unique(Sh(:,5)); 
lev_rows=numel(lev_el);


%input
[x,y]=ginput(1);

axes(handles.axes1)
hold on
errorbar(x,y,sl_error,'ok');
errorbar(x,y,t_error,'ok','horizontal');
plot(x,y,'ok','MarkerFaceColor','r','Markersize',10);

if isfield(handles,'seaposition')==1
Matrix=handles.seaposition;
    
Matrix(level).age=x;%age
Matrix(level).sl=y;%sealevel
Matrix(level).terr=t_error;%age error
Matrix(level).slerr=sl_error;%age error

else
Matrix(level).age=x;%age
Matrix(level).sl=y;%sealevel
Matrix(level).terr=t_error;%age error
Matrix(level).slerr=sl_error;%age error    
end

%INFORMATION=('Wait, processing topography');
INFORMATION=(sprintf('Information: Level:%u;  Age:%.2f +- %.2f ka;  Sea level:%.2f +- %.2f m',level,x,t_error,y,sl_error));
set(handles.textinfo,'String',INFORMATION,'FontSize',10);

%handles
handles.seaposition=Matrix;

guidata(hObject, handles);

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output = hObject;
Matrix=handles.seaposition;
Sh=handles.shorelines;
lev_el=unique(Sh(:,5));
handles.lev_el=lev_el;
tackle=handles.tackle;

P=1;
%Uplift rates
for ll=1:numel(Matrix)

level=lev_el(ll);
Sel_Sh=Sh(Sh(:,5)==level,:);
x=Matrix(ll).age;
y=Matrix(ll).sl;
slerr=Matrix(ll).slerr;
terr=Matrix(ll).terr;

for i=1:numel(Sel_Sh(:,1))
%uplift rate    
Ur_sh(i,ll)=(Sel_Sh(i,3)-y)/x;

%uplift rate errors
rsl(i,1)=Sel_Sh(i,3)-y; %rsl
rsl_e(i,1)=Sel_Sh(i,4)+slerr;%z err + sl err
rsl_new=horzcat(rsl,rsl_e); %creatematrix
t_ee1=horzcat(x,terr);
time_new=repmat(t_ee1,numel(Sel_Sh(:,1)),1);
Urate_errate(P,1:2)=mdiv(rsl_new(i,:),time_new(i,:)); %uplift rate and associated division error propagation
%uplift rate errors
Ur_err(i,ll)=sqrt(Urate_errate(P,1).^2.*((rsl_e(i,1).^2/rsl(i,1).^2)+(terr.^2./x.^2)));

%sinchronous model
Zmodel(P,1)=(Ur_sh(i,ll)*x)+y;
Zobs(P,1)=Sel_Sh(i,3);

%indexing
SH_X(i,ll)=Sel_Sh(i,1);
SH_Y(i,ll)=Sel_Sh(i,2);
SH_Z(i,ll)=Sel_Sh(i,3);
SH_Ze(i,ll)=Sel_Sh(i,4);
SH_L(i,ll)=level;
SH_prof(i,ll)=Sel_Sh(i,6);
SH_distance(i,ll)=Sel_Sh(i,7);

SH_time(i,ll)=x;
SH_sl(i,ll)=y;

P=P+1;
end

end

%vertical concatenate

SS=size(SH_X);

shx=reshape(SH_X,[(SS(1)*SS(2)),1]);
shy=reshape(SH_Y,[(SS(1)*SS(2)),1]);
shz=reshape(SH_Z,[(SS(1)*SS(2)),1]);
shze=reshape(SH_Ze,[(SS(1)*SS(2)),1]);
shlev=reshape(SH_L,[(SS(1)*SS(2)),1]);
shprof=reshape(SH_prof,[(SS(1)*SS(2)),1]);
shdist=reshape(SH_distance,[(SS(1)*SS(2)),1]);
shur=reshape(Ur_sh,[(SS(1)*SS(2)),1]);
shure=reshape(Ur_err,[(SS(1)*SS(2)),1]);

shtime=reshape(SH_time,[(SS(1)*SS(2)),1]);
shsl=reshape(SH_sl,[(SS(1)*SS(2)),1]);

outsync=[shz,shze,shtime,shsl,shlev];
outsync(outsync(:,1) == 0,:) = [];


outfin=[shx,shy,shprof,shlev,shdist,shz,shze,shur,shure];
outfin(outfin(:,1) == 0,:) = [];
handles.outputfin=outfin;


axes(handles.axes3)

if handles.corr==0
cla

%boxplots
Ur_sh(Ur_sh == 0) = NaN;
boxplot(Ur_sh)
xlabel('Terrace level');
ylabel('Uplift rate (m/ka)');

%to fill the synchrouns edit text ranges for uplift
handles.urmin=round(min(shur),2);
handles.urmax=round(max(shur),2);
shur(shur==0)=[];
handles.dur=round((handles.urmax-handles.urmin)/numel(shur),2);

set(handles.textinfo,'String','Information: Uplift rates are calculated using the eq. U=(E-Sl)/t, where E=elevation, Sl= sea level position and t=time. Boxplots display the range of uplift rate for each terrace level. Use Save shorelines (.shp) to save individual uplift rates estimates','FontSize',11);
end

if handles.corr==1
cla
clear Zm pp ss gg1

handles.boxx=0;

%get ranges
minur=str2double(get(handles.edit6,'String'));
intur=str2double(get(handles.edit7,'String'));
maxur=str2double(get(handles.edit8,'String'));   

%tackle=0;
lv=unique(outsync(:,5));

Ur_mtr=minur:intur:maxur;
%loop uplift
for i=1:numel(Ur_mtr)
    clear Zmodel s p
    
    if tackle==1
        
    for j=1:numel(outsync(:,3)) %using the whole population   
    Zmodel(j,1)=(Ur_mtr(i)*outsync(j,3))+outsync(j,4);   
    end
    
    [p,s]=polyfit(outsync(:,1),Zmodel,1);
    [g1,g2]=polyval(p,outsync(:,1),s);
    %regression fit coef
    R2(i)=(s.normr/norm(Zmodel - mean(Zmodel)))^2; 
    %tan=cat op /cat ady
    Tg(i)=(g1(end)-g1(1))/(outsync(end,1)-outsync(1,1)); 
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    else %sin tackle
        
    for j=1:numel(lv) %grouping by level and using the mean  
    lov=lv(j);    
    edad=outsync(outsync(:,5)==lov,3);
    eda=min(edad);
    mar=min(outsync(outsync(:,5)==lov,4));
    Zmodel(j,1)=(Ur_mtr(i)*eda)+mar; 
    altura(j,1)=mean(outsync(outsync(:,5)==lov,1));
    viejo(j,1)=eda;
    posa(j,1)=mar;
    end
        
    [p,s]=polyfit(altura,Zmodel,1);
    [g1,g2]=polyval(p,altura,s);
    %regression fit coef
    R2(i)=(s.normr/norm(Zmodel - mean(Zmodel)))^2; 
    %tan=cat op /cat ady
    Tg(i)=(g1(end)-g1(1))/(altura(end)-altura(1));         
    end
    
   
end

%[M,in]=max(R2);
n=1; %45 degree or 1:1 relationship --> different than approach of Roberts et al., 2013 that uses only the R2

RR2=handles.RR2;

if RR2==0 %checkbutton R^2
dist= abs(Tg - n);
minDist = min(dist);
in=find(dist == minDist);
else
%dist= abs(Tg - n);
dist=R2;
[minDist] = min(dist);
in=find(dist == minDist);  
end

M=R2(in);

%Plot
if tackle==1
Zm=(Ur_mtr(in)*outsync(:,3))+outsync(:,4);
[pp,ss]=polyfit(outsync(:,1),Zm,1);
[gg1,gg2]=polyval(pp,outsync(:,1),ss);

hold on
scatter(outsync(:,1),Zm)
plot(outsync(:,1),gg1,'-r')



else
Zm=(Ur_mtr(in)*viejo)+posa;
[pp,ss]=polyfit(altura,Zm,1);
[gg1,gg2]=polyval(pp,altura,ss); 

hold on
scatter(altura,Zm)
plot(altura,gg1,'-r')

ax = gca; % current axes
D=ax.XLim;
ax.YLim = D;
    
end

dx= (max(outsync(:,1))-min(outsync(:,1)))/10;
dy= (max(Zm)-min(Zm))/8;
xlim([min(outsync(:,1))-dx max(outsync(:,1))+dx])  
ylim([min(Zm)-dy max(Zm)+dy])  

xlabel('Measured elevation (m)');
ylabel('Modeled elevation (m)');
set(gca, 'xticklabelmode', 'auto', 'xtickmode', 'auto');
set(gca, 'yticklabelmode', 'auto', 'ytickmode', 'auto');

if M>= 0.85
Tcell=('Information: High R^2 suggest that is possible to provide a mean uplift rate probably constant through time and space');
    
else
Tcell=('Information: Low R^2 suggest that is not possible to provide a mean uplift rate due to possible variable uplift rates in time or space');
end

set(handles.textinfo,'String',Tcell);

xL = get(gca,'XLim'); yL = get(gca,'YLim');
dxL=xL(2)-xL(1); dyL=yL(2)-yL(1);

text(xL(2)-dxL/6,yL(1)+dyL/6,sprintf(' ${R}^2$=%.2f \n Ur=%.2f m/ka',M,Ur_mtr(in)),'FontSize',14,'Interpreter', 'latex');


axes(handles.axes4)
cla(handles.axes4,'reset')

if RR2==1 %checkbutton R^2

hold on, box on
plot(Ur_mtr,R2,'-b')
vline(Ur_mtr(in),'-r')
xlabel('Uplift rate (m/ka)')
ylabel('R^2')
else
hold on, box on   
plot(Ur_mtr,dist,'-b')
vline(Ur_mtr(in),'-r')
xlabel('Uplift rate (m/ka)')
ylabel('H/V relation')    
    
end


end

% inclined lines typical Ur plot as alternatives
guidata(hObject, handles);


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output = hObject;

Matrix=handles.seaposition;
level=handles.levsel;

Matrix(level).age=nan;%age
Matrix(level).sl=nan;%sealevel
Matrix(level).terr=nan;%age error
Matrix(level).slerr=nan;%age error 




axes(handles.axes1)

delete(findobj(gca, 'Marker','o'));

hold on
for i=1:numel(Matrix)
hold on
   errorbar(Matrix(i).age,Matrix(i).sl,Matrix(i).slerr,'ok')
   errorbar(Matrix(i).age,Matrix(i).sl,Matrix(i).terr,'horizontal');
   plot(Matrix(i).age,Matrix(i).sl,'ok','MarkerFaceColor','r','Markersize',10)
end


handles.seaposition=Matrix;

guidata(hObject, handles);

% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output = hObject;
here=pwd;

[dir1,PathName] = uigetfile({'*.shp;*.mat'},'Select the shorelines mat or shp');
handles.shfile=char(dir1);

[filepath,name,ext] = fileparts(handles.shfile);
handles.shpathname=char(PathName);

cd(PathName)

if strcmp(ext,'.shp')==1
SH=shaperead(sprintf('%s',handles.shfile));


sn=numel(SH);
handles.station=SH(1).station;
    for i=1:sn
 
    SHo(i,1)=SH(i).X;
    SHo(i,2)=SH(i).Y;
    SHo(i,3)=SH(i).Z;
    SHo(i,4)=SH(i).Ze;
    SHo(i,5)=SH(i).level;
    SHo(i,6)=SH(i).profile;
    SHo(i,7)=SH(i).distance;
    end

else
    
load(handles.shfile);   
k=1;
for prof=1:numel(SHORELINE)    
    for level=1:numel(SHORELINE(prof).level)
        shore(k,:)=SHORELINE(prof).level(level);
        k=k+1;
    end
end

handles.station=shore(1).STATION;
SHo(:,1)=extractfield(shore,'UTM_X');
SHo(:,2)=extractfield(shore,'UTM_Y');
SHo(:,3)=extractfield(shore,'ELEVATION');
SHo(:,4)=extractfield(shore,'ERROR');
SHo(:,5)=extractfield(shore,'LEVEL');
SHo(:,6)=extractfield(shore,'PROFILE');
SHo(:,7)=extractfield(shore,'DISTANCE_PROFILE');

end


cd(here)

handles.shorelines=SHo;

%display in popup
sh_lev=num2cell(unique(handles.shorelines(:,5))); %transform number to cell
set(handles.listbox1,'String',sh_lev)


guidata(hObject, handles);


% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output = hObject;
station=handles.station;
dirstation=handles.statpath;
shore=handles.outputfin;

here=pwd;
cd(dirstation)

%craete folders
Outdir=sprintf('%s_EXPORT',handles.station);
if exist(Outdir,'dir')==7
else
mkdir(Outdir);
end
cd(Outdir)

%export to shapefile
[Tracks(1:length(shore)).Geometry] = deal('Point');
for i = 1:length(shore(:,1))
    [Tracks(i).station]= handles.station;
    [Tracks(i).profile]= shore(i,3);
    [Tracks(i).level]= shore(i,4);
    [Tracks(i).X]= shore(i,1);
    [Tracks(i).Y]= shore(i,2);
    [Tracks(i).distance]= shore(i,5);
    [Tracks(i).Z]= shore(i,6);
    [Tracks(i).Ze]= shore(i,7);    
    [Tracks(i).Ur]= shore(i,8);
    [Tracks(i).Ure]= shore(i,9);  
end

%outputs
fout=sprintf('%s_shorelines_upliftrates.shp',station);
%check if no data is in table and remove
for j=1:numel(Tracks)
   code(j)=isempty(Tracks(j).profile);
end
code_n=find(code==1);
Tracks(code_n)=[];

shapewrite(Tracks, fout);

cd(here)

set(handles.textinfo,'String','Information: Shoreline angles and estimated uplift rates have been exported as shapefile (.shp) in the export folder inside the station directory','FontSize',10);

guidata(hObject, handles);

% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output = hObject;
station=handles.station;
dirstation=handles.statpath;
Matrix=handles.seaposition;
lev=handles.lev_el;

for i=1:numel(Matrix)
Mtr(i).Level=lev(i);
Mtr(i).Age=Matrix(i).age;
Mtr(i).Age_error=Matrix(i).terr;
Mtr(i).Sealevel=Matrix(i).sl;
Mtr(i).Sealevel_error=Matrix(i).slerr;

end

T = struct2table(Mtr);

here=pwd;
cd(dirstation)

%craete folders
Outdir=sprintf('%s_EXPORT',handles.station);
if exist(Outdir,'dir')==7
else
mkdir(Outdir);
end
cd(Outdir)

%export to table file
writetable(T,sprintf('%s_table_correlations.xls',station))

cd(here)
set(handles.textinfo,'String','Information: The sea-level/age correlations have been exported as an excell table (.xls) and stored in the export folder inside the station directory','FontSize',10);

guidata(hObject, handles);
% --- Executes on button press in boxx.
function boxx_Callback(hObject, eventdata, handles)
% hObject    handle to boxx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of boxx




% --- Executes when selected object is changed in uibuttongroup1.
function uibuttongroup1_SelectionChangedFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uibuttongroup1 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output = hObject;
newButton=get(eventdata.NewValue,'tag');
switch newButton
    
case 'boxx'  
    handles.boxx=1;
    handles.corr=0;
    
set(handles.edit6,'visible','off');  
set(handles.edit7,'visible','off');  
set(handles.edit8,'visible','off');  
set(handles.text6,'visible','off');  
set(handles.text7,'visible','off');  
set(handles.text8,'visible','off');  
set(handles.axes4,'visible','off');  
set(handles.r2,'Visible','Off')
set(handles.levo,'Visible','Off')
set(handles.textinfo,'String','Information: Uplift rates are calculated using the eq. U=(E-Sl)/t, where E=elevation, Sl= sea level position and t=time. ','FontSize',11);

    
case 'corr' 
    axes(handles.axes3)
    cla
    handles.boxx=0;
    handles.corr=1;

set(handles.r2,'visible','on');  
set(handles.levo,'visible','on');  
set(handles.edit6,'visible','on');  
set(handles.edit7,'visible','on');  
set(handles.edit8,'visible','on');  
set(handles.text6,'visible','on');  
set(handles.text7,'visible','on');  
set(handles.text8,'visible','on'); 
set(handles.axes4,'visible','on');  
set(handles.textinfo,'String','Information: Uplift rates estimated using the Synchronous Correlation method that uses the whole sequence of terrace levels to estimate a mean uplift rate, this assume constant uplift rate thorugh time (see Roberts et al. 2013). To fit modeled and measured elevation can be used the m (1/1 relation, Default) or the R^2 of the regression','FontSize',10);


try
set(handles.edit6,'String',handles.urmin);
set(handles.edit7,'String',handles.dur);
set(handles.edit8,'String',handles.urmax);    
catch
set(handles.edit6,'String',0);
set(handles.edit7,'String',0);
set(handles.edit8,'String',0);   
end


end

guidata(hObject, handles);


% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = guidata(hObject);
station=handles.station;
lm=gca;

f=figure;

df=subplot(2,1,1);
box on
fig1 = get(handles.axes1,'children');
copyobj(fig1,df);
xlabel('Time (ka)');
ylabel('Sea level (m)');

xlim([handles.mint handles.maxt])

ef=subplot(2,1,2);
box on
fig2 = get(handles.axes3,'children');
copyobj(fig2,ef);
xlabel('Terrace level');
ylabel('Uplift rate (m/ka)');
set(gca,'xticklabel',num2str(get(gca,'xtick')','%g'))


%check or add new folder PDF
%craete folders
Outdir=sprintf('%s_PDFs',handles.station);
if exist(Outdir,'dir')==7
else
mkdir(Outdir);
end

here=pwd;
cd(Outdir)


rect=[1,2,18,15]; %[xmin ymin width height]
set(gcf,'PaperType','A4');
set(gcf,'PaperUnits','centimeters'); 
set(gcf,'Paperposition',rect);
fout4 = sprintf('%s_Uplift_rates.pdf',station);
saveas(gcf,fout4,'pdf')
close(f)
cd(here)

set(handles.textinfo,'String','Information: Plots have been exported as PDF files and stored in the PDF folder inside the station directory','FontSize',10);

guidata(hObject, handles);



function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double


% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double


% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit8_Callback(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit8 as text
%        str2double(get(hObject,'String')) returns contents of edit8 as a double


% --- Executes during object creation, after setting all properties.
function edit8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in corr.
function corr_Callback(hObject, eventdata, handles)
% hObject    handle to corr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of corr


% --- Executes on button press in r2.
function r2_Callback(hObject, eventdata, handles)
% hObject    handle to r2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of r2
handles = guidata(hObject);
RR2=get(hObject,'Value');
handles.RR2=RR2;
guidata(hObject, handles);


% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in levo.
function levo_Callback(hObject, eventdata, handles)
% hObject    handle to levo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of levo
handles = guidata(hObject);
tack=get(hObject,'Value');
handles.tackle=tack;
guidata(hObject, handles);
