%% Stacks analysis function
%function [stacks]=Terracem_stacks(swat,station,profnum,pto,thetaB,Dprof,peak,varargin)
function [shoreline,points,regr]=Terracem_stacks(swat,peak,fringes)
%==================================================================
% Jara-Munoz (2015)
%Function designed to map shorline angles in rocky coasts, characterized by
%stacks and stumps
%==================================================================
format long

%load swath profile values
x=swat.x; %distance along profile
mi=swat.z_min; %min values%
me=swat.z_mean; %mean values
ma=swat.z_max; %max values
slp=swat.slope; %slope values
% Check if flipped, high part must be at right

%plot swath
 hold on
%plot of topographic curves
hold on
plot(x,ma,'k')
plot(x,me,'color',[0.3 0.3 0.3])
plot(x,mi,'color',[0.6 0.6 0.6])
%hleg1 = legend('Max topography','Mean topography','Min topography','Location','SouthEast');
%xlim([min(x) max(x)]);
box on
grid on
ylabel('Elevation (m)'); 
xlabel('Distance along profile (m)');




da(:,1)=x; %lenght
da(:,2)=ma; %depth
md=swat; 
ny=length(md(:,1)); 

        disp('select area for peak detection (1st upper rigth corner then lower left)');
        
        [quad(1,1),quad(1,2)]=ginputc(1,'color','b'); 
        [quad(2,1),quad(2,2)]=ginputc(1,'color','b');            
    
%Isolate area for peak detection
j=1; k=1;
for i=1:ny
if (da(i,1)>quad(2,1)) && (da(i,1)<quad(1,1)) %reemplazando cliff
    daquad(j,:)=da(i,:);%
    j=j+1;    
    
else
    daquad=da;
end
end
clear i j
% detect peaks
xc=daquad(:,1); 
yc=daquad(:,2);
%Peak det function (Billauer,2009)
[maxtab, mintab] = peakdet(yc, peak, xc); %peak search
%plot maximum peaks detected

hold on
plot(xc,yc,'k');
plot(maxtab(:,1), maxtab(:,2),'.g','MarkerEdgeColor',[1 0 1],'MarkerSize',8);

%Clasify peaks by terrace level 
G=maxtab(:,2);
nim=numel(G);
npts=sqrt(nim);
x1=min(G):((max(G)-min(G))/npts):max(G); %this is the X axis, Rank of values in the X axis (G), the bin rank ins defined in the center, between :: 
y=G;
n_elements = histc(y,x1); %Y axe of cumulative frecuency histogram
c_elements = cumsum(n_elements); %this is for cumulative frecuency plot (not used here)
clear  n_elements c_elements h npts G y x1 nim


disp('mark only the upper bound of each fringe')   
[X,Y]=ginputc(fringes,'color','g'); 
Y=vertcat(Y,zeros(1,1)); %add zeros file (for loop) 
X=vertcat(X,zeros(1,1));



maxi=max(x);
% clasify the matrix maxtab in the fringe ranges 
hold off
nh=length(maxtab(:,1)); 
for i=1:(fringes) 
    
    for h=1:nh    
    if (maxtab(h,2)<Y(i,1)) && (maxtab(h,2)>Y(i+1,1))    
        maxtab(h,3)=i;     
    end
    end
    
    line([0 maxi],[Y(i,:) Y(i,:)], 'Color', [0 1-(i/(fringes)) 0],'LineStyle','--')   
end
clear i h j maxi mintab md scrsz tit daquad def nh numlines prompt ax1 ax2 k nh ny yc xc f da 
% shoreline angle on terrace remains on the cliffs 
   
     
% mark the shoreline point in the screen according with the Fringe
disp ('mark shoreline angles, if not press ENTER')
[XS,YS]=ginputc(fringes,'color','k'); 
            if isempty(YS)==1
            shore=[];
            else
            shore(:,1)=XS;
            shore(:,2)=YS;
            ns=numel(YS); 
            end



if size(shore)==0
    maxtab=maxtab;
else   
% loop to automaticaly identify elevation fringe for each shoreline angle
%maximum number is 3 fringes
    for h=1:ns %1:number of shoreline angles selcted could be different that number of fringes in some cases    
        for i=1:fringes %number of fringes   
         if (shore(h,2)<Y(i,1)) && (shore(h,2)>Y(i+1,1))    
        shore(h,3)=i;                
        % Condition: if two shorelines angles have the same fringe range
        % move the minor one to next fringe
        %new condition to check for repeated fringe values in shorelines   
        numb=sum(shore(:,3)==i);             
         if numb==1 || numb==0            
          %shore(h,3)=i; 
          intplat(i).shore=shore(h,:);            
         else   % Move repeated to lower level fringe    
            sortshore=sort(shore,2,'descend');            
            %is not possible to use arbitrary asinged fringes
            %so, we detect repeated fringes to evaluate the next alternatives            
            tabl=tabulate(sortshore(:,3));
            c=max(tabl); %statistics of sortshore
            rept=c(:,1); %identified repeated value              
            %Alternative1 if repeated is 2 use this  (working good)
               if rept==2                   
            intplat(i).shore=sortshore(1,:);
            intplat(i).shore=sortshore(2,:);
            j=i+1;   
            intplat(j).shore=sortshore(3,:);
            intplat(j).shore(:,3)=j;       
               end                 
            %Alternative2 if repeated is 1 use this (working good)
               if rept==1         
            intplat(i).shore=sortshore(1,:);
            k2=i+1;    
            intplat(k2).shore=sortshore(2,:);
            intplat(k2).shore(:,3)=k2;                                      
               end          
         end   
         end  
        end 
    end   
clear i h 
hold on
plot(shore(:,1),shore(:,2),'.k','MarkerSize',10);
% create outputs table
% add shoreline angle data to peaks point matrix
maxtab=vertcat(intplat(1,:).shore,maxtab);
end
% clasify and dismember maxtab on each elevation fringe
for i = 1:fringes
plat(i).level = maxtab(maxtab(:,3) == i,:);
end
clear i sortshore rept c tabl numb shore ns 
% separated vectors and fit stacks in profile
% plot and function interplations

hold on  
for i=1:fringes
   xpeak(:,1)=plat(1,i).level(:,1);
   ypeak(:,1)=plat(1,i).level(:,2);   
   % stack 
   [psurf,ssurf]=polyfit(xpeak,ypeak,1);
   dxm=1; %mean(diff(xpeak));%prepare to extend fit
   xxx=min(xpeak):dxm:max(x);
   xxx=xxx'; %range added to extend fit line   
   [p_surf,d_surf]=polyval(psurf,xxx,ssurf);
% save fiting and other data to table structure
   intplat(i).slope=psurf; 
   intplat(i).p_surf=p_surf;
   intplat(i).d_surf=d_surf;
   intplat(i).xpeak=xpeak(:,1); %x value for peaks
   intplat(i).ypeak=ypeak(:,1); %y value for peaks
   intplat(i).xxx=xxx; %x values for interpolation      
%extract fit-maxtopo intersection
m_rect=intplat(i).slope(1,1); %slope of interpolation rect (tand of rect angle)
%c value
c_rect=intplat(i).slope(1,2); %second coeficient of the rect ecuation 'c'
% check this part because replace x and ma por swat values
swati(:,1)=x;
swati(:,2)=ma;
for j=1:(numel(swati(:,1)));
if fix(m_rect*(swati(j,1))+(c_rect)) == nearest(swati(j,2)); %aproximation to topography    
    shore_int(:,1)=swati(j,1);
    shore_int(:,2)=swati(j,2);   
end
end 
   %take error from interpolation and store in the third row
   %take number of shorelines from the number of fringes in loop
   shore_int(:,3)=min(intplat(i).d_surf); %erro in Y
   shore_int(:,4)=i; %shorenum   
   %store level of each shoreline angle in the fourth row  
   %create structure table
   intplat(i).shore_int=shore_int; %projected shoreline point 
   %FIGURE FINAL  
   
   cla
   hold on
   box on; 
   plot(x,ma,'-k'), 
   plot(x,me,'Color', [0.5 0.5 0.5]), 
   plot(x,mi,'Color', [0.7 0.7 0.7]), 
   %xlim([min(x) max(x)]); 
   %ylim([0 max(ma)])
   
   ylabel('Elevation (m)'); xlabel('Distance along profile (m)');
   plot(intplat(i).xxx,intplat(i).p_surf,'Color', [0+(i/(fringes)) 1-(i/(fringes)) 0],'LineStyle','--')
   plot(intplat(i).xpeak,intplat(i).ypeak,'.','Color', [0+(i/(fringes)) 1-(i/(fringes)) 0],'MarkerSize',20)
   errorbar(intplat(i).shore_int(:,1),intplat(i).shore_int(:,2),intplat(i).shore_int(:,3),'dk','markerfacecolor','k')   
   %clear xpeak ypeak xxx dxm p_surf d_surf psurf ssurf shore_int  
   
   str1=num2str(intplat(i).shore_int(:,2),3);
   str2=num2str(intplat(i).shore_int(:,3),3);
   
   xL = get(gca,'XLim'); yL = get(gca,'YLim');
   dxL=xL(2)-xL(1); dyL=yL(2)-yL(1);
    
   text(intplat(i).shore_int(:,1)-dxL/7,intplat(i).shore_int(:,2)-(intplat(i).shore_int(:,2)-yL(1))/2,sprintf('SA: %s +/- %s m',str1,str2),'FontSize',12,'BackgroundColor',[1 1 1]); %Shoreline angle value and location

   
   
    points1(i).pt=vertcat([intplat(i).xpeak,intplat(i).ypeak]);

    %regressions
    %regr.cliff=[xx,p_clif,p_clif+2*d_clif,p_clif-2*d_clif];
    regr1(i).plat=[intplat(i).xxx,intplat(i).p_surf];
   
    shoreline1(i,:)=[intplat(i).shore_int(:,1) intplat(i).shore_int(:,2) intplat(i).shore_int(:,3)];
end  
   %INSET
   G=maxtab(:,2);  
   nim=numel(G);
   npts=sqrt(nim);
   x1=min(G):((max(G)-min(G))/npts):max(G); %this is the X axis, Rank of values in the X axis (G), the bin rank ins defined in the center, between :: 
   y=G;
   n_elements = histc(y,x1); %Y axe of cumulative frecuency histogram
   c_elements = cumsum(n_elements);
    

% outputs
sh=shoreline1(:,1:2);
point2utm=Terracem_point2utm(swat,sh);

Rx=point2utm(:,1); %UTM E
Ry=point2utm(:,2); %UTM N

shoreline=[Rx Ry shoreline1] %number of shoreline,E, N, distance along profile,z ze

if nargout > 1
points=points1;
%regressions
regr=regr1;
end



